//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#include <time.h>
#include <dos.h>
#include <stdlib.h>
#include <math.h>
#include <fcntl.h>
#include <io.h>
#include <sys\stat.h>
#include <shellapi.h>  // ShellExecute()
#include <wincrypt.h>
#pragma hdrstop

#include "gbw1.h"
#include "../common/table.h"
// etH[̃wb_t@CB
#include "unitlist.h"
#include "seisan.h"
#include "status.h"
#include "option.h"
#include "ksreport.h"
#include "kscheckattack.h"
#include "ksevent.h"

#include "ksfunc.h"
#include "ksscript.h"
#include "ksdrawhdc.h"

#define VERSION "2.29"

#define DEMAND_NONE     0 //^C}[CxgŎsR}h
#define DEMAND_OPEN     1
#define DEMAND_SAVE     2
#define DEMAND_LOAD     3
#define DEMAND_REMOTE   4
#define DEMAND_LOADMAIL 5

//EO̕`搧A(x,y)ʒuEOǂ𒲂ׂ鎮
#define OutsideVisible(x,y) (ApplyShade && Map->GetShade(x, y))

#define DEBUG_SHADE (Debug_Shade && Situation->Phase)

//HHOOK TForm1::hHook;
//bool TForm1::RButtonDowned;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cgauges"
#pragma resource "*.dfm"
TForm1 *Form1;

TForm_seisan *Form_seisanp;
TForm_Status *Form_Statusp;
TForm_UnitList *Form_UnitListp;

//---------------------------------------------------------------------------
void CallProcessMessages(void)
{
    Application->ProcessMessages();
}
//---------------------------------------------------------------------------
static void PrintLog(char *file,char *line)
{
    FILE *fp;

    fp = fopen(file,"a");
    if(!fp)
        return;
    fprintf(fp,"%s\n",line);
    fclose(fp);
}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
    Image_Map->ControlStyle = Image_Map->ControlStyle << csOpaque;
    Image_Viewport->ControlStyle = Image_Viewport->ControlStyle << csOpaque;
    if(!GetCurrentDirectory(sizeof BasePath,BasePath))
        BasePath[0] = '\0';
    DrawedStatusUnit=-1;

    Option.Initialize();
    Option.Load();
    FileHistory_Update();
    ShowStatusBar->Checked = Option.ShowStatusBar;
    StatusBar1->Visible = Option.ShowStatusBar;

    Form_UnitListp=new TForm_UnitList(this);

    Map=NULL;
    RangeLayer = NULL;

    KSImageData=new TKSImageData();
    GBW_LoadSystemGraphic(KSImageData, &Option);

    FieldScreen1 = new FieldScreen();
    FieldScreen1->DefineImageList(KSImageData,0);

    BaseData1=new BaseData();
    BaseData1->SetDefault();

    Situation=new GameSituation();
    MailPlayerList = new TMailPlayerList(BasePath,&Option.MailUser);
    Form_Mail = new TForm_Mail(this);
    Form_Mail->MailPlayerList = MailPlayerList;

    Form_Statusp=new TForm_Status(this);
    Form_Statusp->SetGameMaster(this);

    Form_seisanp=new TForm_seisan(this);
    Form_seisanp->SetPointer(FieldScreen1, BaseData1);

//    Form_MapProperty = new TForm_MapProperty(this);

    ApplyShade = false;
    Debug_Shade = false;
    Debug_Check = false;
    // [֌W͂΂炭󂷂B
    Enabled_NewRemote(false);
    Enabled_LoadMail(false);
    // ǂݍłȂ͎gȂ悤ɂB
    Enabled_Option(false);

    KSDrawHDC_Init();

    Show();
    NowRunning=true;
}
//---------------------------------------------------------------------------
__fastcall TForm1::~TForm1(void)
{
//    UnhookWindowsHookEx(hHook);
    Script_Free();
    KSDrawHDC_End();

    delete Form_seisanp;
    delete Form_Statusp;
    delete Form_UnitListp;
    if(Map != NULL)
        delete Map;
    delete KSImageData;
    delete FieldScreen1;
    delete BaseData1;
    if(RangeLayer != NULL)
        delete RangeLayer;
    int sides = SideStatus1.size();
    for(int i=0;i<sides;i++){
        if(SideStatus1[i].LuaState_Com != NULL){
            KSLua_FreeLua(SideStatus1[i].LuaState_Com);
        }
    }
    if(System.LuaState_Event != NULL){
        KSLua_FreeLua(System.LuaState_Event);
    }
    delete Situation;
    delete MailPlayerList;
    delete Form_Mail;
    NowRunning=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnForm1Show(TObject *Sender)
{
    Option.GetWindowState(&Option.WindowState_ks, this);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnForm1Close(TObject *Sender, TCloseAction &Action)
{
    if(Option.NeedConfirmation && System.NeedConfirmation){
        int r = MessageDlg("Z[uĂ܂񂪁Â܂܏I܂H", mtConfirmation,TMsgDlgButtons() << mbYes << mbNo, 0);
        if(r != mrYes){
            Action=caNone;
            return;
        }
    }
    Option.SetWindowState(&Option.WindowState_ks, this);
    Option.Save();
    System.NowDemand=DEMAND_NONE;
    System.StopDemand=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnForm1CanResize(TObject *Sender, int &NewWidth,
      int &NewHeight, bool &Resize)
{
    Image_Map->Width = NewWidth - Panel1->Width - 8;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnForm1ConstrainedResize(TObject *Sender,
      int &MinWidth, int &MinHeight, int &MaxWidth, int &MaxHeight)
{
    MinWidth = Panel1->Width + 32;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnForm1Resize(TObject *Sender)
{
    Graphics::TBitmap *bitmap = Image_Map->Picture->Bitmap;
    bitmap->Width  = Image_Map->Width;
    bitmap->Height = Image_Map->Height;
    bitmap->Canvas->Brush->Color = clBlack;
    bitmap->Canvas->FillRect(TRect(0, 0, bitmap->Width, bitmap->Height));
    if(NowRunning && Map != NULL){
        MapSizeSet();
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnForm1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    const TSize& insize = FieldScreen1->GetViewportInnerSize();

    switch(Key){
    case VK_LEFT:
        SlideViewport(-FieldScreen1->GraphDegree, 0);
        break;
    case VK_UP:
        SlideViewport(0, -FieldScreen1->GraphDegree);
        break;
    case VK_RIGHT:
        SlideViewport(FieldScreen1->GraphDegree, 0);
        break;
    case VK_DOWN:
        SlideViewport(0, FieldScreen1->GraphDegree);
        break;
    case VK_PRIOR:  // PageUp
        SlideViewport(0, -insize.cy/2);
        break;
    case VK_NEXT:   // PageDown
        SlideViewport(0, insize.cy/2);
        break;
    case VK_F8:  // f.8
        ShowMessage("BR}hFُ팟o[hɓ܂B");
        Debug_Check = true;
        break;
    case VK_F9: // vf.9
        ShowMessage("BR}hFGfobO[hɓ܂B");
        Debug_Shade = true;
        break;
    case VK_F10: // f.10
        // IɉʑŜXVB
        UpdateShade();
        DrawAllAndUpdateMapView();
        break;
    }
    if(Shift * (TShiftState()<<ssCtrl) != TShiftState()){
        switch(Key){
        case 'E':
        case 'e':
            if(PhaseEnd->Enabled)
                PhaseEndClick(Sender);
            break;
        case 'J':
        case 'j':
            if(Status->Enabled)
                StatusClick(Sender);
            break;
        case 'L':
        case 'l':
            if(MILoad->Enabled)
                MILoadClick(Sender);
            break;
        case 'N':
        case 'n':
            if(MIOpen->Enabled)
                MIOpenClick(Sender);
            break;
        case 'M':
        case 'm':
            if(More->Enabled)
                MoreClick(Sender);
            break;
        case 'S':
        case 's':
            if(MISave->Enabled)
                MISaveClick(Sender);
            break;
        case 'U':
        case 'u':
            if(UnitList->Enabled)
                UnitListClick(Sender);
            break;
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnForm1MouseWheel(TObject *Sender,
      TShiftState Shift, int WheelDelta, TPoint &MousePos, bool &Handled)
{
    if(Map == NULL)
        return;
    if(WheelDelta > 0){
        SlideViewport(0, -FieldScreen1->GraphDegree);
        Handled = true;
    }
    else if(WheelDelta < 0){
        SlideViewport(0, +FieldScreen1->GraphDegree);
        Handled = true;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnImage_MapMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    int zx,zy;

    if(Map == NULL)
        return;
    if(!System.Controlable) //EFCgĂ鎞
        return;
    if(System.CPUControl) //CPU삵ĂŒ
        return;
    if(Timer1->Enabled) //CPUɐ؂ւ̂҂Ă鎞
        return;
    if(Option.ShowRange){
        ClearUnitRange();
        PopupMenu1->AutoPopup=false;
        return;
    }
    System.MouseX = X;
    System.MouseY = Y;

    if(Button == mbLeft && FieldScreen1->NoticeMouseDownToViewport(X, Y)){
        // |bvAbvj[oĂꍇAɑ΂錈葀󂯎B
        // FLZ̏MouseRightDown()ōsB
        if(KSState == STATE_RECIEVEACTION){
            int id = FieldScreen1->GetPopupMenuSelectedID();
            if(id != -1){
                System.UseGun = id;
                MouseLeftDown(0, 0);
                return;
            }
        }
        DrawAllAndUpdateMapView();
        return;
    }

    const TSize& insz = FieldScreen1->GetViewportInnerSize();
    if(X >= insz.cx || Y >= insz.cy){
        return;
    }

    FieldScreen1->XY_PhyToMap(Map,X,Y,&zx,&zy);
    switch(Button){
    case mbLeft:
        MouseLeftDown(zx,zy);
        break;
    case mbRight:
        if(!System.PhaseEndable)
            PopupMenu1->AutoPopup=false;
        else
            if(!PopupMenu1->AutoPopup)
                PopupMenu1->AutoPopup=true;
        MouseRightDown(zx,zy);
        break;
    }
    if(Button == mbLeft){
        System.LButtonDowned = true;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnImage_MapMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if(Map == NULL)
        return;
    if(Button == mbLeft){
        System.LButtonDowned = false;
        if(FieldScreen1->NoticeMouseUpToViewport()){
            DrawAllAndUpdateMapView();
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnImage_MapMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    if(!SideStatus1.size())
        return;
    //E{^tONAꏊ炢vȂB
    //PopupMenuł͂̃Cxg͋NȂ͂Ȃ͂B
//    RButtonDowned = false;

    if(FieldScreen1->NoticeMouseMoveToViewport(X, Y)){
        DrawAllAndUpdateMapView();
        return;
    }

/*  // ܂gÂ炢Bɑ쒆gȂƘbɂȂȂB
    if(System.PhaseEndable && System.LButtonDowned){
        int dx = System.MouseX - X;
        int dy = System.MouseY - Y;
        if(dx >= 8 || dx <= -8 || dy >= 8 || dy <= -8){
            SlideViewport(dx, dy);
            System.MouseX = X;
            System.MouseY = Y;
        }
    }
*/
    const TSize& insz = FieldScreen1->GetViewportInnerSize();
    if(X >= insz.cx || Y >= insz.cy){
        return;
    }

    int zx,zy;
    FieldScreen1->XY_PhyToMap(Map,X,Y,&zx,&zy);
    AnsiString str;
    str.cat_sprintf("(%d,%d)", zx, zy);
#if 0
    const POINT& p = RangeLayer->GetBack(zx, zy);
    int rp = RangeLayer->GetRangeValue(zx, zy);
    str.cat_sprintf(" Back(%d,%d) %d", p.x, p.y, rp);
#endif
    StatusBar1->SimpleText = str;

    if(System.RadiusCursor > 0){
        EraseAttackRadius();
        TRect r(Map->GetWidth(), Map->GetHeight(), 0, 0);
        FieldScreen1->GetMessageRectNeedUpdateRect(&r);
        FieldScreen1->ClearMessageRectList();
        if(RangeLayer->GetRangeValue(zx, zy)){
            const UnitStatus& unit = SideStatus1[Situation->Phase].Unit[System.HoldUnit];
            const UnitChip& unitInfo = BaseData1->GetUnitChipByID(unit.ID);
            if(unitInfo.SuperMissile){
                DrawAttackRadius(System.TargetX, System.TargetY, System.RadiusCursor);
            }else{
                DrawAttackRadius(zx, zy, System.RadiusCursor);
            }
            // _[W\̕\B
            if(Option.ShowAttackGuidance){
                int gunFlagA = RangeLayer->GetRangeValue(zx, zy);
                const MapStatus& gnd = Map->GetMapStatus(zx, zy);
                if(gnd.Side != -1){
                    const UnitStatus& unitT = SideStatus1[gnd.Side].Unit[gnd.UnitIndex];
                    const UnitChip& unitInfoT = BaseData1->GetUnitChipByID(unitT.ID);
                    UnitStatus unitA = unit;
                    unitA.X = System.TargetX;
                    unitA.Y = System.TargetY;
                    int damageA, damageT, gunTypeA, gunTypeT;
                    CalcBattle(&unitA, &unitT, gunFlagA, &damageA, &damageT, &gunTypeA, &gunTypeT, Option.DamageFix);
                    TMessageRectOnMap msgr;
                    msgr.ZX = zx;
                    msgr.ZY = zy;
                    msgr.Width = 160;
                    msgr.Height = 40;
                    msgr.StringHeight = 18;
                    vector<string>& strs = msgr.MessageString;
                    char str[256];
                    sprintf(str, "gpΊ %s", unitInfo.GunName[gunTypeA]);
                    strs.push_back(string(str));
                    sprintf(str, "_[W %2d", damageT);
                    strs.push_back(string(str));
                    if(gunTypeT != -1){
                        strs.push_back(string(" "));
                        strs.push_back(string(""));
                        sprintf(str, "gpΊ %s", unitInfoT.GunName[gunTypeT]);
                        strs.push_back(string(str));
                        sprintf(str, "_[W %2d", damageA);
                        strs.push_back(string(str));
                        msgr.Height += 72;
                    }
                    FieldScreen1->AddMessageRect(msgr);
                    FieldScreen1->GetMessageRectNeedUpdateRect(&r);
                }
            }
        }
        DrawMapPartial(r);
        UpdateMapViewBlock(r);
    }
    MapChipStatusPut(zx,zy);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Image_ViewportMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    SetViewportLeftTop(X*FieldScreen1->GraphDegree, Y*FieldScreen1->GraphDegree);
    System.LButtonDownedOnViewport = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Image_ViewportMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    if(System.LButtonDownedOnViewport){
        SetViewportLeftTop(X*FieldScreen1->GraphDegree, Y*FieldScreen1->GraphDegree);
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Image_ViewportMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    System.LButtonDownedOnViewport = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OnTimer_InputRepeat(TObject *Sender)
{
    if(FieldScreen1->NoticeTimerToViewport()){
        DrawAllAndUpdateMapView();
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MIOpenClick(TObject *Sender)
{
    if(System.CPUControl)
        if(!System.StopDemand){
            System.StopDemand=true;
            System.NowDemand=DEMAND_OPEN;
            return;
        }
    OpenDialog_LoadMap->InitialDir = Option.Folder_Map;
    if(OpenDialog_LoadMap->Execute()){
        LoadGame(OpenDialog_LoadMap->FileName.c_str(), true, false);
    }
    else{
        if(System.CPUControl)
            Timer1->Enabled=true;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MISaveClick(TObject *Sender)
{
    if(System.CPUControl)
        if(!System.StopDemand){
            System.StopDemand=true;
            System.NowDemand=DEMAND_SAVE;
            return;
        }
    if(!System.PhaseEndable){
        ShowMessage("Z[uł܂BĉB\n");
        return;
    }
    if(SaveNameDialog())
        SaveGame(System.SaveFile);
    if(System.CPUControl)
        Timer1->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MILoadClick(TObject *Sender)
{
    if(System.CPUControl)
        if(!System.StopDemand){
            System.StopDemand=true;
            System.NowDemand=DEMAND_LOAD;
            return;
        }
    if(LoadNameDialog())
        LoadGame(System.SaveFile, false, false);
    else
        if(System.CPUControl)
            Timer1->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MINewRemoteClick(TObject *Sender)
{
    if(System.CPUControl)
        if(!System.StopDemand){
            System.StopDemand=true;
            System.NowDemand=DEMAND_REMOTE;
            return;
        }
    if(OpenDialog_LoadMap->Execute()){
        //LoadMap(OpenDialog_LoadMap->FileName.c_str(), true);
        LoadGame(OpenDialog_LoadMap->FileName.c_str(), true, true);
    }
    else{
        if(System.CPUControl)
            Timer1->Enabled=true;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MILoadMailClick(TObject *Sender)
{
    if(System.CPUControl)
        if(!System.StopDemand){
            System.StopDemand=true;
            System.NowDemand=DEMAND_LOADMAIL;
            return;
        }
    Form_Mail->ShowLoadGame();
    if(Form_Mail->Result)
        LoadGame(Form_Mail->StartFileName, false, true);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MIExitClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------
//󋵕\
void __fastcall TForm1::StatusClick(TObject *Sender)
{
#if 1
    AnsiString str;

    str.sprintf("%3d^[", Situation->Turn);
    Form_Statusp->LabelTurn->Caption = str;

    str.sprintf("jbgF%3d", Situation->UnitMax);
    Form_Statusp->Label_UnitMax->Caption = str;

    Form_Statusp->TabControl_Side->Tabs->Clear();
    for(int side=0;side<BaseData1->Sides;side++){
        Form_Statusp->TabControl_Side->Tabs->Append(BaseData1->SideName[side].c_str());
    }
    Form_Statusp->PutStatus(0);
    Form_Statusp->ShowModal();
#else
    MI_MapPropertyClick(Sender);
#endif
}
//---------------------------------------------------------------------------
//쌟
void __fastcall TForm1::MoreClick(TObject *Sender)
{
    if(NowLookup >= SideStatus1[Situation->Phase].UnitCount)
        NowLookup = 0;
    else
        NowLookup++;
    NowLookup *= NowLookup>0;

    NowLookup = SideStatus1[Situation->Phase].SearchNoActioned(NowLookup);
    if(NowLookup != -1)
        ShowLookup(NowLookup);
    else
        ShowMessage("s\ȃjbg͌܂ł");
}
//---------------------------------------------------------------------------
//tFCYI
void __fastcall TForm1::PhaseEndClick(TObject *Sender)
{
    char path[MAX_PATH],address[256];

    if(!System.PhaseEndable || Option.ShowRange){
        ShowMessage("tFCYIł܂BĉB\n");
        return;
    }
    strcpy(address, SideStatus1[!Situation->Phase].MailAddress);
    if(address[0] != '\0'){
        if(MessageDlg("tFCYIă[𑗐M܂H\nMQ[͒~AVKQ[[hsKv܂B", mtConfirmation,TMsgDlgButtons() << mbYes << mbNo, 0)!=mrYes)
            return;
        //tFCYIāAꎞt@CɃZ[uB
        PhaseEndExec(true);
        MailPlayerList->GetFolderPath("tmp.sav",path);
        SaveGame(path);
        Form_Mail->ShowSendMail(Map->Name.c_str(), address);
        Enabled_GameOperation(false);
    }
    else{
        if(MessageDlg("tFCYI܂B", mtConfirmation,TMsgDlgButtons() << mbYes << mbNo, 0)==mrYes)
            PhaseEndExec(false);
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::VersionClick(TObject *Sender)
{
    char str[100];

    sprintf(str,"ǒn헪@Ver.%s\nŐVo[W\n%s",VERSION,WEBSITE);
    ShowMessage(str);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MI_MapPropertyClick(TObject *Sender)
{
    if(Map == NULL)
        return;
    TForm_MapProperty *Form_MapProperty = new TForm_MapProperty(this);
    bool tekisaku = Map->Tekisaku;

    Form_MapProperty->Left = Left+32;
    Form_MapProperty->Top = Top+32;
    Form_MapProperty->UnitMax = Situation->UnitMax;
    Form_MapProperty->SetDataPointer(BaseData1, FieldScreen1, Map, KSImageData, &Option, SideStatus1, false);
    Form_MapProperty->SetControlProtect(false);
    if(Form_MapProperty->ShowModal() == mrOk){
        Form_MapProperty->GetControlContent();
        Situation->UnitMax = Form_MapProperty->UnitMax;
        if(tekisaku != Map->Tekisaku){
            SetTekisaku(Map->Tekisaku);
            DrawAllAndUpdateMapView();
        }
    }
    delete Form_MapProperty;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MI_OptionClick(TObject *Sender)
{
    TForm_Option *Form_Optionp=new TForm_Option(this);

    Form_Optionp->HideMail();
    Form_Optionp->TrackBar_DamageWaitFix->Position=Option.DamageWaitFix;
    Form_Optionp->TrackBar_LookUpWaitFix->Position=Option.LookUpWaitFix;
    Form_Optionp->TrackBar_CPUWaitFix->Position=Option.CPUWaitFix;
    Form_Optionp->CheckBox_CPUScroll->Checked = Option.CPUScroll;
    Form_Optionp->CheckBox_Sound->Checked     = Option.CPUSound;
    Form_Optionp->CheckBox_CPUNoGrp->Checked  = Option.CPUNoGrp;
    Form_Optionp->CheckBox_UnitListNoModal->Checked = Option.UnitListNoModal;
    Form_Optionp->CheckBox_DamageFix->Checked = Option.DamageFix;
    Form_Optionp->CheckBox_ShowMove->Checked = Option.ShowMove;
    Form_Optionp->CheckBox_ShowAttackGuidance->Checked = Option.ShowAttackGuidance;
    Form_Optionp->CheckBox_NeedConfirmation->Checked = Option.NeedConfirmation;
    Form_Optionp->Edit_Name->Text       = Option.MailUser.Name;
    Form_Optionp->Edit_Mail->Text       = Option.MailUser.Address;
    Form_Optionp->Edit_Reply->Text      = Option.MailUser.ReplyAddress;
    Form_Optionp->Edit_POPServer->Text  = Option.MailUser.POPServer;
    Form_Optionp->Edit_POPUser->Text    = Option.MailUser.POPUser;
    Form_Optionp->Edit_POPPass->Text    = Option.MailUser.POPPass;
    Form_Optionp->Edit_SMTPServer->Text = Option.MailUser.SMTPServer;
    Form_Optionp->Edit_SMTPUser->Text   = Option.MailUser.SMTPUser;
    Form_Optionp->CheckBox_SaveMessage->Checked = Option.MailUser.SaveMessage;
    Form_Optionp->ShowModal();

    if(Form_Optionp->Result){
        Option.DamageWaitFix = Form_Optionp->TrackBar_DamageWaitFix->Position;
        Option.LookUpWaitFix = Form_Optionp->TrackBar_LookUpWaitFix->Position;
        Option.CPUWaitFix    = Form_Optionp->TrackBar_CPUWaitFix->Position;
        Option.CPUScroll = Form_Optionp->CheckBox_CPUScroll->Checked;
        Option.CPUSound  = Form_Optionp->CheckBox_Sound->Checked;
        Option.CPUNoGrp  = Form_Optionp->CheckBox_CPUNoGrp->Checked;
        Option.UnitListNoModal = Form_Optionp->CheckBox_UnitListNoModal->Checked;
        Option.DamageFix = Form_Optionp->CheckBox_DamageFix->Checked;
        Option.ShowMove = Form_Optionp->CheckBox_ShowMove->Checked;
        Option.ShowAttackGuidance = Form_Optionp->CheckBox_ShowAttackGuidance->Checked;
        Option.NeedConfirmation = Form_Optionp->CheckBox_NeedConfirmation->Checked;
        strcpy(Option.MailUser.Name, Form_Optionp->Edit_Name->Text.c_str());
        strcpy(Option.MailUser.Address, Form_Optionp->Edit_Mail->Text.c_str());
        if(Form_Optionp->Edit_Reply->Text.IsEmpty())
            strcpy(Option.MailUser.ReplyAddress, Option.MailUser.Address);
        else
            strcpy(Option.MailUser.ReplyAddress, Form_Optionp->Edit_Reply->Text.c_str());
        strcpy(Option.MailUser.POPServer, Form_Optionp->Edit_POPServer->Text.c_str());
        strcpy(Option.MailUser.POPUser,   Form_Optionp->Edit_POPUser->Text.c_str());
        strcpy(Option.MailUser.POPPass,   Form_Optionp->Edit_POPPass->Text.c_str());
        strcpy(Option.MailUser.SMTPServer, Form_Optionp->Edit_SMTPServer->Text.c_str());
        strcpy(Option.MailUser.SMTPUser,   Form_Optionp->Edit_SMTPUser->Text.c_str());
        Option.MailUser.SaveMessage = Form_Optionp->CheckBox_SaveMessage->Checked;
        Option.Save();
        if(!Option.UnitListNoModal && Form_UnitListp->Visible)
            Form_UnitListp->Close();
    }
    delete Form_Optionp;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MI_CheckAttackClick(TObject *Sender)
{
    TForm_CheckAttack *FormCS = new TForm_CheckAttack(this);

    FormCS->Initialize(FieldScreen1, BaseData1, &Option, Map->UnitDataFile);
    FormCS->ShowModal();
    delete FormCS;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ShowHelpClick(TObject *Sender)
{
    // wvHTMLt@CJB
    char file[MAX_PATH];
    sprintf(file,"%s\\%s", Option.BasePath, FILE_HELPINDEX);
    ShellExecute(Handle, NULL, file, NULL, NULL, SW_SHOWNORMAL);
    // ߂l̓CX^XnhB
    // (HINSTANCE)32 ȉƃG[B
}
//---------------------------------------------------------------------------
void __fastcall TForm1::GraphNormalClick(TObject *Sender)
{
    if(!System.PhaseEndable){
        ShowMessage("쒆͐؂ւł܂B\n");
        SpeedButton_GraphNormal->Down=GraphNormal->Checked;
        SpeedButton_GraphSmall->Down=GraphSmall->Checked;
        return;
    }
    FieldScreen1->DefineImageList(KSImageData, 0);
    MapSizeSet();
    GraphNormal->Checked=true;
    GraphSmall->Checked=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::GraphSmallClick(TObject *Sender)
{
    if(!System.PhaseEndable){
        ShowMessage("쒆͐؂ւł܂B\n");
        SpeedButton_GraphNormal->Down=GraphNormal->Checked;
        SpeedButton_GraphSmall->Down=GraphSmall->Checked;
        return;
    }
    FieldScreen1->DefineImageList(KSImageData, 1);
    MapSizeSet();
    GraphNormal->Checked=false;
    GraphSmall->Checked=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MenuGraphNormalClick(TObject *Sender)
{
    SpeedButton_GraphNormal->Click();
    SpeedButton_GraphNormal->Down=GraphNormal->Checked;
    SpeedButton_GraphSmall->Down=GraphSmall->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MenuGraphSmallClick(TObject *Sender)
{
    SpeedButton_GraphSmall->Click();
    SpeedButton_GraphNormal->Down=GraphNormal->Checked;
    SpeedButton_GraphSmall->Down=GraphSmall->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ShowStatusBarClick(TObject *Sender)
{
    ShowStatusBar->Checked = !ShowStatusBar->Checked;
    Option.ShowStatusBar = ShowStatusBar->Checked;
    Option.Save();
    StatusBar1->Visible = Option.ShowStatusBar;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Image_LoadingMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    int num=-1;

    if(System.HoldUnit != -1)
        num = System.HoldUnit;
    if(num==-1){
        //ShowMessage("ړĨjbg𑀍쒆ɉĉB");
        return;
    }
    UnitStatus& unit = SideStatus1[Situation->Phase].Unit[num];
    int y = Y-16;
    if(System.SelectedLoading == -1){
        int i = y/36;
        if(i >= unit.Load)
            return;
        System.SelectedLoading = i;
    }
    else{
        int i = y/36;
        if(i >= unit.Load)
            return;
        int j = System.SelectedLoading;
        int index = unit.LoadingUnit[j];
        unit.LoadingUnit[j] = unit.LoadingUnit[i];
        unit.LoadingUnit[i] = index;
        System.SelectedLoading = -1;
    }
    DrawLoadingStatus(Situation->Phase, num);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Panel1MouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
    int n=-1;

    if(System.CPUControl) //CPU삵ĂŒ
        return;
    if(System.HoldUnit!=-1)
        n=System.HoldUnit;
    if(n==-1 || n==DrawedStatusUnit)
        return;
    UnitStatusPut(Situation->Phase,n);
    DrawedStatusUnit=n;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::UnitListClick(TObject *Sender)
{
    Form_UnitListp->SetGameMaster(this);
    Form_UnitListp->Side=Situation->Phase;
    Form_UnitListp->MakeList();
    Form_UnitListp->NoModal=Option.UnitListNoModal;
    if(Option.UnitListNoModal)
        Form_UnitListp->Show();
    else
        Form_UnitListp->ShowModal();
    if(!Option.UnitListNoModal && Form_UnitListp->Result)
        ShowLookup(Form_UnitListp->UnitIndex);
}
//---------------------------------------------------------------------------
//botJn
void __fastcall TForm1::OnTimer1(TObject *Sender)
{
    if(!Timer1->Enabled)
        return; //^C}[Cxg܂Ă܂HÔ߁B
    if(Application->Active && !Form1->Active)
        return; //̃tH[ɃtH[JXΑ҂
    Timer1->Enabled=false;
    ComputerControl();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::KillUnitClick(TObject *Sender)
{
    int zx,zy;

    UnitXY(Situation->Phase,Option.SelectedUnit,&zx,&zy);
//    FieldScreen1->DrawCursorZ(zx,zy,CURSOR_LOOKUP);
    FieldScreen1->AddSpriteZ(zx, zy, TSpriteOnMap::stCursor, CURSOR_LOOKUP);
    DrawMapPartial(zx, zy, zx, zy);
    UpdateMapViewBlock(zx, zy);
    if(MessageDlg("w肳ꂽjbg܂B", mtConfirmation,TMsgDlgButtons() << mbYes << mbNo, 0)==mrYes){
        DisposalUnit(Situation->Phase,Option.SelectedUnit);
    }
    else{
//        FieldScreen1->DrawUnitChipAuto(Map,SideStatus1,zx,zy,false);
        FieldScreen1->ClearSpriteList();
        DrawMapPartial(zx, zy, zx, zy);
        UpdateMapViewBlock(zx, zy);
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ShowRangeClick(TObject *Sender)
{
    ShowUnitRange(Option.SelectedSide,Option.SelectedUnit);
}
//---------------------------------------------------------------------------
// t@CIƂ̏B
void __fastcall TForm1::MenuItem_HistoryClick(TObject *Sender)
{
    TMenuItem *menu = (TMenuItem *)Sender;
    char file[MAX_PATH],ext[4];

    strcpy(file, Menu_File->Items[menu->MenuIndex]->Caption.c_str());
    int len = strlen(file);
    if(len<4 || file[len-4]!='.')
        return;
    strcpy(ext, &file[len-3]);
    if(!strcmp(ext,"map")){
        // ʐMΐ탂[hŃ}bvJłʏ탂[hŊJB
        //LoadMap(file,false);
        LoadGame(file, true, false);
    }else if(!strcmp(ext,"sav")){
        LoadGame(file, false, false);
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnForm1Activate(TObject *Sender)
{
    if(Form_Event && Form_Event->Visible){
        Form_Event->SetFocus();
    }
}
//---------------------------------------------------------------------------
__fastcall TForm1::FileHistory_Add(const char *name)
{
    Option.History_ks.Add(name);
    FileHistory_Update();
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::FileHistory_Update(void)
{
    const int len=10;
    char *list[len];
    int count;

    count = Option.History_ks.GetHistory(list,len);
    UpdateHistoryMenu(Menu_File,MI_N_File_HistoryTop,MI_N_File_HistoryBottom,
                      list,count,MenuItem_HistoryClick);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::SaveNameDialog(void)
{
    char path[MAX_PATH];
    bool r;

    GetCurrentDirectory(sizeof(path),path);
    SaveDialog_SaveGame->InitialDir = path;
    SaveDialog_SaveGame->FileName=System.SaveFile;
    r=SaveDialog_SaveGame->Execute();
    if(r)
        strcpy(System.SaveFile,SaveDialog_SaveGame->FileName.c_str());
    return r;
}
//---------------------------------------------------------------------------
__fastcall TForm1::LoadNameDialog(void)
{
    bool r;

    OpenDialog_LoadGame->InitialDir = Option.Folder_Map;
    OpenDialog_LoadGame->FileName=System.SaveFile;
    r=OpenDialog_LoadGame->Execute();
    if(r)
        strcpy(System.SaveFile,OpenDialog_LoadGame->FileName.c_str());
    return r;
}
//---------------------------------------------------------------------------
__fastcall TForm1::SaveGame(const char *file)
{
    FileHistory_Add(file);
    GBW_SaveGame(file,Map,Situation,SideStatus1,BaseData1);
    System.NeedConfirmation = false;
    return 0;
}
//---------------------------------------------------------------------------
//Z[uf[^ǂݍŃQ[ĊJ
__fastcall TForm1::LoadGame(const char *file, bool newGame, bool bRemote)
{
    FileHistory_Add(file);
    Situation->Initialize();
    Script_Initialize(MainInstance, Application->Handle, this);
    // LuȁB
    KSLua_Initialize();
    KSLua_SetGameMaster(this);
    if(Map != NULL)
        delete Map;
    GBW_LoadGame(file,&Map,Situation,SideStatus1,BaseData1,&Option,KSImageData,true);

    if(newGame){
        if(bRemote){
            Form_Mail->ShowStartGame();
            //for(int side=0;side<BaseData1->Sides;side++){
            strcpy(SideStatus1[0].MailAddress, Option.MailUser.ReplyAddress);
            strcpy(SideStatus1[0].PlayerName, Option.MailUser.Name);
            strcpy(SideStatus1[1].MailAddress, Form_Mail->SelectedPlayer->Address);
            strcpy(SideStatus1[1].PlayerName, Form_Mail->SelectedPlayer->Name);
        }

        TForm_MapProperty *Form_MapProperty = new TForm_MapProperty(this);
        Form_MapProperty->Left = Left+32;
        Form_MapProperty->Top = Top+32;
        Form_MapProperty->UnitMax = Situation->UnitMax;
        Form_MapProperty->SetDataPointer(BaseData1, FieldScreen1, Map, KSImageData, &Option, SideStatus1, false);
        Form_MapProperty->SetControlProtect(true);
        Form_MapProperty->DrawUnionStatus(-1);
        Form_MapProperty->ShowModal();
        Form_MapProperty->GetControlContent();
        Situation->UnitMax = Form_MapProperty->UnitMax;
        delete Form_MapProperty;

        for(int i=0;i<BaseData1->Sides;i++){
            SideStatus1[i].CalcIncome(Map, BaseData1, i);
            if(HasCapital(i)){
                SideStatus1[i].Valid = true;
            }
        }
    }

    InitializeGame();

    // VKQ[ȂtF[YJnB
    if(newGame){
        SetPhaseControl();
        ExecuteScriptFunction("ks_on_newgame");
        AnsiString reportOnStart;
        vector<int> serials;
        PhaseStart(reportOnStart, serials);
    }
    return 0;
}
//---------------------------------------------------------------------------
// }bv[h^Q[ĊJ̏B
__fastcall TForm1::InitializeGame(void)
{
    System.Initialize();
    for(int side=0;side<BaseData1->Sides;side++){
        SideStatus1[side].GenerateUnitSerial();
        if(SideStatus1[side].LuaState_Com != NULL){
            KSLua_FreeLua(SideStatus1[side].LuaState_Com);
            SideStatus1[side].LuaState_Com = NULL;
        }
    }
    if(RangeLayer != NULL){
        delete RangeLayer;
    }
    RangeLayer = new TRangeLayer(Map->GetWidth(), Map->GetHeight());
    LoadScript();
    SetTekisaku(Map->Tekisaku);
    Map->UpdateShade();
    FieldScreen1->CurrentRangeType = FieldScreen::rtNone;
    FieldScreen1->ClearSpriteList();
    MapSizeSet();
    CheckCreatable();  // Y\n_̃`FbNB

    AnsiString capstr;
    capstr.sprintf("ǒn헪@%s", Map->Name.c_str());
    Form1->Caption = capstr;
    AdjustRightPanelContent();
    MoneyOperation(Situation->Phase,0);
    if(Option.UnitListNoModal && Form_UnitListp->Visible)
        Form_UnitListp->MakeList();

    Enabled_GameOperation(true);
    SetPhaseControl();

    // Luã[hB
    char luapath[256];
    char errmsg[256];
    for(int side=0; side<BaseData1->Sides; side++){
        const char *luafile = SideStatus1[side].ComScriptFile;
        if(luafile[0] == '\0'){
            luafile = "com.lua";
        }
        if(KS_GetFilePath(luapath, luafile, &Option) == -1){
            continue;
        }
        SideStatus1[side].LuaState_Com = KSLua_LoadLua(luapath);
        if(SideStatus1[side].LuaState_Com == NULL){
            sprintf(errmsg, "vl[`XNvg %s ̓ǂݍ݂Ɏs܂B\niG[O _lualog.txt ɏo͂܂j", luafile);
            ShowMessage(errmsg);
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
// tFCYIAbot^C}[Ȃǂ̃Rg[K؂ɐݒ肷B
__fastcall TForm1::SetPhaseControl(void)
{
    if(SideStatus1[Situation->Phase].IsComputer){
        Enabled_PhaseEnd(false);
        Enabled_More(false);
        Timer1->Enabled=true;
    }
    else{
        Enabled_PhaseEnd(true);
        Enabled_More(true);
        Timer1->Enabled=false;
    }
    Enabled_Option(true);
    return 0;
}
//---------------------------------------------------------------------------
// Yłꏊ`FbNB
// tFCYJnƁAQ[[hɍsB
__fastcall TForm1::CheckCreatable(void)
{
    // ƗY\Ȏ{݂̃`FbNtÕNAB
    int mw = Map->GetWidth();
    int mh = Map->GetHeight();
    for(int y=0;y<mh;y++){
        for(int x=0;x<mw;x++){
            //HE`ED
            MapStatus& gnd = Map->GetMapStatus(x, y);
            int owner = gnd.Owner;
            if(owner < 0)
                continue;
            const MapChip& gndInfo = BaseData1->GetMapChipByType(gnd.Type);
            if(gndInfo.SelfCreatable &&
               BaseData1->CreatableExists(owner, gnd.Type, SideStatus1[owner].LimitView)){
                gnd.Create = true;
            }
            else{
                gnd.Create = false;
            }
        }
    }
    for(int side=0;side<BaseData1->Sides;side++){
        // s@\n`TB
        int gcount = BaseData1->GetGroundTypeCount()-1;
        for(int gndType=0; gndType<gcount; gndType++){
            const MapChip& gndInfo = BaseData1->GetMapChipByType(gndType);
            if(!gndInfo.IsCapital)
                continue;
            const int listsize=64, capitalMax=256;
            POINT capitallist[capitalMax];
            int count = Map->SearchChipByID(side, gndInfo.ID, capitallist, capitalMax);
            // sȂ疳Bwc`ĂĂ}bvɂ͖ƂB
            if(!count)
                continue;
            // tFCYJñXN[W肷B
            SideStatus1[side].PhaseStartX = capitallist[0].x;
            SideStatus1[side].PhaseStartY = capitallist[0].y;
            for(int i=0;i<count;i++){
                const POINT& p = capitallist[i];
                const MapStatus& capital = Map->GetMapStatus(p.x, p.y);
                // s@\{݂̎͂RwNX𒲂ׂB
                POINT plist[listsize];
                int len = FieldScreen1->GetNeighborList(p.x, p.y, 0, 4, Map->GetWidth(), Map->GetHeight(), plist, listsize);
                for(int i=0;i<len;i++){
                    MapStatus& gnd = Map->GetMapStatus(plist[i].x, plist[i].y);
                    if(gnd.Owner != capital.Owner)
                        continue;
                    if(BaseData1->CreatableExists(side, gnd.Type, SideStatus1[side].LimitView)){
                        gnd.Create = true;
                    }
                }
            }
        }
    }

    return 0;
}
//---------------------------------------------------------------------------
// eLTN[hON/OFFݒ肷Bʂ̍XV͂ȂB
__fastcall TForm1::SetTekisaku(bool tekisaku)
{
    for(int i=0;i<BaseData1->Sides;i++)
        SideStatus1[i].LimitView = tekisaku;
    if(tekisaku){
        //FieldScreen1->FindVisibleAll(Map,BaseData1, &SideStatus1[Situation->Phase], Situation->Phase);
        FieldScreen1->FindVisibleAll(Map, BaseData1, SideStatus1, Situation->Phase);
    }else{
        Map->InitVisible(1);
    }
    return 0;
}
//---------------------------------------------------------------------------
//}bṽTCYƃrbg}bṽTCY킹
__fastcall TForm1::MapSizeSet(void)
{
    FieldScreen1->SetViewportSize(Map, Image_Map->Picture->Bitmap->Width, Image_Map->Picture->Bitmap->Height);
    SetViewportLeftTop(0, 0);
    return 0;
}
//---------------------------------------------------------------------------
//̎ǉyёS⋋
__fastcall TForm1::PhaseStart(AnsiString& reportStr, vector<int>& deletedSerials)
{
    SideStatus *sidep;
    const char *reasonStr[3] = {"", "v", "ė"};

    sidep = &SideStatus1[Situation->Phase];
    CheckCreatable();
    if(Situation->Turn > 0){
        // RB
        int side = Situation->Phase;
        int serials[UNITMAX], count=0;   // ͎bB
        for(int i=0; i<SideStatus1[side].UnitCount; i++){
            UnitStatus& unit = SideStatus1[side].Unit[i];
            if(unit.X == -1)
                continue;
            const UnitChip& unitInfo = BaseData1->GetUnitChipByID(unit.ID);
            MapStatus& gnd = Map->GetMapStatus(unit.X, unit.Y);
            // R⋋\Ȓn`ł́ARȂB
            if(unitInfo.GroundFlag[gnd.Type] & GROUND_SUPPLY)
                continue;
            //ShowMessage(unitInfo.FuelConsume);
            if(unitInfo.FuelConsume > 0){
                unit.Fuel -= unitInfo.FuelConsume;
                // ėEvB
                if(unit.Fuel <= 0){
                    serials[count++] = unit.Serial;
                    if(!SideStatus1[side].IsComputer){
                        reportStr.cat_sprintf("(%d,%d)n_ %s R؂ɂ%s܂B\r\n",
                                unit.X, unit.Y, unitInfo.Name, reasonStr[unitInfo.ANFType]);
                    }
                }
            }
        }
#if 0
        for(int i=0;i<count;i++){
            SideStatus1[side].DeleteUnitBySerial(Map, serials[i]);
        }
#else
        for(int i=0;i<count;i++){
            deletedSerials.push_back(serials[i]);
        }
#endif
    }
    MoneyOperation(Situation->Phase, sidep->Income); //
    if(sidep->Money>MONEYMAX)
        sidep->Money=MONEYMAX;
    FieldScreen1->FindSupplyRange(RangeLayer, Map, BaseData1, sidep, Situation->Phase); //S⋋͈̔
    SupplyAll(Situation->Phase);    //S⋋
    ExecuteScriptFunction("ks_on_phasestart");
    MoneyOperation(Situation->Phase,0); //S⋋̌Ɏ\XV
    return 0;
}
//---------------------------------------------------------------------------
//S⋋
__fastcall TForm1::SupplyAll(int side)
{
    SideStatus *sidep = &SideStatus1[side];
//    UnitStatus *unitp;
//    UnitChip *unitInfop;

    if(sidep->Money < 0)   //}CiXȂ牽Ȃ
        return 0;
    for(int i=0;i<sidep->UnitCount;i++){
        UnitStatus& unit = sidep->Unit[i];
        if(unit.X==-1)
            continue;
        if(CanSupplyUnit(unit.X, unit.Y, side, unit.Type)){
            SupplyToUnit(sidep, i, SUPPLY_ALL);
        }
        for(int j=0;j<unit.Load;j++){
            const UnitChip& unitInfo = BaseData1->GetUnitChipByType(unit.Type);
            int loading = unit.LoadingUnit[j];
            int flag = unitInfo.SupplyFlag_Loading[sidep->Unit[loading].Type];
            if(flag){
                SupplyToUnit(sidep, loading, flag);
            }
        }
        //ڂĂ郆jbgɕ⋋B⋋\łKv
    }
    int mw = Map->GetWidth();
    int mh = Map->GetHeight();
    for(int y=0;y<mh;y++){
        for(int x=0;x<mw;x++){
            //⋋jbg̎
            int flag = RangeLayer->GetRangeValue(x, y);
            const MapStatus& gnd = Map->GetMapStatus(x, y);
            if(flag && gnd.Side==side){
                SupplyToUnit(sidep, gnd.UnitIndex, flag);
            }
        }
    }
    //炩ߔ⋋\ǂׂĂÔ߁ARangePoint
    //`FbNŗǂAꉞSideĂB
    //⋋tOFieldScreen::FindSupplyRange()ŒׂlB

    return 0;
}
//---------------------------------------------------------------------------
// ⋋tO̓eɉĔRƒe⋋B
__fastcall TForm1::SupplyToUnit(SideStatus *sidep,int unitNum,int flag)
{
    UnitStatus& unit = sidep->Unit[unitNum];
    const UnitChip& unitInfo = BaseData1->GetUnitChipByID(unit.ID);

    if(flag & SUPPLY_LIFE){
        int rate = unitInfo.Value/100;
        int supplyLife = 100-unit.Life;
        if(supplyLife>20)
            supplyLife=20;
        if(supplyLife*rate > sidep->Money)
            supplyLife = sidep->Money/rate;
        sidep->Money -= supplyLife*rate;
        unit.Life += supplyLife; //Life⋋
    }
    if(flag & SUPPLY_FUEL){
        int value = unitInfo.FuelValue;
        int supplyFuel = unitInfo.FuelMax - unit.Fuel;
        if(supplyFuel*value > sidep->Money)
            supplyFuel = sidep->Money/value;
        sidep->Money -= supplyFuel*value;
        unit.Fuel += supplyFuel; //R⋋
    }
    if(flag & SUPPLY_GUN){
        for(int i=0;i<GUN_MAX;i++){     //e⋋
            int value = unitInfo.GunValue[i];
            int supplyGun = unitInfo.GunMax[i] - unit.GunRest[i];
            if(supplyGun*value > sidep->Money)
                supplyGun = sidep->Money/value;
            sidep->Money -= supplyGun*value;
            unit.GunRest[i] += supplyGun;
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//J[\n_̒n`\
__fastcall TForm1::MapChipStatusPut(int zx,int zy)
{
    int side,num;

    const MapStatus& gnd = Map->GetMapStatus(zx, zy);
    const MapChip& gndInfo = BaseData1->GetMapChipByID(gnd.ID);
    FieldScreen1->DrawGroundStatusToTCanvas(Image_GroundStatus->Canvas,Panel1->Brush->Color,0,0,gnd, &gndInfo);

    side= gnd.Side; //jbg\
    num = gnd.UnitIndex;

    // eLTN[hł͎EÕjbg݂͑Ȃ̂ƓB
    if(SideStatus1[Situation->Phase].LimitView && Map->GetShade(zx, zy))
        side = -1;

    // jbgړĂrȂ炻̃jbg̏\B
    if(side==-1 && System.HoldUnit != -1){
        if(zx==System.TargetX && zy==System.TargetY){
            side = Situation->Phase;
            num = System.HoldUnit;
        }
    }
    if(side==-1){
        // \Ă郆jbgKvɉăNAB
        if(DrawedStatusUnit==-1)
            return 0;
        FillCanvas(Image_UnitStatus->Canvas, Panel1->Brush->Color);
        FillCanvas(Image_Loading->Canvas,    Panel1->Brush->Color);
        DrawedStatusUnit=-1;
    }
    else{
        UnitStatusPut(side,num);
        DrawedStatusUnit = side*UNITMAX+num;
    }
    return 0;
}
//---------------------------------------------------------------------------
//jbg̏\
__fastcall TForm1::UnitStatusPut(int side, int num)
{
    const UnitStatus& unit = SideStatus1[side].Unit[num];
    const UnitChip& unitInfo = BaseData1->GetUnitChipByType(unit.Type);
    FieldScreen1->DrawUnitStatusToTCanvas(Image_UnitStatus->Canvas,Panel1->Brush->Color,0,0,&unit,&unitInfo,Map->LevelUpEnabled);

    DrawLoadingStatus(side, num);
    return 0;
}
//---------------------------------------------------------------------------
//ڏ󋵕\̍XV
__fastcall TForm1::DrawLoadingStatus(int side, int num)
{
#if 1
    const UnitStatus& unit = SideStatus1[side].Unit[num];
    FieldScreen1->DrawLoadingStatus(Image_Loading->Canvas, Panel1->Brush->Color, unit, *BaseData1, SideStatus1, side, System.SelectedLoading);
#else
    const UnitStatus& unit = SideStatus1[side].Unit[num];
    const UnitChip& unitInfo = BaseData1->GetUnitChipByType(unit.Type);
    TCanvas *canvas = Image_Loading->Canvas;
    TColor backcolor = Panel1->Brush->Color;

    FillCanvas(canvas,backcolor);
    if(!unitInfo.Loadable)
        return 0;
    canvas->Font->Color = clWindowText;
    canvas->TextOut(0, 0, "ڃjbg");
    int y = 16;
    for(int i=0; i<unitInfo.Loadable; i++){
        if(i<unit.Load){
            if(System.SelectedLoading == i){
                canvas->Brush->Color = clHighlight;
                canvas->FillRect(Rect(0, y, canvas->ClipRect.Right, y+36));
                canvas->Font->Color = clHighlightText;
            }else{
                canvas->Brush->Color = backcolor;
                canvas->Font->Color = clWindowText;
            }
            const UnitStatus& loaded = SideStatus1[side].Unit[unit.LoadingUnit[i]];
            FieldScreen1->DrawUnitChipToTCanvas(canvas, 2, y+2, loaded.Graphic, GRAPHDEGREE_N);
            // jbg
            canvas->TextOut(36, y+4, BaseData1->GetUnitChipByType(loaded.Type).Name);
            // Life
            AnsiString str;
            str.cat_sprintf("Life %2d", loaded.Life);
            canvas->TextOut(36, y+20, str);
        }
        canvas->Brush->Color = clBlack;
        canvas->FrameRect(TRect(0, y, canvas->ClipRect.Right, y+36));
        y += 36;
    }
#endif
    return 0;
}
//---------------------------------------------------------------------------
// }bvō{^̏B
__fastcall TForm1::MouseLeftDown(int zx,int zy)
{
    UnitStatus *unitp = NULL;
    const UnitChip *unitInfop = NULL;
    bool noMove;
    bool collision=false;
    int side,num,cx,cy;

    if(System.RadiusCursor){
        EraseAttackRadius();
        System.RadiusCursor = 0;
    }
    if(System.GameEnd){
        return 0;
    }
    if(System.HoldUnit!=-1){
        unitp = &SideStatus1[Situation->Phase].Unit[System.HoldUnit];
        unitInfop = &BaseData1->GetUnitChipByType(unitp->Type);
    }
    switch(KSState){
    case STATE_DEFAULT:
        // jbgݔB
        side = Map->GetMapStatus(zx, zy).Side;
        if(side == Situation->Phase){
            //jbg񂾏ԂɂBړ͈͂̕\
            System.UseGun = -1;
            num = Map->GetMapStatus(zx, zy).UnitIndex;
            if(!SideStatus1[side].Unit[num].Actioned){
                System.PhaseEndable=false;
                System.HoldUnit=num;
                unitp = &SideStatus1[Situation->Phase].Unit[System.HoldUnit];
                unitInfop = &BaseData1->GetUnitChipByType(unitp->Type);
                FieldScreen1->GetMoveRange(RangeLayer,Map,BaseData1,SideStatus1,&SideStatus1[side].Unit[num],side,zx,zy);
                if(!System.NoDraw){
                    FieldScreen1->CurrentRangeType = FieldScreen::rtMoveRange;
                    DrawMapPartial(unitp->X - unitInfop->MoveMax, unitp->Y - unitInfop->MoveMax, unitp->X + unitInfop->MoveMax, unitp->Y + unitInfop->MoveMax);
                    UpdateMapViewBlock(unitp->X - unitInfop->MoveMax, unitp->Y - unitInfop->MoveMax, unitp->X + unitInfop->MoveMax, unitp->Y + unitInfop->MoveMax);
                }
                System.SelectedLoading = -1;
                KSState = STATE_GETMOVETARGET;
            }
        }
        else{
            // YB
            MouseLeftDown_CreateUnit(zx,zy);
        }
        break;
    case STATE_GETMOVETARGET:
        if(!RangeLayer->GetRangeValue(zx,zy))
            break;
        FieldScreen1->CurrentRangeType = FieldScreen::rtNone;
        DrawMapPartial(unitp->X - unitInfop->MoveMax, unitp->Y - unitInfop->MoveMax, unitp->X + unitInfop->MoveMax, unitp->Y + unitInfop->MoveMax);
        UpdateMapViewBlock(unitp->X - unitInfop->MoveMax, unitp->Y - unitInfop->MoveMax, unitp->X + unitInfop->MoveMax, unitp->Y + unitInfop->MoveMax);
        if(!Map->GetVisible(zx,zy)){ //E̊OȂ`FbN
            if(WalkPath(unitp,&zx,&zy,&cx,&cy))
                collision = true; //ړGjbgɏՓ˂
        }
        System.TargetX = zx;
        System.TargetY = zy;
        noMove = (zx==unitp->X && zy==unitp->Y);
        EraseMoveRangeAndShowMove(zx,zy,Situation->Phase,System.HoldUnit);
        if(collision){
            // Փ˂Ă狭IɈړ肷B
            FieldScreen1->AddSpriteZ(zx, zy, TSpriteOnMap::stCursor, CURSOR_CLLSN);
            DrawMapPartial(zx, zy, zx, zy);
            UpdateMapViewBlock(zx, zy);
            // ZOCɂՓ˂ȂՓ˃}[N͈ړɕtB
            if(cx!=zx || cy!=zy){
                FieldScreen1->AddSpriteZ(cx, cy, TSpriteOnMap::stCursor, CURSOR_CLLSN);
                DrawMapPartial(cx, cy, cx, cy);
                FieldScreen1->DrawMap(Map, RangeLayer, NULL, SideStatus1, cx, cy, cx, cy);
                UpdateMapViewBlock(cx, cy);
            }
            DamageWait(WAIT_SHOWCLLSN);
            Map->GetVisible(cx, cy) = 1;
            MouseLeftDown_EndOfOther(zx, zy, unitp, unitInfop);
            break;
        }
//        if(((zx!=unitp->X || zy!=unitp->Y) && Map->GetMapStatus(zx,zy).Side!=-1) ||
        if(ConfirmAction(unitp, unitInfop, noMove)){
            // gpΊIɑIԂACOM̑ɂꍇB
            MouseLeftDown_GetActionRange(unitp, unitInfop, noMove);
        }else{
            // gpΊ[U[IɑIԏꍇB
            KSState = STATE_RECIEVEACTION;
        }
        break;
    case STATE_RECIEVEACTION:
        // |bvAbvj[ȊȌNbNꍇAB
        if(System.UseGun != -1){
            FieldScreen1->HidePopupMenu(NULL);
            MouseLeftDown_GetActionRange(unitp, unitInfop, noMove);
        }
        break;
    case STATE_SELECTTARGET:
        if(!RangeLayer->GetRangeValue(zx,zy)){
            if(zx==System.TargetX && zy==System.TargetY){
                MouseLeftDown_EndOfOther(System.TargetX, System.TargetY, unitp, unitInfop);
            }
            else{
                System.RadiusCursor = 1;
            }
            break;
        }
        TRect r;
        FieldScreen1->GetMessageRectNeedUpdateRect(&r);
        FieldScreen1->CurrentRangeType = FieldScreen::rtNone;
        FieldScreen1->ClearSpriteList();
        FieldScreen1->ClearMessageRectList();
        if(Option.ShowAttackGuidance){
//            DrawAllAndUpdateMapView();
            DrawMapPartial(r);
            UpdateMapViewBlock(r);
        }
        System.LeftX = unitp->X;
        System.LeftY = unitp->Y;
        // jbg̉摜͂܂oĂid}[N܂ȂjB
        FieldScreen1->AddSpriteZ(System.TargetX, System.TargetY, TSpriteOnMap::stMapChipDark, Map->GetMapStatus(System.TargetX, System.TargetY).Graphic);
        FieldScreen1->AddSpriteZ(System.TargetX, System.TargetY, TSpriteOnMap::stUnitChip, unitp->Graphic);
        MoveUnit(System.TargetX, System.TargetY, Situation->Phase, System.HoldUnit, !System.NoDraw);
        int maxr = unitInfop->GetMaxRange();
        DrawMapPartial(unitp->X - maxr, unitp->Y - maxr, unitp->X + maxr, unitp->Y + maxr);
        UpdateMapViewBlock(unitp->X - maxr, unitp->Y - maxr, unitp->X + maxr, unitp->Y + maxr);
        //Ί킪I΂ĂāAꂪKwNXUΊȂ
        //KwNXȔsB
        if(System.UseGun!=-1 && System.UseGun<GUN_MAX && unitInfop->Radius[System.UseGun]>1){
            unitp->Fuel -= System.ConsumeFuel;
            if(unitInfop->SuperMissile){
                UnitBattleMegaHex(Situation->Phase, System.HoldUnit, System.TargetX, System.TargetY, System.UseGun, !System.NoDraw);
            }
            else{
                UnitBattleMegaHex(Situation->Phase, System.HoldUnit, zx, zy, System.UseGun, !System.NoDraw);
            }
            MouseLeftDown_EndOfAttack(unitp, unitInfop);
        }
        //łȂ΁A]̍U^~ԏB
        else if(Map->GetMapStatus(zx,zy).Side!=-1){
            //퓬OɔRƁiԍω\j
            unitp->Fuel -= System.ConsumeFuel;
            UnitBattle(Situation->Phase, System.HoldUnit, Map->GetMapStatus(zx,zy).Side, Map->GetMapStatus(zx,zy).UnitIndex, !System.NoDraw);
            MouseLeftDown_EndOfAttack(unitp, unitInfop);
        }
        else{
            MouseLeftDown_UnloadUnit(zx, zy, unitp, unitInfop);
        }
        break;
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::MouseLeftDown_CreateUnit(int zx,int zy)
{
    //Y\Ȃ琶Y_CAO\
    if(CanCreateUnit(zx,zy)){
        if(SideStatus1[Situation->Phase].UnitCount >= Situation->UnitMax){
            ShowUnitMax();
            return -1;
        }
        Form_seisanp->MakeList(Situation->Phase,
                               SideStatus1[Situation->Phase].Money,
                               Map->GetMapStatus(zx,zy).Type,
                               SideStatus1[Situation->Phase].LimitView);
        Form_seisanp->ShowModal();
        if(Form_seisanp->ModalResult == mrOk){  //炵ĕǉ
            const UnitChip& unitInfo = BaseData1->GetUnitChipByType(Form_seisanp->SelectedType);
            MoneyOperation(Situation->Phase, -unitInfo.Value);
            NewUnit(zx,zy,Situation->Phase,Form_seisanp->SelectedType);
            System.NeedConfirmation = true;
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::MouseLeftDown_GetActionRange(UnitStatus *unitp, const UnitChip *unitInfop, bool noMove)
{
    TempMove(noMove);
    if(System.UseGun == MENUITEM_NOACTION){
        // sII񂾏ꍇB
        MouseLeftDown_EndOfOther(System.TargetX, System.TargetY, unitp, unitInfop);
    }
    else{
        KSState = STATE_SELECTTARGET;
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::MouseLeftDown_UnloadUnit(int unloadx, int unloady, UnitStatus *unitp, const UnitChip *unitInfop)
{
    if(!RangeLayer->GetRangeValue(unloadx, unloady)){
        if(unloadx==System.TargetX && unloady==System.TargetY){
            FieldScreen1->ClearSpriteList();
            DrawMapPartial(unitp->X - 1, unitp->Y - 1, unitp->X + 1, unitp->Y + 1);
            UpdateMapViewBlock(unitp->X - 1, unitp->Y - 1, unitp->X + 1, unitp->Y + 1);
            MouseLeftDown_EndOfAttack(unitp, unitInfop);
        }
        else{
            System.RadiusCursor = 1;
        }
        return 0;
    }
    DownUnit(unloadx, unloady, Situation->Phase, System.HoldUnit, !System.NoDraw);
    // ~낷ƂɌolZB
    unitp->Experience += 3;
    //ڂ̍~ԂƓɁAEXVB͈̏񂾂B
    if(SideStatus1[Situation->Phase].LimitView && System.LeftX!=-1){
        UpdateLimitView(System.LeftX, System.LeftY, unitp->X, unitp->Y, unitInfop);
    }
    System.LeftX = -1;
    if(unitp->Load){
        //̍~ԂsׂɁA~Ԕ͈͂̍XVsB
        RangeLayer->InitRange();
        FieldScreen1->GetLoadRange(RangeLayer, Map, BaseData1, SideStatus1, unitp, Situation->Phase, System.TargetX, System.TargetY);
        // ͂𒲂ׂāA܂~Ԃł鏊邩mFB
        POINT plist[6];
        int count = FieldScreen1->GetNeighborList(System.TargetX, System.TargetY, 1, 2, Map->GetWidth(), Map->GetHeight(), plist, 6);
        int unloadable=0;
        for(int i=0;i<count;i++){
            if(RangeLayer->GetRangeValue(plist[i].x, plist[i].y)){
                unloadable++;
            }
        }
        // ܂~Ԃł鏊ȂA~ԂpB
        if(unloadable){
            // jbg̉摜͂܂oĂid}[N܂ȂjB
            FieldScreen1->AddSpriteZ(System.TargetX, System.TargetY, TSpriteOnMap::stMapChipDark, Map->GetMapStatus(System.TargetX, System.TargetY).Graphic);
            FieldScreen1->AddSpriteZ(System.TargetX, System.TargetY, TSpriteOnMap::stUnitChip, unitp->Graphic);
            FieldScreen1->CurrentRangeType = FieldScreen::rtAttackOrLoadRange;
            DrawMapPartial(unitp->X - 1, unitp->Y - 1, unitp->X + 1, unitp->Y + 1);
            UpdateMapViewBlock(unitp->X - 1, unitp->Y - 1, unitp->X + 1, unitp->Y + 1);
            System.RadiusCursor = 1;
            return 0;
        }
    }
    //S~Ԃꍇ͔RďIB
    //̎_ŎE͊SɍXVĂB
    FieldScreen1->ClearSpriteList();
    DrawMapPartial(unitp->X - 1, unitp->Y - 1, unitp->X + 1, unitp->Y + 1);
    UpdateMapViewBlock(unitp->X - 1, unitp->Y - 1, unitp->X + 1, unitp->Y + 1);
    SideStatus1[Situation->Phase].Unit[System.HoldUnit].Fuel -= System.ConsumeFuel;
    KSState = STATE_DEFAULT;
    System.HoldUnit = -1;
    System.PhaseEndable = true;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::MouseLeftDown_EndOfAttack(UnitStatus *unitp, const UnitChip *unitInfop)
{
    if(Map->GetMapStatus(System.TargetX, System.TargetY).Side != -1){
        //jbgȂȂĂȂΎE̍XVB
        //A~ԓrȂXV͊ɏIĂB(System.LeftX == -1)
        if(SideStatus1[Situation->Phase].LimitView && System.LeftX!=-1){
//        AnsiString str;
//        str.cat_sprintf("%d,%d,%d,%d", System.LeftX, System.LeftY, unitp->X, unitp->Y);
//        ShowMessage(str);
            UpdateLimitView(System.LeftX, System.LeftY, unitp->X, unitp->Y, unitInfop);
        }
        if(!OutsideVisible(System.TargetX, System.TargetY)){
            DrawMapPartial(System.TargetX, System.TargetY, System.TargetX, System.TargetY);
            UpdateMapViewBlock(System.TargetX, System.TargetY);
        }
    }
    else{ //jbgȂȂĂO̎E邾
        if(SideStatus1[Situation->Phase].LimitView)
            UpdateLimitView(System.LeftX, System.LeftY, -1, 0, unitInfop);
    }
    // ړ̕AolZBol`FbNB
    unitp->Experience++;
    CheckUnitExperience(unitp, unitInfop);
    // Ԃ߂B
    KSState = STATE_DEFAULT;
    System.HoldUnit = -1;
    System.PhaseEndable = true;
    System.NeedConfirmation = true;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::MouseLeftDown_EndOfOther(int movex, int movey, UnitStatus *unitp, const UnitChip *unitInfop)
{
    int ox,oy;
    int drawr = 1;
    bool plused;

    ox = unitp->X;
    oy = unitp->Y;
    plused = MoveUnit(movex, movey, Situation->Phase, System.HoldUnit, !System.NoDraw);
    //łȂ΁AR炷
    if(!plused){
        SideStatus1[Situation->Phase].Unit[System.HoldUnit].Fuel -= System.ConsumeFuel;
    }
    if(SideStatus1[Situation->Phase].LimitView){
        //̏ꍇAꂽ̎Ê܂ܕێB
        //ijbgj
        if(plused)
            UpdateLimitView(ox, oy, -1, 0, unitInfop);
        else
            UpdateLimitView(ox, oy, unitp->X, unitp->Y, unitInfop);
        drawr = unitInfop->Visibility;
    }
    drawr = max(drawr, unitInfop->GetMaxRange());

    FieldScreen1->CurrentRangeType = FieldScreen::rtNone;
    FieldScreen1->ClearSpriteList();
    DrawMapPartial(movex-drawr, movey-drawr, movex+drawr, movey+drawr);
    UpdateMapViewBlock(movex-drawr, movey-drawr, movex+drawr, movey+drawr);
    // ړ̕AolZBol`FbNB
    unitp->Experience++;
    CheckUnitExperience(unitp, unitInfop);
    // Ԃ߂B
    KSState = STATE_DEFAULT;
    System.HoldUnit = -1;
    System.PhaseEndable = true;
    System.NeedConfirmation = true;
    return 0;
}
//---------------------------------------------------------------------------
//}bvŉE{^̏
__fastcall TForm1::MouseRightDown(int zx,int zy)
{
    if(System.RadiusCursor){
        EraseAttackRadius();
        System.RadiusCursor = 0;
    }
    Popup_ShowRange->Enabled=false;
    Popup_KillUnit->Enabled=false;
    if(System.PhaseEndable){
        const MapStatus& gnd = Map->GetMapStatus(zx,zy);
        if(gnd.Side!=-1){
            Option.SelectedSide = gnd.Side;
            Option.SelectedUnit = gnd.UnitIndex;
            Popup_ShowRange->Enabled=true;
        }
        if(gnd.Side==Situation->Phase){
            Option.SelectedUnit = gnd.UnitIndex;
            if(!SideStatus1[Situation->Phase].Unit[gnd.UnitIndex].Actioned)
                Popup_KillUnit->Enabled=true;
        }
        return 0;
    }

    UnitStatus *unitp = &SideStatus1[Situation->Phase].Unit[System.HoldUnit];
    const UnitChip& unitInfo = BaseData1->GetUnitChipByType(unitp->Type);

    TRect updateRect;
    switch(KSState){
    case STATE_GETMOVETARGET:
        //jbĝ݂iړ͈͂̏j
        Map->GetMapStatus(unitp->X, unitp->Y).Side = Situation->Phase;
        FieldScreen1->ClearSpriteList();
        FieldScreen1->CurrentRangeType = FieldScreen::rtNone;
        DrawMapPartial(unitp->X - unitInfo.MoveMax, unitp->Y - unitInfo.MoveMax, unitp->X + unitInfo.MoveMax, unitp->Y + unitInfo.MoveMax);
        UpdateMapViewBlock(unitp->X - unitInfo.MoveMax, unitp->Y - unitInfo.MoveMax, unitp->X + unitInfo.MoveMax, unitp->Y + unitInfo.MoveMax);
        System.HoldUnit=-1;
        KSState = STATE_DEFAULT;
        System.PhaseEndable=true;
        break;
    case STATE_RECIEVEACTION:
        Map->GetMapStatus(unitp->X, unitp->Y).Side = Situation->Phase;
        FieldScreen1->ClearSpriteList();
        FieldScreen1->CurrentRangeType = FieldScreen::rtNone;
        if(FieldScreen1->HidePopupMenu(&updateRect)){
            DrawMapPartial(updateRect);
            UpdateMapViewBlock(updateRect);
        }
        DrawMapPartial(unitp->X - unitInfo.MoveMax, unitp->Y - unitInfo.MoveMax, unitp->X + unitInfo.MoveMax, unitp->Y + unitInfo.MoveMax);
        UpdateMapViewBlock(unitp->X - unitInfo.MoveMax, unitp->Y - unitInfo.MoveMax, unitp->X + unitInfo.MoveMax, unitp->Y + unitInfo.MoveMax);
        System.HoldUnit=-1;
        KSState = STATE_DEFAULT;
        System.PhaseEndable=true;
        break;
    case STATE_SELECTTARGET:
        //jbg̈ړ
        if(unitp->Actioned)
            return 0; //~ԓr̃jbg͉ENbN𖳎
        Map->GetMapStatus(unitp->X, unitp->Y).Side = Situation->Phase;
        FieldScreen1->CurrentRangeType = FieldScreen::rtNone;
        FieldScreen1->ClearSpriteList();
        FieldScreen1->ClearMessageRectList();
        if(Option.ShowAttackGuidance){
            DrawAllAndUpdateMapView();
        }
        else{
            if(FieldScreen1->HidePopupMenu(&updateRect)){
                DrawMapPartial(updateRect);
                UpdateMapViewBlock(updateRect);
            }
            int maxr = max(unitInfo.MoveMax, unitInfo.GetMaxRange());
            if(unitInfo.SuperMissile){
                maxr += unitInfo.Radius[0];
            }
            DrawMapPartial(unitp->X - maxr, unitp->Y - maxr, unitp->X + maxr, unitp->Y + maxr);
            UpdateMapViewBlock(unitp->X - maxr, unitp->Y - maxr, unitp->X + maxr, unitp->Y + maxr);
        }
        System.HoldUnit=-1;
        KSState = STATE_DEFAULT;
        System.PhaseEndable=true;
        break;
    }
    return 0;
}
//---------------------------------------------------------------------------
//ړ͈͕\Ajbgw肳ꂽW֓ČB
__fastcall TForm1::EraseMoveRangeAndShowMove(int zx,int zy,int side,int num)
{
//    bool Draw;
    const UnitStatus *unitp = &SideStatus1[side].Unit[num];
    const UnitChip& unitInfo = BaseData1->GetUnitChipByType(unitp->Type);
    int ux = unitp->X;
    int uy = unitp->Y;

#if 0
    DrawMapChip(ux,uy);
    Draw = !OutsideVisible(zx,zy); //ړW͕`悷邩H
    if(Draw){
        FieldScreen1->DrawMapChipDarkZ(zx, zy, Map->Data[zx][zy].Graphic);
        FieldScreen1->DrawUnitChipZ(zx,zy,Unitp->Graphic);
        if(Unitp->Load)
            FieldScreen1->DrawCursorZ(zx,zy,CURSOR_LOAD);
    }
    UpdateMapView(FieldScreen1->BackupRect[0]);
#endif
    // ̏ꏊ̃jbg摜B
    //FieldScreen1->AddSpriteZ(ux, uy, TSpriteOnMap::stMapChip, Map->Data[ux][uy].Graphic);
    Map->GetMapStatus(ux,uy).Side = -1;
    // Ɉړ悤ɌB
    bool draw = !OutsideVisible(zx, zy); //ړW͕`悷邩H
    if(draw){
        if(Option.ShowMove && (ux!=zx || uy!=zy)){
            TPoint plist[32];
            plist[0].x = zx;
            plist[0].y = zy;
            int count=1;
            for(;;){
                plist[count] = RangeLayer->GetBack(plist[count-1].x, plist[count-1].y);
                if(plist[count].x == ux && plist[count].y == uy)
                    break;
                count++;
            }
            for(int i=count;i>0;i--){
                const TPoint& p = plist[i];
                const TPoint& p2 = plist[i-1];
                FieldScreen1->ClearSpriteList();
                FieldScreen1->AddSpriteZ(p.x, p.y, TSpriteOnMap::stMapChipDark, Map->GetMapStatus(p.x, p.y).Graphic);
                FieldScreen1->AddSpriteZ(p.x, p.y, TSpriteOnMap::stUnitChip, unitp->Graphic);
                DrawMapPartial(p.x-1, p.y-1, p.x+1, p.y+1);
                UpdateMapViewBlock(p.x-1, p.y-1, p.x+1, p.y+1);
                TimeWait(10);
                // wNXƃwNX̊Ԃ̒ԏԂ`悷B
                int chipx, chipy, chipx2, chipy2;
                FieldScreen1->XY_MapToPhy(p.x, p.y, &chipx, &chipy);
                FieldScreen1->XY_MapToPhy(p2.x, p2.y, &chipx2, &chipy2);
                int midx = (chipx + chipx2)/2;
                int midy = (chipy + chipy2)/2;
                FieldScreen1->ClearSpriteList();
                FieldScreen1->AddSprite(midx, midy, TSpriteOnMap::stDarkRect, 0);
                FieldScreen1->AddSprite(midx, midy, TSpriteOnMap::stUnitChip, unitp->Graphic);
                DrawMapPartial(p.x-1, p.y-1, p.x+1, p.y+1);
                UpdateMapViewBlock(p.x-1, p.y-1, p.x+1, p.y+1);
                TimeWait(10);
            }
            FieldScreen1->ClearSpriteList();
        }
        FieldScreen1->AddSpriteZ(zx, zy, TSpriteOnMap::stMapChipDark, Map->GetMapStatus(zx,zy).Graphic);
        FieldScreen1->AddSpriteZ(zx, zy, TSpriteOnMap::stUnitChip, unitp->Graphic);
        FieldScreen1->AddSpriteZ(zx, zy, TSpriteOnMap::stCursor, CURSOR_MOVE);
    }
    DrawMapPartial(unitp->X - unitInfo.MoveMax, unitp->Y - unitInfo.MoveMax, unitp->X + unitInfo.MoveMax, unitp->Y + unitInfo.MoveMax);
    UpdateMapViewBlock(unitp->X - unitInfo.MoveMax, unitp->Y - unitInfo.MoveMax, unitp->X + unitInfo.MoveMax, unitp->Y + unitInfo.MoveMax);
    return 0;
}
//---------------------------------------------------------------------------
//ǂ̍ŝmFBmF̗vΏ]ʂ̂thB
//߂l͍sȂ1AłȂ0
__fastcall TForm1::ConfirmAction(UnitStatus *unitp, const UnitChip *unitInfop, bool noMove)
{
    //if(!collision && UnitInfop->HasMegaHex()){
    if(unitInfop->SuperMissile){
        System.UseGun = 0;
        return 1;
    }
    if(noMove && unitInfop->HasMegaHex()){
        // CPȔꍇASystem.UseGun̒l͌肳ĂB
        if(System.CPUControl){
            return 1;
        }
        else{
//            SelectGunByUser(unitp,unitInfop,noMove);
            //gΊ̐𐔂B
            FieldScreen1->ClearPopupMenu();
            for(int i=0;i<GUN_MAX;i++){
                if(!unitInfop->GunMax[i])
                    continue;
                bool enabled = true;
                if(!unitp->GunRest[i]){
                    enabled = false;
                }else if(unitInfop->MinRange[i] > 1 && !noMove){
                    enabled = false;
                }
                FieldScreen1->AddPopupMenu(unitInfop->GunName[i], i, enabled);
            }
            if(unitp->Load){
                FieldScreen1->AddPopupMenu("~", MENUITEM_DOWNUNIT, true);
            }
            FieldScreen1->AddPopupMenu("sI", MENUITEM_NOACTION, true);
            TRect updr;
            FieldScreen1->ShowPopupMenu(unitp->X, unitp->Y, &updr);
            DrawMapPartial(updr.Left, updr.Top, updr.Right, updr.Bottom);
            UpdateMapViewBlock(updr.Left, updr.Top, updr.Right, updr.Bottom);
            return 0;
        }
    }
    return 1;
}
//---------------------------------------------------------------------------
// ړB
__fastcall TForm1::TempMove(bool noMove)
{
    bool Draw,megaHex=false;
    int i,zx,zy,ux,uy,gndType;
    int side = Situation->Phase;
    int unitNum = System.HoldUnit;
    UnitStatus *unitp = &SideStatus1[side].Unit[unitNum];
    const UnitChip& unitInfo = BaseData1->GetUnitChipByType(unitp->Type);

    zx = System.TargetX;
    zy = System.TargetY;
    ux = unitp->X;
    uy = unitp->Y;

    System.ConsumeFuel = RangeLayer->GetRangeValue(ux,uy) - RangeLayer->GetRangeValue(zx,zy);
//    Map->Data[ux][uy].Side = -1; //~Ԕ͈͒̈
    gndType = Map->GetMapStatus(zx,zy).Type;
    if(Map->GetMapStatus(zx,zy).Side==-1){ // EڂłȂ΍U
        // X[p[~TC͓ʈB
        if(unitInfo.SuperMissile){
            int maxr = unitInfo.Radius[0];
            int minr = 1;
            RangeLayer->InitRange();
            FieldScreen1->GetNeighborRange(zx, zy, minr, maxr, RangeLayer);
            megaHex = true;
        }
        else{
            // KwNXUȊỎΊĝȂ]̎˒sB
            if(System.UseGun==-1 || System.UseGun==MENUITEM_DOWNUNIT ||
               !noMove  ||
               unitInfo.Radius[System.UseGun]<=1){
                FieldScreen1->GetAttackRange(RangeLayer,Map,BaseData1,unitp,SideStatus1,Situation->Phase,zx,zy,noMove);
            }else{
                //KwNXUΊw肵ꍇ͈ΊɊւPȎ˒B
//                FieldScreen1->FindSingleAttackRange(RangeLayer,BaseData1,Unitp,zx,zy,System.UseGun,side);
                int maxr = unitInfo.MaxRange[System.UseGun];
                int minr = unitInfo.MinRange[System.UseGun];
                RangeLayer->InitRange();
                FieldScreen1->GetNeighborRange(zx, zy, minr, maxr+1, RangeLayer);
                megaHex = true;
            }
            // ~ԉ\Ȓn`ɋ΍~Ԕ͈͂TB
            if(unitInfo.GroundFlag[gndType] & GROUND_CAN_UNLOAD)
                FieldScreen1->GetLoadRange(RangeLayer,Map,BaseData1,SideStatus1,unitp,Situation->Phase,zx,zy);
        }
    }
    else{
        //͈͒sȂ͏Ȃƕss
        RangeLayer->InitRange();
    }

    if(megaHex){
        FieldScreen1->CurrentRangeType = FieldScreen::rtAttackRange;
    }else{
        FieldScreen1->CurrentRangeType = FieldScreen::rtAttackOrLoadRange;
    }

    if(noMove || unitInfo.SuperMissile){
        int maxr = unitInfo.GetMaxRange();
        DrawMapPartial(zx - maxr, zy - maxr, zx + maxr, zy + maxr);
        UpdateMapViewBlock(zx - maxr, zy - maxr, zx + maxr, zy + maxr);
    }else{
        DrawMapPartial(zx - 1, zy - 1, zx + 1, zy + 1);
        UpdateMapViewBlock(zx - 1, zy - 1, zx + 1, zy + 1);
    }

#if 0
    if(megaHex){
        FieldScreen1->DrawMegaAttackRange(RangeLayer);
    }
    else{
        int minr,maxr;
        BaseData1->GetUnitGunRange(type,&minr,&maxr);
        maxr = max(1,maxr);
//        FieldScreen1->DrawAttackRange(RangeLayer,Map,zx,zy,0,maxr,Situation->Phase);
    }
#endif

    Draw = !OutsideVisible(zx,zy); //ړW͕`悷邩H
    if(Draw){
#if 0
        if(unitInfop->SuperMissile){
            System.RadiusCursor = unitInfop->Radius[0];
        }else if(System.UseGun != -1){
#endif
        if(System.UseGun != -1){
            System.RadiusCursor = unitInfo.Radius[System.UseGun];
        }else{
            System.RadiusCursor = 1;
        }
#if 0
        //ړn_ɂāAKvȂeJ[\`悷B
        if(Map->Shade[zx][zy] || Map->Data[zx][zy].Side == -1){
            FieldScreen1->DrawCursorZ(zx,zy,CURSOR_MOVE);
        }
        else{
            i = SideStatus1[side].Unit[Map->Data[zx][zy].Unit].Type;
            if(type==i) //mF̃J[\
                FieldScreen1->DrawCursorZ(zx,zy,CURSOR_PLUS);
            else //ڊmF̃J[\
                FieldScreen1->DrawCursorZ(zx,zy,CURSOR_UP);
        }
#endif
        UpdateMapViewBlock(zx,zy);
    }
    return 0;
}
//---------------------------------------------------------------------------
// ol`FbNAxAbvsB
__fastcall TForm1::CheckUnitExperience(UnitStatus *unitp, const UnitChip *unitInfop)
{
    // [LŖꍇAxAbvȂB
    if(!Map->LevelUpEnabled){
        unitp->Experience = 0;
        return 0;
    }
    // ̃xꍇAol0Ŏ~߂B
    if(unitp->Level >= unitInfop->LevelMax){
        unitp->Experience = 0;
        return 0;
    }
    if(unitp->Experience >= 100){
        if(unitp->Level < unitInfop->LevelMax){
            unitp->Experience = 0;
            unitp->Level++;
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//jbgYoԂB͘_W
__fastcall TForm1::CanCreateUnit(int zx,int zy)
{
    const MapStatus& gnd = Map->GetMapStatus(zx,zy);

    if(gnd.Side != -1)
        return 0;
    if(gnd.Owner != Situation->Phase)
        return 0;
    if(!gnd.Create)
        return 0;
    return 1;
}
//---------------------------------------------------------------------------
//w肵jbgւ̕⋋\B͘_W
__fastcall TForm1::CanSupplyUnit(int zx,int zy,int side,int unitType)
{
    const MapStatus& gnd = Map->GetMapStatus(zx,zy);

    if(gnd.Owner < 0)
        return 0;
    if(side != gnd.Owner && SideStatus1[gnd.Owner].Friendly[side] <= 0)
        return 0;
    if(BaseData1->GetUnitChipByType(unitType).GroundFlag[gnd.Type] & GROUND_SUPPLY)
        return 1;
    return 0;
}
//---------------------------------------------------------------------------
// jbguiY̐VKo^CCxgɂVKjbgݒuj
// X͐Yp̊֐߁Ajbg͍sς݂ɂȂB
__fastcall TForm1::NewUnit(int zx,int zy,int side,int type)
{
    TRect rect;

    Map->GetMapStatus(zx,zy).Side = side;
    Map->GetMapStatus(zx,zy).UnitIndex = SideStatus1[side].UnitCount;
    SideStatus1[side].AddUnit(BaseData1,zx,zy,side,type);
    const UnitChip& unitInfo = BaseData1->GetUnitChipByType(type);

    if(!OutsideVisible(zx,zy)){
//        FieldScreen1->DrawUnitChipAuto(Map,SideStatus1,zx,zy,true);
        DrawMapPartial(zx, zy, zx, zy);
        UpdateMapViewBlock(zx, zy);
    }
    if(side == Situation->Phase){
        //eLTNȂ王EXV
        if(SideStatus1[Situation->Phase].LimitView && !ApplyShade){
            Map->GetShade(zx,zy) = 0; //Rjbg͏Ɍ
            UpdateLimitView(-1,0,zx,zy,&unitInfo);
            int drawr = unitInfo.Visibility;
            DrawMapPartial(zx-drawr, zy-drawr, zx+drawr, zy+drawr);
            UpdateMapViewBlock(zx-drawr, zy-drawr, zx+drawr, zy+drawr);
        }
        if(Option.UnitListNoModal && Form_UnitListp->Visible)
            Form_UnitListp->MakeList(); //\ɐVjbgǉ
    }
    return 0;
}
//---------------------------------------------------------------------------
// CxgɂIDw肵ẴjbgݒuB
__fastcall TForm1::AppendUnit_Event(int zx,int zy,int side,int id)
{
    if(SideStatus1[side].UnitCount >= Situation->UnitMax)
        return -1;
    int type = BaseData1->GetUnitTypeIndex(id);
    if(type == -1)
        return -1;
    NewUnit(zx,zy,side,type);
    SideStatus1[side].Unit[SideStatus1[side].UnitCount-1].Actioned = false;
    return 0;
}
//---------------------------------------------------------------------------
//jbg̈ړoHHB炩ߍŒZH߂ĂKvB
//͖ړI̍W̃|C^B
//GƏՓ˂AՓ˒n_̍W|C^Ɋi[ 1 ԂB
//Փ˂NȂΉ 0 ԂB
__fastcall TForm1::WalkPath(UnitStatus *Unitp,int *zx,int *zy,int *colx,int *coly)
{
    bool immediate=false, collision=false;
    int x=*zx,y=*zy,cx,cy;

    //ړI̍WoHtɒH
    for(int i=0;i<1000;i++){ //[vɂȂƂȂ̂œKȉ񐔃[v
        if(x==Unitp->X && y==Unitp->Y) //oHSHΏI
            break;
        int side = Map->GetMapStatus(x,y).Side; //oHɓG邩`FbN
        bool stop = false;
        if(side!=-1 && side!=Situation->Phase){
            stop = true;
            immediate = true;
        }else if(Map->ZOCMode && !immediate &&
                 FieldScreen1->CirculationEnemy(Map, BaseData1, SideStatus1,
                     x,y,Situation->Phase,Unitp->Type,true)){
            //ZOCAאډȅɗאړGΏՓˁB
            //oH̓GɂԂ钼OȂ炱͓KpȂ
            //iǂ݂̍WŒ~邩jB
            stop = true;
        }
        else
            immediate = false;
        if(stop){
            collision = true;
            cx = x;
            cy = y; //GAŏɂԂG̍WL^
        }
        const TPoint& p = RangeLayer->GetBack(x,y);
        x = p.x;
        y = p.y;
    }
    if(collision){
        //Ԃ̍Wi[
        *colx = cx;
        *coly = cy;
        //GƂԂ钼O̍W烆jbg̋Ȃ܂Ŗ߂
        while(Map->GetMapStatus(cx,cy).Side != -1){
            //鏊܂Ŗ߂ꍇ͂ŏI
            if(cx==Unitp->X && cy==Unitp->Y)
                break;
            const TPoint& p = RangeLayer->GetBack(cx,cy);
            cx = p.x;
            cy = p.y;
        }
        *zx = cx;
        *zy = cy;
/*
        if(Map->Data[*zx][*zy].Side != -1){
            sprintf(str,"Collision error:go(%d,%d),col(%d,%d)",ex,ey,cx,cy);
            ShowMessage(str);
        }
*/
        return 1;
    }
    return 0;
}
//---------------------------------------------------------------------------
//jbgړiMap1SideStatus1̏j
//߂l͍ǂB 1AȂ 0
__fastcall TForm1::MoveUnit(int zx,int zy,int side,int unitNum,bool Draw)
{
    SideStatus *mySide;
    UnitStatus *unitp;
    MapStatus *ground;
    bool Occupy=false,Restore=false,Loaded=false,Plused=false;
    int oldX,oldY,type,life,income,occupyPoint=0;

    mySide = &SideStatus1[side];
    unitp = &SideStatus1[side].Unit[unitNum];
    ground = &Map->GetMapStatus(zx,zy);
    type = unitp->Type;
    life = unitp->Life;
    oldX = unitp->X;
    oldY = unitp->Y;
    Map->GetMapStatus(oldX, oldY).Side = -1;
    if(ground->Side == -1){
        unitp->X=zx;
        unitp->Y=zy;
        UnitActioned(side,unitNum);
        ground->Side = side;
        ground->UnitIndex = unitNum;
    }
    else{
        int existUnit = ground->UnitIndex;
        int existType = SideStatus1[side].Unit[existUnit].Type;
        if(type==existType){
            PlusUnit(side,existUnit,unitNum);
            UnitActioned(side,existUnit);
            KillUnit(side,unitNum);
            Plused=true;
        } //
        else{
            unitp->X = -1;
            SideStatus1[side].LoadUnit(existUnit,unitNum);
            UnitActioned(side,unitNum);
            UnitActioned(side,existUnit);
            Loaded=true;
        } //
    }

    const UnitChip& unitInfo = BaseData1->GetUnitChipByType(type);
    const MapChip& gndInfo = BaseData1->GetMapChipByType(ground->Type);
    // ̏B̂K؂ȏsB
    if(!Loaded && !Plused && gndInfo.IsBuilding &&
       ground->Owner!=side && (ground->Owner==-1 || mySide->Friendly[ground->Owner]<=0) &&
       unitInfo.Occupy > 0){
        occupyPoint = life*unitInfo.Occupy/100;
        occupyPoint = min(occupyPoint, ground->Life);
        ground->Life -= occupyPoint;
        if(ground->Life == 0){
            int oldOwner = ground->Owner;
            BaseData1->InitializeMapStatus(ground,side,ground->Type);
            income = gndInfo.Income;
            SideStatus1[side].Income += income;
            if(oldOwner >= 0)
                SideStatus1[oldOwner].Income -= income;
            if(mySide->LimitView){
                FieldScreen1->FindVisible(Map, zx, zy, gndInfo.Visibility+1, 1);
            }
        }
        Occupy=true;
    }
    // ϋvx̉񕜏B
    if(!Loaded && !Plused && !Occupy && ground->Owner==side &&
       unitInfo.Repair > 0){
        occupyPoint = life*unitInfo.Repair/100;
        occupyPoint = min(occupyPoint, gndInfo.LifeMax - ground->Life);
        ground->Life += occupyPoint;
        Restore=true;
    }
    if(Draw && !OutsideVisible(zx,zy)){
        if(Plused){
            FieldScreen1->AddSpriteZ(zx, zy, TSpriteOnMap::stCursor, CURSOR_PLUSED);
            DrawMapPartial(zx, zy, zx, zy);
            UpdateMapViewBlock(zx, zy);
            DamageWait(WAIT_SHOWPLUS);
        }
        if(Occupy){
            FieldScreen1->AddSpriteZ(zx, zy, TSpriteOnMap::stValue, COLOR_OCCUPY, occupyPoint);
            DrawMapPartial(zx, zy, zx, zy);
            UpdateMapViewBlock(zx, zy);
            DamageWait(WAIT_SHOWOCCUPY);
        }
        if(Restore && occupyPoint){
            FieldScreen1->AddSpriteZ(zx, zy, TSpriteOnMap::stValue, COLOR_RESTORE, occupyPoint);
            DrawMapPartial(zx, zy, zx, zy);
            UpdateMapViewBlock(zx, zy);
            DamageWait(WAIT_SHOWOCCUPY);  //EFCgl͋ʁB
        }
        FieldScreen1->ClearSpriteList();
        DrawMapPartial(zx, zy, zx, zy);
        UpdateMapViewBlock(zx, zy);
    }
    return (int)Plused;
}
//---------------------------------------------------------------------------
//jbg鎞Ac鑤ibaseUnitjLifeƔReXVB
__fastcall TForm1::PlusUnit(int side,int baseUnit,int plusUnit)
{
    UnitStatus *baseUnitp,*plusUnitp;

    baseUnitp = &SideStatus1[side].Unit[baseUnit];
    plusUnitp = &SideStatus1[side].Unit[plusUnit];

    baseUnitp->Life += plusUnitp->Life;
    //Re͑̒lɂȂB
    for(int i=0;i<GUN_MAX;i++){
        baseUnitp->GunRest[i] = max(baseUnitp->GunRest[i], plusUnitp->GunRest[i]);
        baseUnitp->Level = max(baseUnitp->Level, plusUnitp->Level);
        baseUnitp->Experience = max(baseUnitp->Experience, plusUnitp->Experience);
    }
    baseUnitp->Fuel = max(baseUnitp->Fuel, plusUnitp->Fuel);

    if(Option.UnitListNoModal && Form_UnitListp->Visible && !System.CPUMinding)
        Form_UnitListp->MakeList();
    return 0;
}
//---------------------------------------------------------------------------
//jbg~ԂB
//zx,zy͍~ԂʒuASideLoader͖ړĨjbgςł郆jbgB
//܂~Ԃꂽjbg̎EB
__fastcall TForm1::DownUnit(int zx,int zy,int side,int loader,bool Draw)
{
    UnitStatus *unitp,*loaderp;
//    UnitChip *unitInfop;
//    TRect rect;
    int unitNum,loadIndex;

    loaderp = &SideStatus1[side].Unit[loader];
    loadIndex = SelectDownUnit(zx,zy,side,loaderp);
    //~Ԃ郆jbg͉ȂB
    if(loadIndex == -1){
        ShowMessage("ɍ~Ԃł郆jbg܂");
        return -1;
    }
    unitNum = loaderp->LoadingUnit[loadIndex];
    // ~Ԃ郆jbg𓋍ڃXg폜B
    for(int i=loadIndex; i<loaderp->Load-1; i++){
        loaderp->LoadingUnit[i] = loaderp->LoadingUnit[i+1];
    }
    loaderp->Load--;
    Map->GetMapStatus(zx,zy).Side = side;
    Map->GetMapStatus(zx,zy).UnitIndex = unitNum;
    unitp = &SideStatus1[side].Unit[unitNum];
    unitp->X = zx;
    unitp->Y = zy;
    if(Draw){
        UnitActioned(side,unitNum);
        DrawMapPartial(zx, zy, zx, zy);
        if(SideStatus1[Situation->Phase].LimitView){
            const UnitChip& unitInfo = BaseData1->GetUnitChipByType(unitp->Type);
            UpdateLimitView(-1, 0, zx, zy, &unitInfo);
            int v = unitInfo.Visibility;
            DrawMapPartial(zx-v, zy-v, zx+v, zy+v);
            UpdateMapViewBlock(zx-v, zy-v, zx+v, zy+v);
        }
    }
    else{
        unitp->Actioned=true;
    }
    return 0;
}
//---------------------------------------------------------------------------
// w肵n_Ƀjbg~Ԃł邩B
// ͘_WAڑUnitStatus̃|C^B
// ~Ԃłꍇ͂̓ڔԍA~Ԃł郆jbgȂ -1 ԂB
__fastcall TForm1::SelectDownUnit(int zx,int zy,int side,UnitStatus *unitp)
{
    int i,gndType,type;

    gndType = Map->GetMapStatus(zx,zy).Type;
    for(i=0; i<unitp->Load; i++){
        type = SideStatus1[side].Unit[unitp->LoadingUnit[i]].Type;
        const UnitChip& targetInfo = BaseData1->GetUnitChipByType(type);
        if(targetInfo.GroundFlag[gndType] & GROUND_CAN_ALIGHT){
            return i;
        }
    }
    return -1;
}
//---------------------------------------------------------------------------
//jbgB}[NEFCgtŕ\
__fastcall TForm1::DisposalUnit(int Side,int UnitNum)
{
    int zx,zy,type;

    UnitXY(Side,UnitNum,&zx,&zy);
    type = SideStatus1[Side].Unit[UnitNum].Type;
//    FieldScreen1->DrawCursorZ(zx,zy,CURSOR_KILLED);
    FieldScreen1->AddSpriteZ(zx, zy, TSpriteOnMap::stCursor, CURSOR_KILLED);
    DrawMapPartial(zx, zy, zx, zy);
    UpdateMapViewBlock(zx, zy);
    DamageWait(WAIT_SHOWKILL);
//    DrawMapChip(zx,zy);
    if(SideStatus1[Side].LimitView)
        UpdateLimitView(zx,zy,-1,0, &BaseData1->GetUnitChipByType(type));
    KillUnit(Side,UnitNum);
    FieldScreen1->ClearSpriteList();
    DrawMapPartial(zx, zy, zx, zy);
    UpdateMapViewBlock(zx,zy);
    return 0;
}
//---------------------------------------------------------------------------
// Cxgɂ郆jbg̍폜B
__fastcall TForm1::RemoveUnit_Event(int zx,int zy)
{
    int side,num,type;

    side = Map->GetMapStatus(zx,zy).Side;
    if(side == -1)
        return -1;
    num  = Map->GetMapStatus(zx,zy).UnitIndex;
    type = SideStatus1[side].Unit[num].Type;
    if(side == Situation->Phase && SideStatus1[side].LimitView)
        UpdateLimitView(zx,zy,-1,0, &BaseData1->GetUnitChipByType(type));
    KillUnit(side,num);
    return 0;
}
//---------------------------------------------------------------------------
//jbg폜B
//}bv̍XVAf[^̍폜AɕKvȂ畔\̍XVsB
__fastcall TForm1::KillUnit(int side,int unitNum)
{
    int zx,zy;

    UnitXY(side,unitNum,&zx,&zy);
    Map->GetMapStatus(zx,zy).Side=-1;
    SideStatus1[side].DeleteUnit(Map,side,unitNum);
    if(side==Situation->Phase && !System.CPUMinding &&
       Option.UnitListNoModal && Form_UnitListp->Visible)
        Form_UnitListp->MakeList();
    return 0;
}
//---------------------------------------------------------------------------
// 퓬ɕwc̃jbgSč폜A{݂𒆗ɂB
__fastcall TForm1::KillSide(int side)
{
    int mw = Map->GetWidth();
    int mh = Map->GetHeight();
    for(int y=0;y<mh;y++){
        for(int x=0;x<mw;x++){
            MapStatus& gnd = Map->GetMapStatus(x, y);
            if(gnd.Owner == side){
                gnd.Owner = -1;
            }
            if(gnd.Side == side){
                gnd.Side = -1;
            }
        }
    }
    BaseData1->ApplyIDToAll(Map, SideStatus1);
    SideStatus1[side].UnitCount = 0;
    DrawAllAndUpdateMapView();
    return 0;
}
//---------------------------------------------------------------------------
//jbgsς݂ɂ
__fastcall TForm1::UnitActioned(int side,int unitNum)
{
    SideStatus1[side].Unit[unitNum].Actioned = true;
    if(Option.UnitListNoModal && Form_UnitListp->Visible && !System.CPUMinding)
        UnitListRevise(unitNum);
    return 0;
}
//---------------------------------------------------------------------------
// _[W{olZoB
__fastcall TForm1::GetAttackBaseExperience(const UnitStatus *unitA, const UnitStatus *unitT, int damage)
{
    const UnitChip& unitInfoA = BaseData1->GetUnitChipByType(unitA->Type);
    const UnitChip& unitInfoT = BaseData1->GetUnitChipByType(unitT->Type);
    double valueA = max(unitInfoA.Value, 100);
    double valueT = unitInfoT.Value;
    valueA = valueA/2 + (valueA/3)*unitA->Level;
    valueT = valueT/2 + (valueT/3)*unitT->Level;
    bool death = damage > unitT->Life;
    double ratio = sqrt(valueT/valueA);

    double exp = ratio*damage;
    if(death)
        exp += ratio*20;
    return static_cast<int>(exp)/2;
}
//---------------------------------------------------------------------------
//퓬i_[WvZAeECtASŃjbg폜j
__fastcall TForm1::UnitBattle(int attackSide,int attackNum,int targetSide,int targetNum,bool Draw)
{
    int ax,ay,tx,ty,aDraw,tDraw,
        damageA,damageT,gunTypeA,gunTypeT;

    UnitXY(targetSide,targetNum,&tx,&ty); //̏Aŋ߂Kv͖
    UnitXY(attackSide,attackNum,&ax,&ay);
    UnitStatus *unitA = &SideStatus1[attackSide].Unit[attackNum];
    UnitStatus *unitT = &SideStatus1[targetSide].Unit[targetNum];
    //AttackRangeSelect()QƂ̂ƁB
    int gunFlagA = RangeLayer->GetRangeValue(unitT->X, unitT->Y);
    CalcBattle(unitA, unitT, gunFlagA, &damageA, &damageT, &gunTypeA, &gunTypeT, Option.DamageFix);

    unitA->GunRest[gunTypeA]--;
    if(gunTypeT != -1){
        unitT->GunRest[gunTypeT]--;
    }

    if(Draw){
        aDraw = !OutsideVisible(ax,ay); //ꂼ`ׂǂ߂
        tDraw = !OutsideVisible(tx,ty);
        //ꂽU_[W\
        if(gunTypeT != -1 && aDraw){
            FieldScreen1->AddSpriteZ(ax, ay, TSpriteOnMap::stValue, COLOR_DAMAGE, damageA);
            DrawMapPartial(ax, ay, ax, ay);
            UpdateMapViewBlock(ax, ay);
        }
        if(tDraw){
            FieldScreen1->AddSpriteZ(tx, ty, TSpriteOnMap::stValue, COLOR_DAMAGE, damageT);
            DrawMapPartial(tx, ty, tx, ty);
            UpdateMapViewBlock(tx, ty);
        }
        DamageWait(WAIT_SHOWDAMAGE);
        FieldScreen1->ClearSpriteList();
        if(gunTypeT != -1 && aDraw){
            DrawMapPartial(ax, ay, ax, ay);
            UpdateMapViewBlock(ax, ay);
        }
        if(tDraw){
            DrawMapPartial(tx, ty, tx, ty);
            UpdateMapViewBlock(tx, ty);
        }
    }

    if(gunTypeT != -1){
        SideStatus1[attackSide].DisLife(attackNum,damageA);
        //U͏ɑ쑤Ȃ̂ŁB\̓eXV
        if(Option.UnitListNoModal && Form_UnitListp->Visible && !System.CPUMinding){
            UnitListRevise(attackNum);
        }
        // ̌olB͂CheckUnitExperience()B
        int exp = GetAttackBaseExperience(unitT, unitA, damageA)/2;
        unitT->Experience += max(exp, 1);
        CheckUnitExperience(unitT, &BaseData1->GetUnitChipByType(unitT->Type));
    }
    SideStatus1[targetSide].DisLife(targetNum,damageT);
    // olB
    int exp = GetAttackBaseExperience(unitA, unitT, damageT);
    if(gunTypeT == -1)  // ԐڍȔꍇ͔B
        exp /= 2;
    unitA->Experience += max(exp, 1);

    UpdateDamagedUnit(targetSide,targetNum,tx,ty,Draw);
    UpdateDamagedUnit(attackSide,attackNum,ax,ay,Draw);
    return 0;
}
//---------------------------------------------------------------------------
// 퓬̌ʂvZBł͌vZ邾Œl̕ύX͈؍sȂB
__fastcall TForm1::CalcBattle(const UnitStatus *unitA, const UnitStatus *unitT, int gunFlagA,
    int *damageA, int *damageT, int *gunTypeA, int *gunTypeT, bool damageFix) const
{
    *damageT = FieldScreen1->CalcDamage(Map, BaseData1, unitA, unitT, gunTypeA, gunFlagA, false, Map->IgnoreLife, damageFix);
    //ł邩ǂ̔B
    const UnitChip& unitInfoT = BaseData1->GetUnitChipByType(unitT->Type);
    *gunTypeT = FieldScreen1->CanCounter(unitA, unitT, unitInfoT);
    if(*gunTypeT != -1){
        int gunFlagT = (1<<(*gunTypeT));
        *damageA = FieldScreen1->CalcDamage(Map, BaseData1, unitT, unitA, gunTypeT, gunFlagT, true, Map->IgnoreLife, damageFix);
    }
    else{
        *damageA = 0;
    }
    return 0;
}
//---------------------------------------------------------------------------
//UnitBattle()̃KwNXŁBlȂB
__fastcall TForm1::UnitBattleMegaHex(int attackSide,int attackNum,int center_x,int center_y,int gunType,bool Draw)
{
    UnitStatus *attackUnit = &SideStatus1[attackSide].Unit[attackNum];
    UnitStatus attackUnitStatus;
    const UnitChip& unitInfo = BaseData1->GetUnitChipByType(attackUnit->Type);
    POINT list[1024];
    int exp=0;

    attackUnitStatus = *attackUnit;
    attackUnit->GunRest[gunType]--;
    int count = FieldScreen1->GetNeighborList(center_x,center_y,0,unitInfo.Radius[gunType],Map->GetWidth(),Map->GetHeight(),list,1024);
    for(int i=0;i<count;i++){
        exp += AttackNoCounter(attackSide,&attackUnitStatus,list[i].x,list[i].y,gunType,Draw);
    }
    int maxr;
    if(unitInfo.SuperMissile){
        maxr = unitInfo.Radius[0];
    }
    else{
        maxr = unitInfo.MaxRange[gunType];
    }
    // łĂȂ΁AolZBA̔@͂܂B
    // VAŐwc񂩂ׂB
    if(attackUnit->Serial == attackUnitStatus.Serial){
        attackUnit->Experience += max(exp, 1);
    }
    if(Draw){
        FieldScreen1->ClearSpriteList();
        DrawMapPartial(center_x-maxr, center_y-maxr, center_x+maxr, center_y+maxr);
        UpdateMapViewBlock(center_x-maxr, center_y-maxr, center_x+maxr, center_y+maxr);
    }
    return 0;
}
//---------------------------------------------------------------------------
// ߂l͌olBattackUnit͈ꎞCX^XAKwNXUŎł邩Ȃ̂
// ŉZ͂łȂB
__fastcall TForm1::AttackNoCounter(int attackSide,UnitStatus *attackUnit,int tx,int ty,int gunType,bool Draw)
{
    bool tDraw;
    int damage,targetType;
    const MapStatus& ground = Map->GetMapStatus(tx,ty);
    int targetSide = ground.Side;
    if(targetSide == -1)
        return 0;
    int targetNum = ground.UnitIndex;
    //UnitStatus *attackUnit = &SideStatus1[attackSide]->Unit[attackNum];
    UnitStatus *targetUnit = &SideStatus1[targetSide].Unit[targetNum];
    targetType = targetUnit->Type;

    damage = FieldScreen1->CalcDamage(Map, BaseData1, attackUnit, targetUnit, &gunType, 1<<gunType, false, Map->IgnoreLife, Option.DamageFix);
    if(Draw){
        //`ׂǂ߂
        tDraw = !OutsideVisible(tx,ty);
        if(tDraw){
            FieldScreen1->AddSpriteZ(tx, ty, TSpriteOnMap::stValue, COLOR_DAMAGE, damage);
            DrawMapPartial(tx, ty, tx, ty);
            UpdateMapViewBlock(tx, ty);
        }
        DamageWait(WAIT_SHOWDAMAGE);
        if(tDraw){
            //EÕjbgɍUꍇ̓_[Ŵݕ\A
            //̌etn`ɖ߂B
            DrawMapPartial(tx, ty, tx, ty);
            UpdateMapViewBlock(tx,ty);
        }
    }

    SideStatus1[targetSide].DisLife(targetNum,damage);
    if(UpdateDamagedUnit(targetSide,targetNum,tx,ty,tDraw)){
        //R̃jbgUďłꍇAEXVB
        if(targetSide == attackSide &&
           SideStatus1[attackSide].LimitView){
            UpdateLimitView(tx,ty,-1,0,&BaseData1->GetUnitChipByType(targetType));
        }
    }

    // olB
    int exp = GetAttackBaseExperience(attackUnit, targetUnit, damage)/4;
    return exp;
}
//---------------------------------------------------------------------------
//_[W󂯁Ał\̂郆jbgɂāA
//ʋyѕ\̍XVsB
//łĂꍇ߂l1AłȂ0
__fastcall TForm1::UpdateDamagedUnit(int side,int unitnum,int unitx,int unity,bool bDraw)
{
    if(SideStatus1[side].Unit[unitnum].Life > 0)
        return 0;
    KillUnit(side,unitnum);
    if(bDraw){
//        if(DrawMapChip(unitx,unity))
//            UpdateMapViewBlock(unitx,unity);
        DrawMapPartial(unitx, unity, unitx, unity);
        UpdateMapViewBlock(unitx, unity);
    }
    return 1;
}
//---------------------------------------------------------------------------
//jbgړEŁEoƂɎEXVčĕ`悷
//decx,decÿʒu王E炵Aincx,incÿʒu王EB
__fastcall TForm1::UpdateLimitView(int decx,int decy,int incx,int incy,const UnitChip *UnitInfop)
{
    if(decx != -1)
        FieldScreen1->FindVisible(Map,decx,decy,UnitInfop->Visibility+1,-1);
    if(incx != -1)
        FieldScreen1->FindVisible(Map,incx,incy,UnitInfop->Visibility+1,1);
    if(!ApplyShade){
        UpdateShade();
        DrawAllAndUpdateMapView();
    }
    return 0;
}
//---------------------------------------------------------------------------
//Shade  Visible ƖĂ鏊 Shade XVB
__fastcall TForm1::UpdateShade(void)
{
    int px,py;

    int mw = Map->GetWidth();
    int mh = Map->GetHeight();
    for(int y=0;y<mh;y++){
        for(int x=0;x<mw;x++){
            if(Map->GetShade(x,y)){
                if(Map->GetVisible(x,y)){
                    Map->GetShade(x,y) = 0;
                }
            }
            else{
                if(!Map->GetVisible(x,y)){
                    Map->GetShade(x,y) = 1;
                }
            }
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
// S`悩S]B̏͂ƂĂ̂ŁB
__fastcall TForm1::DrawAllAndUpdateMapView(void)
{
    DrawAll();
    UpdateMapViewAll();
    FieldScreen1->DrawViewportToTCanvas(Image_Viewport->Canvas, Image_Viewport->Width, Image_Viewport->Height);
    Image_Viewport->Refresh();
    return 0;
}
//---------------------------------------------------------------------------
// }bv\Ŝ`悷B
__fastcall TForm1::DrawAll(void)
{
    UnitStatus *holdUnit = NULL;

    if(System.HoldUnit != -1){
        holdUnit = &SideStatus1[Situation->Phase].Unit[System.HoldUnit];
    }
    FieldScreen1->DrawMap(Map, RangeLayer, holdUnit, SideStatus1);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::DrawMapPartial(int zx, int zy)
{
    return DrawMapPartial(zx, zy, zx, zy);
}
//---------------------------------------------------------------------------
// }bv̈ꕔXV`悷B
__fastcall TForm1::DrawMapPartial(int zx1, int zy1, int zx2, int zy2)
{
    UnitStatus *holdUnit = NULL;

    if(System.HoldUnit != -1){
        holdUnit = &SideStatus1[Situation->Phase].Unit[System.HoldUnit];
    }
    FieldScreen1->DrawMap(Map, RangeLayer, holdUnit, SideStatus1, zx1, zy1, zx2, zy2);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::DrawMapPartial(const TRect& r)
{
    return DrawMapPartial(r.Left, r.Top, r.Right, r.Bottom);
}
//---------------------------------------------------------------------------
// FieldScreeñrbg}bvImage1ɓ]B
__fastcall TForm1::UpdateMapViewAll(void)
{
    if(!NowRunning)
        return 0;
    FieldScreen1->DrawScrollBars();
    FieldScreen1->CopyToTCanvas(Image_Map->Canvas);

    const TSize& s = FieldScreen1->GetViewportOuterSize();
    if(Image_Map->Width > s.cx){
        Image_Map->Canvas->Brush->Color = clBlack;
        Image_Map->Canvas->FillRect(TRect(s.cx, 0, Image_Map->Width, Image_Map->Height));
    }
    if(Image_Map->Height > s.cy){
        Image_Map->Canvas->Brush->Color = clBlack;
        Image_Map->Canvas->FillRect(TRect(0, s.cy, Image_Map->Width, Image_Map->Height));
    }
    return 0;
}
//---------------------------------------------------------------------------
//}bv摜̈ꕔXViRectŁj
__fastcall TForm1::UpdateMapView(const TRect& r)
{
    if(System.NoDraw) //\ʏ`悪Ȃ
        return 0;
    FieldScreen1->CopyToTCanvas(Image_Map->Canvas, r);
    return 0;
}
//---------------------------------------------------------------------------
// }bv摜PubNXVi_WŎwj
__fastcall TForm1::UpdateMapViewBlock(int zx, int zy)
{
    int x,y;

    FieldScreen1->XY_MapToPhy(zx,zy,&x,&y);
    UpdateMapView(TRect(x,y,x+FieldScreen1->GraphDegree,y+FieldScreen1->GraphDegree));
    return 0;
}
//---------------------------------------------------------------------------
// }bv摜XVi_WŎwj
__fastcall TForm1::UpdateMapViewBlock(int zx1, int zy1, int zx2, int zy2)
{
    int x1, y1, x2, y2;

    FieldScreen1->XY_MapToPhy(zx1, zy1, &x1, &y1);
    FieldScreen1->XY_MapToPhy(zx2, zy2, &x2, &y2);
    UpdateMapView(TRect(x1 - FieldScreen1->GraphDegree/2, y1, x2 + FieldScreen1->GraphDegree + FieldScreen1->GraphDegree/2, y2 + FieldScreen1->GraphDegree));
    return 0;
}
//---------------------------------------------------------------------------
// }bv摜PubNXVi_WŎwj
__fastcall TForm1::UpdateMapViewBlock(const TRect& r)
{
    UpdateMapViewBlock(r.Left, r.Top, r.Right, r.Bottom);
    return 0;
}
//---------------------------------------------------------------------------
//w肵WɍU͈̓J[\`ĉʂXVB
__fastcall TForm1::DrawAttackRadius(int x,int y,int radius)
{
    POINT plist[256];

    int count = FieldScreen1->GetNeighborList(x, y, 0, radius, Map->GetWidth(), Map->GetHeight(), plist, 256);
    for(int i=0;i<count;i++){
        FieldScreen1->AddSpriteZ(plist[i].x, plist[i].y, TSpriteOnMap::stCursor, CURSOR_ATTACK, 0, SPRITELAYER_RADIUSCURSOR);
    }

    int r = radius - 1;
    DrawMapPartial(x-r, y-r, x+r, y+r);
    UpdateMapViewBlock(x-r, y-r, x+r, y+r);
    System.LastDrawedRadius.x = x;
    System.LastDrawedRadius.y = y;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::EraseAttackRadius(void)
{
    FieldScreen1->ClearSpriteList(SPRITELAYER_RADIUSCURSOR);
    int x = System.LastDrawedRadius.x;
    int y = System.LastDrawedRadius.y;
    int r = System.RadiusCursor - 1;
    DrawMapPartial(x-r, y-r, x+r, y+r);
    UpdateMapViewBlock(x-r, y-r, x+r, y+r);
    return 0;
}
//---------------------------------------------------------------------------
// SĂ̐wcbotł邩ǂB
__fastcall TForm1::ComputerOnly(void)
{
    for(int side=0;side<BaseData1->Sides;side++){
        if(SideStatus1[side].Valid && !SideStatus1[side].IsComputer){
            return 0;
        }
    }
    return 1;
}
//---------------------------------------------------------------------------
//wWił邾jSɂȂ悤ɃXN[
__fastcall TForm1::SysAutoScroll(int zx,int zy)
{
    int px, py;

    FieldScreen1->XY_MapToPhy(zx, zy, &px, &py);
    const TSize& insize = FieldScreen1->GetViewportInnerSize();
    SetViewportLeftTop(px - insize.cx/2, py - insize.cy/2);
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::SetViewportLeftTop(int x, int y)
{
    FieldScreen1->SetViewportLeftTop(x, y);
    DrawAllAndUpdateMapView();
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::SlideViewport(int x, int y)
{
    FieldScreen1->SlideViewport(x, y);
    DrawAllAndUpdateMapView();
    return 0;
}
//---------------------------------------------------------------------------
/*__fastcall TForm1::DrawViewport(void)
{
    const TPoint& leftTop = FieldScreen->GetViewportLeftTop();
    const TSize& innerSize = FieldScreen->GetViewportInnerSize();

    

    return 0;
}*/
//---------------------------------------------------------------------------
//EFCgBPʂ̓~biCLK_TCK萔ɂj
__fastcall TForm1::TimeWait(int Time)
{
    clock_t clk;

    clk=clock();
    System.Controlable=false; //ꎞIɃAv̎s~
    while(clock()<clk+Time)
        Application->ProcessMessages();
    System.Controlable=true;
    return 0;
}
//---------------------------------------------------------------------------
//_[W\pEFCg
__fastcall TForm1::DamageWait(int Time)
{
    if(!System.NoDraw)
        TimeWait(Time*Option.DamageWaitFix/100);
    return 0;
}
//---------------------------------------------------------------------------
//jbgQƃEFCg
__fastcall TForm1::LookUpWait(int Time)
{
    TimeWait(Time*Option.LookUpWaitFix/100);
    return 0;
}
//---------------------------------------------------------------------------
//botpEFCg
__fastcall TForm1::CPUWait(int Time)
{
    if(!System.StopDemand && !System.NoDraw)
        TimeWait(Time*Option.CPUWaitFix/100);
    return 0;
}
//---------------------------------------------------------------------------
//bot̃jbgY zx,zy:YW Graph:Yjbg
__fastcall TForm1::ComCreateUnit(int zx,int zy,int type)
{
    if(!CanCreateUnit(zx,zy)){
        PrintError("CPUٰݴװ:Wrong Create");
        return -1;
    }
    if(SideStatus1[Situation->Phase].UnitCount >= Situation->UnitMax){
        return -1;
    }
    const UnitChip& unitInfo = BaseData1->GetUnitChipByType(type);
    MoneyOperation(Situation->Phase, -unitInfo.Value);
    NewUnit(zx,zy,Situation->Phase,type);
    CPUWait(WAIT_SHOWCREATE);
    return 0;
}
//---------------------------------------------------------------------------
//bot샂[h
__fastcall TForm1::ComputerControl(void)
{
    System.CPUControl=true;
    ProgressBar_CPU->Visible=true;
    System.CPUOperationMode=true;

    System.NoDraw = Option.CPUNoGrp;
    // eLTN[hŃvC[݂鎞
    // `Gwc̎E̋yԔ͈͂ɐB
    // vC[̎́uOɑvC[̎EvɂȂB
    // ̓eLTNł邩ǂwc̃tOŔfĂB
    if((!ComputerOnly() || DEBUG_SHADE) &&
       SideStatus1[Situation->Phase].LimitView){
        ApplyShade = true;
        FieldScreen1->RangeLimit = true;
    }

    // [hɎsĂꍇAĂяoȂB
    if(SideStatus1[Situation->Phase].LuaState_Com != NULL){
        KSLua_CallFunction(SideStatus1[Situation->Phase].LuaState_Com, "ks_on_side_operation");
        while(!lua_resume(SideStatus1[Situation->Phase].LuaState_Com, 0)){
            if(System.StopDemand)
                break;
        }
    }

    ProgressBar_CPU->Visible = false;
    ProgressBar_CPU->Position = 0;
    if(System.StopDemand){  //fv̌Ăяo
        DemandExec();
        return 0;
    }

    //`悵ĂȂ\ΑSĕ`
    if(System.NoDraw){
        DrawAllAndUpdateMapView();
        System.NoDraw = false;
    }

    System.CPUOperationMode=false;
    PhaseEndExec(false);
    System.CPUControl = false;
    ApplyShade = false;
    FieldScreen1->RangeLimit = false;

    return 0;
}
//---------------------------------------------------------------------------
//bot쒆f̗vĂяo
__fastcall TForm1::DemandExec(void)
{
    switch(System.NowDemand){
    case DEMAND_OPEN:
        MIOpenClick(NULL);
        break;
    case DEMAND_SAVE:
        MISaveClick(NULL);
        break;
    case DEMAND_LOAD:
        MILoadClick(NULL);
        break;
    }
    System.StopDemand=false;
    System.NowDemand=DEMAND_NONE;
    return 0;
}
//---------------------------------------------------------------------------
//
__fastcall TForm1::GameEndJudge(void)
{
    int side,winner=-1, exist=0;

    for(side=0;side<BaseData1->Sides;side++){
        if(!SideStatus1[side].Valid || SideStatus1[side].Lost)
            continue;
        if(!HasCapital(side)){
            SideStatus1[side].Lost = true;
        }
        if(!SideStatus1[side].UnitCount &&
           (Situation->Turn>0 || side<Situation->Phase)){
            SideStatus1[side].Lost = true;
        }
    }
    vector<int> hasEnemy(BaseData1->Sides);
    hasEnemy.assign(BaseData1->Sides, 0);
    for(side=0;side<BaseData1->Sides;side++){
        if(!SideStatus1[side].Valid)
            continue;
        hasEnemy[side] = false;
        if(!SideStatus1[side].Lost){
            exist++;
            for(int i=0;i<BaseData1->Sides;i++){
                if(i!=side && !SideStatus1[i].Lost &&
                   SideStatus1[i].Valid &&
                   SideStatus1[side].Friendly[i] <= 0){
                    hasEnemy[side] = true;
                    break;
                }
            }
            if(!hasEnemy[side])
                winner = side;
        }
        else{
            // ɖłłĂxĂ܂肪B
            KillSide(side);
            /*char msg[64];
            sprintf(msg, "%s͖łт܂B", BaseData1->SideName[side].c_str());
            ShowMessage(msg);*/
        }
    }
    if(winner!=-1 || exist==0){
        TForm_Report *dialog = new TForm_Report(this);
        TStrings *lines = dialog->Memo_Report->Lines;
        lines->Clear();
        AnsiString str;
        if(winner != -1){
            AnsiString winstr;
            for(int i=0;i<BaseData1->Sides;i++){
                if(i==winner || SideStatus1[winner].Friendly[i]>0){
                    if(!winstr.IsEmpty())
                        winstr.cat_sprintf("C");
                    winstr.cat_sprintf("%s", BaseData1->SideName[i].c_str());
                }
            }
            str.cat_sprintf("퓬F%s̏\n", winstr.c_str());
            lines->Append(str);
        }
        else{
            lines->Append("퓬FSwcS");
        }
        str.sprintf("^[F%d\n", Situation->Turn);
        lines->Append(str);
        for(int i=0;i<BaseData1->Sides;i++){
            str.sprintf("c(%s)F%d\n", BaseData1->SideName[i].c_str(), SideStatus1[i].UnitCount);
            lines->Append(str);
        }
        dialog->ShowModal();
        System.GameEnd=true;
        Enabled_PhaseEnd(false);
        delete dialog;
        return 1;
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::HasCapital(int side)
{
    int gcount = BaseData1->GetGroundTypeCount()-1;
    for(int gndType=0; gndType<gcount; gndType++){
        const MapChip& gndInfo = BaseData1->GetMapChipByType(gndType);
        if(gndInfo.IsCapital){
            if(Map->HasMapChip(side, gndInfo.ID) > 0){
                return 1;
            }
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
// tFCYIBۂɂ͊JnĂB
// bRemote=trueȂł̃tFCY̐ؑւ̂ݍsB
__fastcall TForm1::PhaseEndExec(bool bRemote)
{
    int oldPhase,newPhase,end;

    end = GameEndJudge();
    oldPhase = Situation->Phase;
    newPhase = oldPhase+1;
    for(;;){
        if(newPhase >= BaseData1->Sides)
            newPhase = 0;
        if(!end && newPhase == oldPhase){
            ShowMessage("G[FLȐwc܂iQ[ĨoOHj");
            break;
        }
        if(SideStatus1[newPhase].Valid && !SideStatus1[newPhase].Lost)
            break;
        newPhase++;
    }
    SideStatus1[oldPhase].EndClear();
    // 񍐕B
    AnsiString reportOnStart;
    vector<int> serials;
    if(bRemote){
        Situation->Phase = newPhase;
        PhaseStart(reportOnStart, serials);
        return 0;
    }

    // eLTNȂ王ES߂B
    if(SideStatus1[newPhase].LimitView){
        //FieldScreen1->FindVisibleAll(Map,BaseData1,&SideStatus1[newPhase],newPhase);
        FieldScreen1->FindVisibleAll(Map, BaseData1, SideStatus1, newPhase);
        // lԑCPU̎CPȖȂB
        // lԂꍇɂbotɃtF[Y؂ւ鎞͎EXVȂB
        if(!((!ComputerOnly() && SideStatus1[newPhase].IsComputer) ||
             (Debug_Shade && newPhase))){
            UpdateShade();
        }
    }else{
        Map->InitVisible(1);
    }

    UpdateMapViewAll();
    if(end)
        return 0;

    Situation->Phase = newPhase;
    if(newPhase < oldPhase){
        Situation->Turn++;
    }
    int income = SideStatus1[newPhase].Income;
    int oldMoney = SideStatus1[newPhase].Money;
    SysAutoScroll(SideStatus1[newPhase].PhaseStartX, SideStatus1[newPhase].PhaseStartY);
    if(PhaseStart(reportOnStart, serials) == -1)
        return -1;
    int newMoney = SideStatus1[newPhase].Money;
    if(Debug_Check)
        CheckSituation();
    // CPUlԂɐ؂ւƂ́ARg[̍XVƃ_CAO̕\B
    if(!System.GameEnd &&
       ((SideStatus1[oldPhase].IsComputer && !SideStatus1[newPhase].IsComputer) || !reportOnStart.IsEmpty())){
        if(Option.CPUSound)
            MessageBeep(MB_ICONASTERISK);
        int outgo = oldMoney + income - newMoney;
        char str[256];
        TForm_Report *dialog = new TForm_Report(this);
        TStrings *lines = dialog->Memo_Report->Lines;
        lines->Clear();
        sprintf(str,"%d^[  %s sJn", Situation->Turn, BaseData1->SideName[newPhase].c_str());
        lines->Append(str);
        lines->Append("");
        sprintf(str,"@@F%6d", income);
        lines->Append(str);
        sprintf(str,"⋋pF%6d", outgo);
        lines->Append(str);
        sprintf(str,"@@F%6d", newMoney);
        lines->Append(str);
        lines->Append("");
        lines->Append(reportOnStart);

        dialog->ShowModal();
        delete dialog;
        //ShowMessage("tFCYI");
        Enabled_PhaseEnd(true);
        Enabled_More(true);
    }
    // ŁEvEėjbg폜B
    if(!serials.empty()){
        for(vector<int>::const_iterator itr=serials.begin(); itr!=serials.end(); itr++){
            int unum = SideStatus1[newPhase].GetUnitBySerial(*itr);
            const UnitStatus& unit = SideStatus1[newPhase].Unit[unum];
            const UnitChip& unitInfo = BaseData1->GetUnitChipByType(unit.Type);
            MapStatus& gnd = Map->GetMapStatus(unit.X, unit.Y);
            if(!SideStatus1[newPhase].IsComputer || !Option.CPUNoGrp){
                // ŁEvEėAj[V\B
                SysAutoScroll(unit.X, unit.Y);
                for(int i=0;i<3;i++){
                    FieldScreen1->AddSpriteZ(unit.X, unit.Y, TSpriteOnMap::stMapChip, gnd.Graphic);
                    DrawMapPartial(unit.X, unit.Y);
                    UpdateMapViewBlock(unit.X, unit.Y);
                    LookUpWait(WAIT_SHOWLOOKUP);
                    FieldScreen1->ClearSpriteList();
                    DrawMapPartial(unit.X, unit.Y);
                    UpdateMapViewBlock(unit.X, unit.Y);
                    LookUpWait(WAIT_SHOWLOOKUP);
                }
                int crashIndex = unitInfo.ANFType * 10;
                for(int i=0;i<8;i++){
                    FieldScreen1->AddSpriteZ(unit.X, unit.Y, TSpriteOnMap::stMapChip, gnd.Graphic);
                    FieldScreen1->AddSpriteZ(unit.X, unit.Y, TSpriteOnMap::stCrash, crashIndex+i);
                    DrawMapPartial(unit.X, unit.Y);
                    UpdateMapViewBlock(unit.X, unit.Y);
                    TimeWait(25);
                    FieldScreen1->ClearSpriteList();
                }
                DrawMapPartial(unit.X, unit.Y);
                UpdateMapViewBlock(unit.X, unit.Y);
            }
            // ۂɍ폜B
            int zx = unit.X;
            int zy = unit.Y;
            SideStatus1[newPhase].DeleteUnitBySerial(Map, newPhase, *itr);
            gnd.Side = -1;
            DrawMapPartial(zx, zy);
            UpdateMapViewBlock(zx, zy);
        }
        UpdateMapViewAll();
    }
    TimeWait(WAIT_CPUSCROLL);
    if(Option.UnitListNoModal && Form_UnitListp->Visible){
        Form_UnitListp->Side=Situation->Phase;
        Form_UnitListp->MakeList();
    }
    SetPhaseControl();
    return 0;
}
//---------------------------------------------------------------------------
//VKQ[̏
__fastcall TForm1::Enabled_Open(bool Value)
{
    MIOpen->Enabled=Value;
    SpeedButton_Open->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
//Z[ȕ
__fastcall TForm1::Enabled_Save(bool Value)
{
    MISave->Enabled=Value;
    SpeedButton_Save->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
//[h̏
__fastcall TForm1::Enabled_Load(bool Value)
{
    MILoad->Enabled=Value;
    SpeedButton_Load->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::Enabled_NewRemote(bool value)
{
    MINewRemote->Enabled = value;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::Enabled_LoadMail(bool value)
{
    MILoadMail->Enabled = value;
    SpeedButton_Mail->Enabled = value;
    return 0;
}
//---------------------------------------------------------------------------
//󋵂̏
__fastcall TForm1::Enabled_Status(bool Value)
{
    Status->Enabled=Value;
    SpeedButton_Status->Enabled=Value;
    Popup_Status->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
//\̏
__fastcall TForm1::Enabled_UnitList(bool Value)
{
    UnitList->Enabled=Value;
    SpeedButton_UnitList->Enabled=Value;
    Popup_UnitList->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
//쌟̏
__fastcall TForm1::Enabled_More(bool Value)
{
    More->Enabled=Value;
    SpeedButton_More->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
//tFCYGh̏
__fastcall TForm1::Enabled_PhaseEnd(bool Value)
{
    PhaseEnd->Enabled=Value;
    SpeedButton_PhaseEnd->Enabled=Value;
    Popup_PhaseEnd->Enabled=Value;
    return 0;
}
//---------------------------------------------------------------------------
//IvV̏
__fastcall TForm1::Enabled_Option(bool value)
{
    Menu_Option->Enabled = value;
    SpeedButton_GraphNormal->Enabled = value;
    SpeedButton_GraphSmall->Enabled  = value;
    return 0;
}
//---------------------------------------------------------------------------
//Q[̏ԁBQ[̐isAZ[uȂǁB
__fastcall TForm1::Enabled_GameOperation(bool Value)
{
    Image_Map->Enabled = Value;
    Enabled_PhaseEnd(Value);
    Enabled_More(Value);
    Enabled_UnitList(Value);
    Enabled_Status(Value);
    Enabled_Save(Value);
    KSState = STATE_DEFAULT;
    ErrorHappened = false;
    return 0;
}
//---------------------------------------------------------------------------
//̑i\ύXj
__fastcall TForm1::MoneyOperation(int side,int money)
{
    char str[50];

    SideStatus1[side].Money += money;
    sprintf(str,"@%6d  ",SideStatus1[side].Money);
    Label_Money->Caption=str;
    return 0;
}
//---------------------------------------------------------------------------
//QƃJ[\̕\
__fastcall TForm1::DrawLookUpCursor(int zx,int zy,int Side,int Index)
{
    for(int i=0;i<3;i++){
        if(i)
            LookUpWait(WAIT_SHOWLOOKUP);
        FieldScreen1->AddSpriteZ(zx, zy, TSpriteOnMap::stCursor, CURSOR_LOOKUP);
        DrawMapPartial(zx, zy, zx, zy);
        UpdateMapViewBlock(zx, zy);
        LookUpWait(WAIT_SHOWLOOKUP);
        FieldScreen1->ClearSpriteList();
        DrawMapPartial(zx, zy, zx, zy);
        UpdateMapViewBlock(zx, zy);
        if(Index != NowLookup)
            break; //rŕʂ̌sꂽ_Œ~
    }
    return 0;
}
//---------------------------------------------------------------------------
//jbg̈ʒuQ
__fastcall TForm1::ShowLookup(int Index)
{
    int zx,zy;

    NowLookup = Index; //\Ă΂鎖̂ŒlʂĂ
    UnitXY(Situation->Phase,Index,&zx,&zy);
    SysAutoScroll(zx,zy);
    DrawLookUpCursor(zx,zy,Situation->Phase,Index);
    return 0;
}
//---------------------------------------------------------------------------
//w胆jbg̍WT
__fastcall TForm1::UnitXY(int side,int unitNum,int *zx,int *zy)
{
    const UnitStatus *unitp;
    int i,j;

    unitp = &SideStatus1[side].Unit[unitNum];
    if(unitp->X != -1){
        *zx = unitp->X;
        *zy = unitp->Y;
        return 0;
    }
    //ړĨjbgڒȂ瓋ڃjbgT
    for(i=0;i<SideStatus1[side].UnitCount;i++){
        unitp = &SideStatus1[side].Unit[i];
        for(j=0;j<unitp->Load;j++){
            if(unitp->LoadingUnit[j]==unitNum){
                break;
            }
        }
    }
    *zx = unitp->X;
    *zy = unitp->Y;
    //ɓڒȂċAĂяo
    if(*zx==-1)
        UnitXY(side,i,zx,zy);
    return 0;
}
//---------------------------------------------------------------------------
//\̓eXV
__fastcall TForm1::UnitListRevise(int UnitNum)
{
    Form_UnitListp->ListUnitRevise(UnitNum);
    return 0;
}
//---------------------------------------------------------------------------
//胆jbg̎˒\
__fastcall TForm1::ShowUnitRange(int side,int num)
{
    const UnitStatus *unitp = &SideStatus1[side].Unit[num];
    const UnitChip& unitInfo = BaseData1->GetUnitChipByType(unitp->Type);
//    int minr=1000, maxr=0;
//
//    for(int i=0;i<GUN_MAX;i++){
//        if(unitInfo.GunMax[i]){
//            if(maxr < unitInfo.MaxRange[i]){
//                maxr = unitInfo.MaxRange[i];
//            }
//            if(minr > unitInfo.MinRange[i]){
//                minr = unitInfo.MinRange[i];
//            }
//        }
//    }
//    if(!maxr)
//        return 0;
    RangeLayer->InitRange();
    //FieldScreen1->GetNeighborRange(unitp->X, unitp->Y, minr, maxr+1, RangeLayer);
    for(int i=0;i<GUN_MAX;i++){
        if(unitInfo.GunMax[i]){
            FieldScreen1->GetNeighborRange(unitp->X, unitp->Y, unitInfo.MinRange[i], unitInfo.MaxRange[i] + 1, RangeLayer);
        }
    }

    FieldScreen1->CurrentRangeType = FieldScreen::rtAttackRange;
    FieldScreen1->AddSpriteZ(unitp->X, unitp->Y, TSpriteOnMap::stCursor, CURSOR_LOOKUP);
    int maxr = unitInfo.GetMaxRange();
    DrawMapPartial(unitp->X - maxr, unitp->Y - maxr, unitp->X + maxr, unitp->Y + maxr);
    UpdateMapViewBlock(unitp->X - maxr, unitp->Y - maxr, unitp->X + maxr, unitp->Y + maxr);
    Option.ShowRange=true;
    return 0;
}
//---------------------------------------------------------------------------
//胆jbg̎˒\
__fastcall TForm1::ClearUnitRange(void)
{
    if(!Option.ShowRange)
        return -1;
    FieldScreen1->CurrentRangeType = FieldScreen::rtNone;
    FieldScreen1->ClearSpriteList();
    DrawAllAndUpdateMapView();
    Option.ShowRange=false;
    return 0;
}
//---------------------------------------------------------------------------
//
__fastcall TForm1::ShowUnitMax(void)
{
    char str[100];

    sprintf(str,"%dłB",Situation->UnitMax);
    ShowMessage(str);
    return 0;
}
//---------------------------------------------------------------------------
//
__fastcall TForm1::LoadScript(void)
{
    char path[MAX_PATH];

    System.ScriptEnabled = false;
    if(Map->ScriptFile[0] != '\0'){
        if(KS_GetFilePath(path, Map->ScriptFile, &Option) == -1){
            ShowMessage("}bvt@CŎw肳ꂽXNvgt@C܂łB");
            return -1;
        }
        if(!KS_CompareFileExt(Map->ScriptFile, "lua")){
            KSLua_InitOnNewGame();
            // Lua
            if(System.LuaState_Event != NULL){
                KSLua_FreeLua(System.LuaState_Event);
            }
            System.LuaState_Event = KSLua_LoadLua(path);
            if(System.LuaState_Event == NULL){
                ShowMessage("CxgXNvg̓ǂݍ݂ŃG[N܂\niG[e_lualog.txtɏo͂܂jB");
                return -1;
            }else{
                System.ScriptEnabled = true;
            }
        }
        else{
            // 
            char paths[2][MAX_PATH];
            const char *ps[2] = {paths[0],paths[1]};
            sprintf(paths[0], "%s\\script", Option.SystemPath);
            _fullpath(paths[1], ".", MAX_PATH);
            Script_SetFilePath(ps, 2);
            if(Script_Load(path) == -1){
                ShowMessage("CxgXNvg̓ǂݍ݂ŃG[N܂B");
                return -1;
            }else{
                System.ScriptEnabled = true;
            }
        }
    }
/*
    if(BaseData1->LevelUpScriptFile[0] != '\0'){
        if(GBW_GetFilePath(path, BaseData1->LevelUpScriptFile, &Option) == -1){
            ShowMessage("xAbvXNvgt@C܂łB");
            return -1;
        }
        if(System.LuaState_LevelUp != NULL){
            KSLua_FreeLua(System.LuaState_LevelUp);
        }
        System.LuaState_LevelUp = KSLua_LoadLua(path);
    }
*/
    return 0;
}
//---------------------------------------------------------------------------
//
__fastcall TForm1::ExecuteScriptFunction(const char *funcname)
{
    if(!System.ScriptEnabled)
        return -1;
    if(System.LuaState_Event != NULL){
        KSLua_CallFunction(System.LuaState_Event, funcname);
//        while(!lua_resume(System.LuaState_Event, 0)){
//        while(!KSLua_Resume(System.LuaState_Event)){
        for(;;){
            int rsm = KSLua_Resume(System.LuaState_Event);
            if(needScreenUpdate){
                BaseData1->ApplyIDToAll(Map,SideStatus1);
                DrawAllAndUpdateMapView();
                needScreenUpdate = false;
            }
            Application->ProcessMessages();
            if(rsm){
                break;
            }
        }
    }
    else{
        if(Script_SetEntryPoint(funcname) == -1){
            //ShowMessage("Script Error : Function not found.");
            return -1;
        }
        needScreenUpdate = false;
        for(;;){
            int i = Script_ReExecute();
            if(needScreenUpdate){
                BaseData1->ApplyIDToAll(Map,SideStatus1);
                DrawAllAndUpdateMapView();
                needScreenUpdate = false;
            }
            if(i == 0)
                break;
            if(i == -1){
                ShowMessage("XNvgR[h̃XebvɒB܂B");
                break;
            }
            Application->ProcessMessages();
        }
        Script_OnEnd();
    }
    return 0;
}
//---------------------------------------------------------------------------
//fobOpBQ[󋵂Ɉُ킪ΌoāA̓e\
//ُ킪ȂΉȂ
__fastcall TForm1::CheckSituation(void)
{
    UnitStatus *Unitp;
    int side,num,i,load,type;

    for(side=0;side<2;side++)
        for(num=0; num<SideStatus1[side].UnitCount; num++){
            Unitp = &SideStatus1[side].Unit[num];
            if(Unitp->Life > 100) //Ct`FbN
                ShowMessage("Check:Found too large life");
            //ڃ`FbN
            //ڂłȂjbg𓋍ڂĂ
            for(i=0;i<Unitp->Load;i++){
                load = Unitp->LoadingUnit[i];
                type = SideStatus1[side].Unit[load].Type;
                if(!BaseData1->GetUnitChipByType(Unitp->Type).LoadUnit[type])
                    ShowMessage("Check:Found incorrect load");
            }
        }

    return 0;
}
//---------------------------------------------------------------------------
/*
__fastcall TForm1::EncryptPOP3Password(char *pass,char *crypt)
{
    return 0;
}*/
//---------------------------------------------------------------------------
__fastcall TForm1::PrintError(char *msg)
{
    char lines[256];
    sprintf(lines,"Error:\n%s\nState=%d\n",msg,KSState);
    PrintLog("_errors.txt",msg);
    ErrorHappened = true;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm1::AdjustRightPanelContent()
{
    const int defgunmax = BaseData1->GetDefinedGunMax();
    // Image_UnitStatus->Height ߂鎮́ATurbo C++ 2006 IDEImage_UnitStatus̏TCY(153)
    // FieldScreen::DrawUnitStatusToTCanvas()̕`揈e猈߂B
    // XImage_UnitStatus̃TCYR[hŕς鏈͖āAt̂߁B
    int h = 153 + (defgunmax - 2) * 32;
    if(Map->LevelUpEnabled){
        h += 16;
    }
    Image_UnitStatus->Height = h;
    Image_Loading->Top = Image_UnitStatus->Top + Image_UnitStatus->Height + 8;
    return 0;
}
//---------------------------------------------------------------------------
int TForm1::GMGetFilePath(char *path, const char *fileName)
{
    return KS_GetFilePath(path, fileName, &Option);
}
//---------------------------------------------------------------------------
void TForm1::GMGetSystemLuaPath(char *path)
{
    strcpy(path, Option.SystemLuaPath);
}
//---------------------------------------------------------------------------
int TForm1::GMGetNextXYLayer(int *array_x, int *array_y)
{
    int nx,ny,count=0;

    int mw = Map->GetWidth();
    int mh = Map->GetHeight();
    for(int y=0;y<mh;y++){
        for(int x=0;x<mw;x++){
            for(int i=0;i<6;i++){
                nx = x + FieldScreen1->NextDX[y%2][i];
                ny = y + FieldScreen1->NextDY[i];
                if(nx<0 || nx>=mw || ny<0 || ny>=mh)
                    continue;
                array_x[count] = nx;
                array_y[count] = ny;
                count++;
            }
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
//int TForm1::GMGetNeighborXYLayer(int x, int y, int r1, int r2, POINT *plist, int array_size)
int TForm1::GMGetNeighborXYLayer(int x, int y, int r1, int r2, vector<POINT>& plist)
{
    return FieldScreen1->GetNeighborList(x, y, r1, r2+1, Map->GetWidth(), Map->GetHeight(), plist);
}
//---------------------------------------------------------------------------
int TForm1::GMIsNeighbor(int x1, int y1, int x2, int y2, int r)
{
    return FieldScreen1->IsNeighbor(x2, y2, x1, y1, r);
}
//---------------------------------------------------------------------------
// (x,y)n_sideY\ȃjbgID̃Xg쐬B
int TForm1::GMGetCreatableUnitList(int x,int y,int side,int *idlist)
{
    if(!CanCreateUnit(x,y))
        return 0;

    int tcount = BaseData1->GetUnitTypeCount()-1;
    int gndtype = Map->GetMapStatus(x,y).Type;
    int count = 0;
    for(int i=0;i<tcount;i++){
        if(BaseData1->CanCreateUnit(side, gndtype, i, SideStatus1[side].LimitView)){
            idlist[count] = BaseData1->GetUnitChipByType(i).ID;
            count++;
        }
    }
    return count;
}
//---------------------------------------------------------------------------
int TForm1::GMGetCurrentSide(void)
{
    return Situation->Phase;
}
//---------------------------------------------------------------------------
int TForm1::GMGetMoveDistanceLayer(int x,int y,int utype,int dist,int *layer)
{
    TRangeLayer *rangeLayer = new TRangeLayer(Map->GetWidth(), Map->GetHeight(), layer);

    rangeLayer->InitRange();
    rangeLayer->GetRangeValue(x,y) = dist;
    FieldScreen1->TraceRangeSimply(rangeLayer, Map, &BaseData1->GetUnitChipByType(utype), x, y);
    delete rangeLayer;
    return 0;
}
//---------------------------------------------------------------------------
int TForm1::GMGetMovableRangeLayer(int side,int serial,int *layer)
{
    TRangeLayer *rangeLayer = new TRangeLayer(Map->GetWidth(), Map->GetHeight(), layer);

    int num = SideStatus1[side].GetUnitBySerial(serial);
    if(num == -1)
        return -1;
    const UnitStatus& unit = SideStatus1[side].GetUnitStatus(num);
    FieldScreen1->GetMoveRange(rangeLayer, Map, BaseData1, SideStatus1, &unit, side, unit.X, unit.Y);
    delete rangeLayer;
    return 0;
}
//---------------------------------------------------------------------------
int TForm1::GMMoveAndAttack(int side,int serial,int x,int y,int gun_index,int tx,int ty,bool exec,
    POINT *plist, int *damagelist, int listmax)
{
    int num = SideStatus1[side].GetUnitBySerial(serial);
    if(num == -1)
        return -1;
    const UnitStatus& unit = SideStatus1[side].GetUnitStatus(num);
    // fobOp
    UnitStatus unit_bak = unit;
    int listcount = 0;

    // ڒȂssB
    if(unit.X == -1)
        return -1;
    FieldScreen1->GetMoveRange(RangeLayer, Map, BaseData1, SideStatus1, &unit, side, unit.X, unit.Y);
    if(!RangeLayer->GetRangeValue(x, y))
        return -1;
    if(gun_index != -1){
        // jbg̋鏊iځEjւ̈ړ̏ꍇ͕sB
        if((x != unit.X || y != unit.Y) && Map->GetMapStatus(x,y).Side != -1)
            return -1;
        // e
        if(unit.GunRest[gun_index] <= 0)
            return -1;
        // ۂɓ킯ɂ͂Ȃ̂ŕĂ̍WςB
        UnitStatus unitA = unit;
        const UnitChip& unitInfoA = BaseData1->GetUnitChipByType(unit.Type);
        unitA.X = x;
        unitA.Y = y;
        if(unitInfoA.Radius[gun_index] > 1){
            // KwNXȔꍇ
            if((x != unit.X || y != unit.Y) && !unitInfoA.SuperMissile)
                return -1;
            if(!FieldScreen1->IsNeighbor(tx, ty, x, y, unitInfoA.MaxRange[gun_index]))
                return -1;
            // AttackMegaHex()ƓB
            POINT list[1024];
            int count;
            if(unitInfoA.SuperMissile){
                count = FieldScreen1->GetNeighborList(x, y, 0, unitInfoA.Radius[gun_index], Map->GetWidth(), Map->GetHeight(), list, 1024);
            }else{
                count = FieldScreen1->GetNeighborList(tx, ty, 0, unitInfoA.Radius[gun_index], Map->GetWidth(), Map->GetHeight(), list, 1024);
            }
            if(count > listmax)
                return -1;
            for(int i=0;i<count;i++){
                // Ȃ̓jbgĂ_[WsB
                if(!Map->GetVisible(list[i].x, list[i].y))
                    continue;
                const MapStatus& gnd = Map->GetMapStatus(list[i].x, list[i].y);
                if(gnd.Side == -1)
                    continue;
                const UnitStatus& unitT = SideStatus1[gnd.Side].GetUnitStatus(gnd.UnitIndex);
                int gunType;
                plist[listcount] = list[i];
                damagelist[listcount] = FieldScreen1->CalcDamage(Map, BaseData1, &unitA, &unitT, &gunType, 1<<gun_index, false, Map->IgnoreLife, Option.DamageFix);
                listcount++;
            }
        }
        else{
            // ʏ풼ڍUEԐڍȔꍇ
            // Ȃ͍Us
            if(!Map->GetVisible(tx, ty))
                return -1;
            bool noMove = (x == unit.X && y == unit.Y);
            if(!noMove){
                // ĂꍇAԐڍUs
                if(unitInfoA.MaxRange[gun_index] > 1)
                    return -1;
            }
            const MapStatus& gnd = Map->GetMapStatus(tx, ty);
            // jbgȂAwc͗FDwc̃jbgɂ͍Us
            if(gnd.Side == -1 || side == gnd.Side || SideStatus1[side].Friendly[gnd.Side] > 0){
                return -1;
            }
            // U͈̓`FbNB
            FieldScreen1->GetAttackRange(RangeLayer, Map, BaseData1, &unit, SideStatus1, side, x, y, noMove);
            if(!RangeLayer->GetRangeValue(tx, ty)){
                return -1;
            }
            // õ_[W̌vZB
            const UnitStatus& unitT = SideStatus1[gnd.Side].GetUnitStatus(gnd.UnitIndex);
            int damageA, damageT, gunTypeA, gunTypeT;
            CalcBattle(&unitA, &unitT, (1<<gun_index), &damageA, &damageT, &gunTypeA, &gunTypeT, Option.DamageFix);
            if(listmax < 2)
                return -1;
            listcount = 2;
            plist[0].x = x;
            plist[0].y = y;
            damagelist[0] = damageA;
            plist[1].x = tx;
            plist[1].y = ty;
            damagelist[1] = damageT;
        }
    }

    if(exec){
        // OwcȊÕjbg𑀍삷邱Ƃ͂łȂB
        if(side != Situation->Phase){
            return -1;
        }
        if(Option.CPUScroll){
            SysAutoScroll(unit.X, unit.Y);
        }
        // ͂ށB
        MouseLeftDown(unit.X, unit.Y);
        if(!RangeLayer->GetRangeValue(x,y)){
            MouseRightDown(x, y);
            return -1;
        }
        CPUWait(WAIT_SHOWMOVE);
        // ړB
        if(gun_index != -1){
            System.UseGun = gun_index;
        }
        MouseLeftDown(x, y);
        if(System.PhaseEndable){
            // Փ˂ꍇAIB
            return 0;
        }
        CPUWait(WAIT_SHOWATTACK);
        // U悪w肳ĂꍇB
        if(gun_index != -1){
            // Uw
            if(!RangeLayer->GetRangeValue(tx,ty)){
                MouseRightDown(x, y);
                return -1;
            }
            MouseLeftDown(tx,ty);
        }
        else{
            // ړm
            MouseLeftDown(x, y);
        }
        CPUWait(WAIT_SHOWMOVEEND);
        if(!System.PhaseEndable){
            char str[256];
            sprintf(str, "vIG[FCOM̑~X (%d,%d)(%d,%d)ɈړĉΊ%d(%d,%d)U悤Ƃ܂B",
                unit_bak.X, unit_bak.Y, x, y, gun_index, tx, ty);
            ShowMessage(str);
        }
    }

    return listcount;
}
//---------------------------------------------------------------------------
// (x,y)WɈړ loadlist ̓ڃjbg plist ̍Wɍ~Ԃł邩ǂ肷B
// exec=true ȂۂɑsBsuccesslist  loadcount ̐tOB
// ߂l͈ړꍇ0AړɎsꍇ-1B
int TForm1::GMMoveAndUnload(int side,int serial,int x,int y,const int *loadlist,const POINT *plist,int loadcount,bool exec,
    bool *successlist)
{
    int num = SideStatus1[side].GetUnitBySerial(serial);
    if(num == -1)
        return -1;
    const UnitStatus& unit = SideStatus1[side].GetUnitStatus(num);
    // fobOp
    UnitStatus unit_bak = unit;

    // ړ`FbN
    FieldScreen1->GetMoveRange(RangeLayer, Map, BaseData1, SideStatus1, &unit, side, unit.X, unit.Y);
    if(!RangeLayer->GetRangeValue(x, y))
        return -1;
    // ~Ԕ͈̓`FbN
    RangeLayer->InitRange();
    FieldScreen1->GetLoadRange(RangeLayer, Map, BaseData1, SideStatus1, &unit, side, x, y);
    // ~Ԕ
    for(int i=0;i<loadcount;i++){
        successlist[i] = false;
        // ꉞACfbNX͈̔̓`FbNB
        if(loadlist[i] >= unit.Load){
            continue;
        }
        int& rp = RangeLayer->GetRangeValue(plist[i].x, plist[i].y);
        if(!rp){
            continue;
        }
        // ~Ԑ
        rp = 0;
        successlist[i] = true;
    }

    if(exec){
        // OwcȊÕjbg𑀍삷邱Ƃ͂łȂB
        if(side != Situation->Phase){
            return -1;
        }
        if(Option.CPUScroll){
            SysAutoScroll(unit.X, unit.Y);
        }
        // ͂ށB
        MouseLeftDown(unit.X, unit.Y);
        if(!RangeLayer->GetRangeValue(x,y)){
            MouseRightDown(x, y);
            return -1;
        }
        CPUWait(WAIT_SHOWMOVE);
        // ړB
        System.UseGun = MENUITEM_DOWNUNIT;
        MouseLeftDown(x, y);
        if(System.PhaseEndable){
            // Փ˂ꍇAIB
            return 0;
        }
        CPUWait(WAIT_SHOWATTACK);
        // ~Ԑ悪w肳ĂꍇBB
        for(int i=0;i<loadcount;i++){
            // Ŏs͂Ƃ΂B
            if(successlist[i]){
                MouseLeftDown(plist[i].x, plist[i].y);
            }
        }
        // ~ԂĂȂꍇ͊m葀삪KvB
        if(!System.PhaseEndable){
            // ړm
            MouseLeftDown(x, y);
        }
        CPUWait(WAIT_SHOWMOVEEND);
        if(!System.PhaseEndable){
            char str[256];
            sprintf(str, "vIG[FCOM̑~X (%d,%d)(%d,%d)Ɉړ%d̃jbg~Ԃ悤Ƃ܂B",
                unit_bak.X, unit_bak.Y, x, y, loadcount);
            ShowMessage(str);
        }
    }

    return 0;
}
//---------------------------------------------------------------------------
int TForm1::GMCanCreateUnit(int x,int y,int uid)
{
    int gndtype = Map->GetMapStatus(x,y).Type;
    int utype = BaseData1->GetUnitTypeIndex(uid);
    return CanCreateUnit(x,y) &&
        BaseData1->CanCreateUnit(Situation->Phase, gndtype, utype, SideStatus1[Situation->Phase].LimitView);
}
//---------------------------------------------------------------------------
// YwBvl[`pB
int TForm1::GMCreateUnit(int x,int y,int uid)
{
    if(!System.CPUOperationMode){
        return -1;
    }
    int utype = BaseData1->GetUnitTypeIndex(uid);
    return ComCreateUnit(x,y,utype);
}
//---------------------------------------------------------------------------
void TForm1::GMPutCPUScriptVariable(int side, const string& key, const string& value)
{
    // CX^X̃Rs[}bvɓB
    SideStatus1[side].CPUScriptVariable_String[key] = value;
}
//---------------------------------------------------------------------------
string TForm1::GMGetCPUScriptVariable(int side, const string& key)
{
    // l̃Rs[邪邵ȂB
    return SideStatus1[side].CPUScriptVariable_String[key];
}
//---------------------------------------------------------------------------
void TForm1::GMRemoveCPUScriptVariable(int side, const string& key)
{
    SideStatus1[side].CPUScriptVariable_String.erase(key);
}
//---------------------------------------------------------------------------
void TForm1::GMPutEventScriptVariable(const string& key, const string& value)
{
    Situation->EventScriptVariable[key] = value;
}
//---------------------------------------------------------------------------
string TForm1::GMGetEventScriptVariable(const string& key)
{
    return Situation->EventScriptVariable[key];
}
//---------------------------------------------------------------------------
void TForm1::GMRemoveEventScriptVariable(const string& key)
{
    Situation->EventScriptVariable.erase(key);
}
//---------------------------------------------------------------------------
// FDxݒBCxgpB
int TForm1::GMSetSideRelation(int side1, int side2, int friendly)
{
    if(System.CPUOperationMode)
        return -1;
    if(side1 < 0 || side1 >= BaseData1->Sides ||
       side2 < 0 || side2 >= BaseData1->Sides)
        return -1;
    SideStatus1[side1].Friendly[side2] = friendly;

    if(side2 == Situation->Phase && !SideStatus1[side2].IsComputer && SideStatus1[side2].LimitView){
        FieldScreen1->FindVisibleAll(Map, BaseData1, SideStatus1, side2);
        Map->UpdateShade();
        needScreenUpdate = true;
    }
    return 0;
}
//---------------------------------------------------------------------------
// jbgǉBCxgpB
int TForm1::GMAppendUnit(int x, int y, int side, int id)
{
    if(System.CPUOperationMode)
        return -1;
    return AppendUnit_Event(x,y,side,id);
}
//---------------------------------------------------------------------------
// jbg폜BCxgpB
int TForm1::GMRemoveUnit(int x, int y)
{
    if(System.CPUOperationMode)
        return -1;
    return RemoveUnit_Event(x,y);
}
//---------------------------------------------------------------------------
// n`ύXBCxgpB
int TForm1::GMSetGroundStatus(int x, int y, int id, int life)
{
    if(System.CPUOperationMode)
        return -1;
    if(x < 0 || x >= Map->GetWidth() || y < 0 || y >= Map->GetHeight())
        return -1;
    MapStatus& gnd = Map->GetMapStatus(x, y);
    gnd.ID = id;
    gnd.Life = life;
    needScreenUpdate = true;
    return 0;
}
//---------------------------------------------------------------------------
// EύXBCxgpB
int TForm1::GMSetSideStatus(int side, int money, int income)
{
    if(System.CPUOperationMode)
        return -1;
    if(side < 0 || side >= BaseData1->Sides)
        return -1;
    SideStatus *sidep = &SideStatus1[side];
    sidep->Money = money;
    sidep->Income = income;
    MoneyOperation(side, 0);
    return 0;
}
//---------------------------------------------------------------------------
int TForm1::GMSetUnitStatus(int side, int serial, const UnitStatus& unit)
{
    if(side < 0 || side >= BaseData1->Sides)
        return -1;
    int unum = SideStatus1[side].GetUnitBySerial(serial);
    if(unum == -1)
        return -1;
    UnitStatus& unit_target = SideStatus1[side].Unit[unum];
    // w肳ꂽl肤̂ȂAɏ]ĕύXB
    if(unit.Life >= 1 && unit.Life <= 100)
        unit_target.Life = unit.Life;
    if(unit.Fuel >= 0)
        unit_target.Fuel = unit.Fuel;
    if(unit.Level >= 0)
        unit_target.Level = unit.Level;
    if(unit.Experience >= 0 && unit.Experience <= 100)
        unit_target.Experience = unit.Experience;
    needScreenUpdate = true;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TSystemStatus::Initialize(void)
{
    PhaseEndable=true;
    Controlable=true;
    GameEnd=false;
    StopDemand = false;
    CPUMinding = false;
    ScriptEnabled = false;
    CPUOperationMode = false;
    RadiusCursor = 0;
    strcpy(SaveFile,NEWFILENAME);
    HoldUnit = -1;
    UseGun = -1;
    SelectedLoading = -1;
    LuaState_Event = NULL;
    return 0;
}
//---------------------------------------------------------------------------

