//---------------------------------------------------------------------------

#ifndef kseventH
#define kseventH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>

#include "../common/buingl/ABitmap.hpp"
//---------------------------------------------------------------------------
class TForm_Event : public TForm
{
__published:	// IDE Ǘ̃R|[lg
    void __fastcall Form_EventMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall Form_EventClick(TObject *Sender);
    void __fastcall Form_EventMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
    void __fastcall Form_EventPaint(TObject *Sender);
private:	// [U[錾
    HBITMAP hbmpBuffer;
    HDC hdcBuffer;
    LPDWORD lpdwPixel;
    int BufferWidth;
    int BufferHeight;
    TABitmap *ABitmap;
public:		// [U[錾
    __fastcall TForm_Event(TComponent* Owner);
    __fastcall ~TForm_Event(void);
    bool MouseDowned;
    bool MouseClicked;
    LONG MouseLastX,MouseLastY;
    LONG MouseLastClickX,MouseLastClickY;
    LONG MouseLastDownX,MouseLastDownY;
    __fastcall InitializeSurface(bool useABitmap);
    __fastcall FinalizeSurface(void);
    HBITMAP& GetHBMPBuffer(void) { return hbmpBuffer; };
    HDC& GetHDCBuffer(void) { return hdcBuffer; };
    LPDWORD GetPixel(void) { return lpdwPixel; };
    int GetBufferHeight(void) const { return BufferHeight; };
    int GetBufferWidth(void) const { return BufferWidth; };
    TABitmap* __fastcall GetABitmap(void) { return ABitmap; };
};
//---------------------------------------------------------------------------
extern PACKAGE TForm_Event *Form_Event;
//---------------------------------------------------------------------------
#endif
