//---------------------------------------------------------------------------
// }bṽvpeB肷_CAOB
// TabControl_UnionStatus ̒gɂẮÃR[hœe擾B
#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "ksmapprp.h"
#include "ksfunc.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm_MapProperty *Form_MapProperty;
//---------------------------------------------------------------------------
__fastcall TForm_MapProperty::TForm_MapProperty(TComponent* Owner)
    : TForm(Owner)
{
    LastSelectedSideIndex = -1;
}
//---------------------------------------------------------------------------
__fastcall TForm_MapProperty::~TForm_MapProperty(void)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm_MapProperty::Form_Property1Close(TObject *Sender,
      TCloseAction &Action)
{
    GetControlContent();
}
//---------------------------------------------------------------------------
void __fastcall TForm_MapProperty::Button_OkClick(TObject *Sender)
{
    int x,y;

    x = Edit_MapX->Text.ToIntDef(-1);
    y = Edit_MapY->Text.ToIntDef(-1);
    if(x <= 0)
        Edit_MapX->Text = 1;
    if(y <= 0)
        Edit_MapY->Text = 1;
}
//---------------------------------------------------------------------------
void __fastcall TForm_MapProperty::Button_BrowseClick(TObject *Sender)
{
    char path[MAX_PATH]="",file[128];

    if(Sender == Button_Browse){
        if(KS_BrowsePath(this,"ǒn헪{f[^(*.csv)|*.csv","csv",path)){
            KS_GetFileTitle(path, file, sizeof file, "csv");
            Edit_UnitFile->Text = file;
            strcpy(Mapp->UnitDataFile, Edit_UnitFile->Text.c_str());
            ReloadBaseData();
        }
    }else if(Sender == Button_BrowseScript){
        if(KS_BrowsePath(this,"ǒn헪CxgXNvg(*.lua;*.c)|*.lua;*.c","lua",path)){
            KS_GetFileTitle(path, file, sizeof file, "lua");
            Edit_ScriptFile->Text = file;
        }
    }else if(Sender == Button_BrowseBGImage){
        if(KS_BrowsePath(this,"摜t@C(*.bmp;*.png;*.jpg)|*.bmp;*.png;*.jpg", "", path)){
            KS_GetFileTitle(path, file, sizeof file, "bmp");
            Edit_BGImageFile->Text = file;
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm_MapProperty::Button_ComScriptBrowseClick(TObject *Sender)
{
    char path[MAX_PATH]="",file[64];

    if(KS_BrowsePath(this,"COMXNvgt@C(*.lua)|*.lua","lua",path)){
        KS_GetFileTitle(path,file,64,"lua");
        Edit_ComScriptFile->Text = file;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm_MapProperty::TabControl_UnionChange(TObject *Sender)
{
    if(LastSelectedSideIndex != -1){
        GetControlContent(LastSelectedSideIndex);
    }
    if(ListBox_Side->ItemIndex >= 0){
        DrawUnionStatus(ListBox_Side->ItemIndex - 1);
        LastSelectedSideIndex = ListBox_Side->ItemIndex - 1;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm_MapProperty::TrackBar_UnitMaxChange(TObject *Sender)
{
    UpdateUnitMax();
}
//---------------------------------------------------------------------------
void __fastcall TForm_MapProperty::Button_AllComClick(TObject *Sender)
{
    boolean com = !IsAllCom();
    for(int side=0; side<BaseDatap->Sides; side++){
        ((*SideStatus1)[side]).IsComputer = com;
    }
    UpdateAllComButton();
    if(ListBox_Side->ItemIndex >= 0){
        DrawUnionStatus(ListBox_Side->ItemIndex - 1);
    }
}
//---------------------------------------------------------------------------
__fastcall TForm_MapProperty::SetControlProtect(bool start)
{
    CheckBox_Protected->Visible = false;
    Button_Cancel->Enabled = false;
    Edit_MapName->Enabled = false;
    Edit_MapX->Enabled = false;
    Edit_MapY->Enabled = false;
    Edit_UnitFile->Enabled = false;
    Button_Browse->Enabled = false;
    CheckBox_IsComputer->Enabled = !Mapp->Protected;
    Edit_ComScriptFile->Enabled     = !Mapp->Protected;
    Button_ComScriptBrowse->Enabled = !Mapp->Protected;
    CheckListBox_Map->Enabled    = !Mapp->Protected;
    NowPlaying = !start;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm_MapProperty::SetDataPointer(BaseData *base,FieldScreen *field,
    MapData *map, TKSImageData *image1, TKSOption *option, TSideStatusArray& sides, bool newMap)
{
    BaseDatap = base;
    FieldScreenp = field;
    Mapp = map;
    KSImage1 = image1;
    Option = option;
    CheckBox_Protected->Checked = Mapp->Protected;
    SideStatus1 = &sides;
    IsNewMap = newMap;
    UpdateSideTabs();
    TrackBar_UnitMax->Position = UnitMax/10;
    UpdateUnitMax();
    Edit_MapX->Text = Mapp->GetWidth();
    Edit_MapY->Text = Mapp->GetHeight();
    CheckListBox_Map->Checked[0] = Mapp->ZOCMode;
    CheckListBox_Map->Checked[1] = Mapp->Tekisaku;
    CheckListBox_Map->Checked[2] = Mapp->LevelUpEnabled;
    CheckListBox_Map->Checked[3] = Mapp->IgnoreLife;
    Edit_MapName->Text = Mapp->Name.c_str();
    Edit_UnitFile->Text = Mapp->UnitDataFile;
    Edit_ScriptFile->Text = Mapp->ScriptFile;
    Edit_BGImageFile->Text = Mapp->BGImageFile;
    CheckBox_BGImageOnGame->Checked = Mapp->BGImageOnGame;
    DrawUnionStatus(-1); // wc̕\B
    UpdateAllComButton();
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm_MapProperty::GetControlContent(int side)
{
    // OĂяoꂽꍇ́Ȃ݂IʒuoB
    if(side < 0){
        if(ListBox_Side->ItemIndex >= 0)
            side = ListBox_Side->ItemIndex -1;
    }
    if(side >= 0){
        SideStatus *sidep = &((*SideStatus1)[side]);
        sidep->Money = Edit_Money->Text.ToIntDef(0);
        sidep->IsComputer = CheckBox_IsComputer->Checked;
        strcpy(sidep->ComScriptFile, Edit_ComScriptFile->Text.c_str());
    }
    Mapp->Protected = CheckBox_Protected->Checked;
    Mapp->Resize(Edit_MapX->Text.ToIntDef(1), Edit_MapY->Text.ToIntDef(1));
    Mapp->ZOCMode  = CheckListBox_Map->Checked[0];
    Mapp->Tekisaku = CheckListBox_Map->Checked[1];
    Mapp->LevelUpEnabled = CheckListBox_Map->Checked[2];
    Mapp->IgnoreLife = CheckListBox_Map->Checked[3];
    Mapp->Name = Edit_MapName->Text.c_str();
    strcpy(Mapp->UnitDataFile, Edit_UnitFile->Text.c_str());
    strcpy(Mapp->ScriptFile, Edit_ScriptFile->Text.c_str());
    strcpy(Mapp->BGImageFile, Edit_BGImageFile->Text.c_str());
    Mapp->BGImageOnGame = CheckBox_BGImageOnGame->Checked;
    UpdateUnitMax();
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm_MapProperty::DrawUnionStatus(int side)
{
    TCanvas *canvas = Image_UnionStatus->Canvas;
    char str[64];

    FillCanvas(canvas,clWindow);
    if(!IsNewMap){
        FieldScreenp->DrawBuildingCount(canvas,side,BaseDatap,Mapp);
    }
    Edit_Money->Text = "";
    if(side >= 0){
        SideStatus *sidep = &((*SideStatus1)[side]);
        /*if(sidep->Lost){
            canvas->TextOut(64,64,"S");
        }*/
        if(!IsNewMap){
            sidep->CalcIncome(Mapp, BaseDatap, side);
            sprintf(str, "@%6d", sidep->Income);
            canvas->TextOut(8,112,str);
            sprintf(str, "jbg@%6d", sidep->UnitCount);
            canvas->TextOut(160,112,str);
        }
        Edit_Money->Text = sidep->Money;
        CheckBox_IsComputer->Checked = sidep->IsComputer;
        Edit_ComScriptFile->Text = sidep->ComScriptFile;
        // GfB^E{́EύXstORg[̎gpۂ߂B
        Edit_Money->Enabled = !NowPlaying;
        bool b = (Editing || !Mapp->Protected);
        CheckBox_IsComputer->Enabled = b;
        Edit_ComScriptFile->Enabled = b;
        Button_ComScriptBrowse->Enabled = b;
    }
    else{
        Edit_ComScriptFile->Text = "";
        Edit_Money->Enabled = false;
        CheckBox_IsComputer->Checked = false;
        CheckBox_IsComputer->Enabled = false;
        Edit_ComScriptFile->Enabled = false;
        Button_ComScriptBrowse->Enabled = false;
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm_MapProperty::UpdateUnitMax(void)
{
    char str[64];
    UnitMax = 10*TrackBar_UnitMax->Position;
    sprintf(str,"jbgF%3d",UnitMax);
    Label_UnitMax->Caption = str;
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm_MapProperty::UpdateSideTabs(void)
{
    //TStrings *tabs = TabControl_Union->Tabs;
    TStrings *tabs = ListBox_Side->Items;
    tabs->Clear();
    tabs->Append("{");
    for(int i=0;i<BaseDatap->Sides;i++){
        tabs->Append(BaseDatap->SideName[i].c_str());
    }
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm_MapProperty::ReloadBaseData(void)
{
    GBW_LoadBaseAll(Mapp, KSImage1, BaseDatap, Option, false);
    KS_ResizeSideStatusArray(*SideStatus1, BaseDatap->Sides);
    UpdateSideTabs();
    return 0;
}
//---------------------------------------------------------------------------
__fastcall TForm_MapProperty::IsAllCom(void)
{
    for(int side=0; side<BaseDatap->Sides; side++){
        if(!((*SideStatus1)[side]).IsComputer)
             return 0;
    }
    return 1;
}
//---------------------------------------------------------------------------
__fastcall TForm_MapProperty::UpdateAllComButton(void)
{
    const char *captions[] = {"SCOM", "SĐl"};

    Button_AllCom->Caption = captions[IsAllCom()];
    return 1;
}
//---------------------------------------------------------------------------

