//---------------------------------------------------------------------------
#ifndef ksmapprpH
#define ksmapprpH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>

#include "gbwfield.h"
#include "ksoption.h"
#include <Dialogs.hpp>
#include <ComCtrls.hpp>
#include <checklst.hpp>
#include <CheckLst.hpp>
//---------------------------------------------------------------------------
class TForm_MapProperty : public TForm
{
__published:	// IDE Ǘ̃R|[lg
    TPanel *Panel1;
    TButton *Button_Ok;
    TButton *Button_Cancel;
    TOpenDialog *OpenDialog1;
    TTrackBar *TrackBar_UnitMax;
    TLabel *Label_UnitMax;
    TCheckBox *CheckBox_Protected;
    TCheckListBox *CheckListBox_Map;
        TImage *Image_UnionStatus;
        TLabel *Label_Money;
        TEdit *Edit_Money;
        TCheckBox *CheckBox_IsComputer;
        TEdit *Edit_ComScriptFile;
        TButton *Button_ComScriptBrowse;
        TListBox *ListBox_Side;
    TButton *Button_AllCom;
    TPageControl *PageControl1;
    TTabSheet *TabSheet_Base;
    TTabSheet *TabSheet_File;
    TLabel *Label_X;
    TEdit *Edit_MapX;
    TLabel *Label_Y;
    TEdit *Edit_MapY;
    TLabel *Label_AboutXY;
    TLabel *Label_AboutName;
    TLabel *Label_Name;
    TEdit *Edit_MapName;
    TLabel *Label_UnitFile;
    TEdit *Edit_UnitFile;
    TButton *Button_Browse;
    TLabel *Label_BaseDataWarning;
    TLabel *Label_ScriptFile;
    TEdit *Edit_ScriptFile;
    TButton *Button_BrowseScript;
    TEdit *Edit_BGImageFile;
    TLabel *Label_BGImageFile;
    TButton *Button_BrowseBGImage;
    TCheckBox *CheckBox_BGImageOnGame;
    TLabel *Label_BGImageWarning;
    void __fastcall Button_OkClick(TObject *Sender);
    void __fastcall Button_BrowseClick(TObject *Sender);
    void __fastcall TabControl_UnionChange(TObject *Sender);
    void __fastcall Form_Property1Close(TObject *Sender,
          TCloseAction &Action);
    void __fastcall TrackBar_UnitMaxChange(TObject *Sender);
    void __fastcall Button_ComScriptBrowseClick(TObject *Sender);
    void __fastcall Button_AllComClick(TObject *Sender);
private:	// [U[錾
    BaseData *BaseDatap;
    FieldScreen *FieldScreenp;
    MapData *Mapp;
    TSideStatusArray *SideStatus1;
    TKSImageData *KSImage1;
    TKSOption *Option;
    int LastSelectedSideIndex;
    bool IsNewMap;    // VK쐬̃}bvB
    bool Editing;     // }bvGfB^̌ĂяoB
    bool NowPlaying;  // ݃Q[iJn̂jB
    __fastcall IsAllCom(void);
    __fastcall UpdateAllComButton(void);
public:		// [U[錾
    int UnitMax;
    __fastcall TForm_MapProperty(TComponent* Owner);
    __fastcall ~TForm_MapProperty(void);
    __fastcall SetControlProtect(bool start);
    __fastcall SetDataPointer(BaseData *,FieldScreen *,MapData *,TKSImageData *,TKSOption *,TSideStatusArray&,bool newMap);
    __fastcall GetControlContent(int side = -1);
    __fastcall DrawUnionStatus(int side);
    __fastcall UpdateUnitMax(void);
    __fastcall UpdateSideTabs(void);
    __fastcall ReloadBaseData(void);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm_MapProperty *Form_MapProperty;
//---------------------------------------------------------------------------
#endif
