//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "seisan.h"
#include "ksfunc.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm_seisan *Form_seisan;
//---------------------------------------------------------------------------
__fastcall TForm_seisan::TForm_seisan(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm_seisan::OnListBox1DrawItem(TWinControl *Control,
      int Index, TRect &Rect, TOwnerDrawState State)
{
    TRect Rect1;

    ListBox1->Canvas->Brush->Color=clWindow;
    ListBox1->Canvas->Font->Color=clBlack;
    if(ListBox1->Selected[Index]){
        if(OldIndex!=-1){   //OIĂACeĕ`
            if(OldIndex==Index && OldIndex<ListBox1->Items->Count-1)
                OldIndex++;   //̏ɂďXN[̕`sBs
            Rect1=Rect;
            Rect1.Top+=(OldIndex-Index)*ListBox1->ItemHeight;
            Rect1.Bottom=Rect1.Top+ListBox1->ItemHeight;
            ListBox1->Canvas->FillRect(Rect1);
            ListUnitPut(ListBox1->Canvas,&Rect1,OldIndex);
        }
        OldIndex=Index;
        ListBox1->Canvas->Brush->Color=clActiveCaption;
        ListBox1->Canvas->Font->Color=clWhite;
        UnitChipPut(Index);
    }
    ListBox1->Canvas->FillRect(Rect);
    ListUnitPut(ListBox1->Canvas,&Rect,Index);
}
//---------------------------------------------------------------------------
__fastcall TForm_seisan::SetPointer(FieldScreen *field, BaseData *base)
{
    FieldScreenp = field;
    BaseDatap = base;
    return 0;
}
//---------------------------------------------------------------------------
//Xg{bNXւ̃ACe̓o^
__fastcall TForm_seisan::MakeList(int side,int money,int building,bool sakuteki)
{
    char str[32];

    Side = side;
    Money = money;
    FillCanvas(Image_Unit->Canvas, Panel1->Brush->Color);
    Label_UnitValue->Caption="";
    Label_Guidance->Caption="";
    ButtonOK->Enabled=false;
    sprintf(str,"@%6d",Money);
    Label_Money->Caption=str;
    ListBox1->Clear();
    int tcount = BaseDatap->GetUnitTypeCount();
    for(int i=0;i<tcount;i++)
        if(BaseDatap->CanCreateUnit(side,building,i,sakuteki))
            ListBox1->Items->Add(AnsiString(i));

    OldIndex=-1;
    return 0;
}
//---------------------------------------------------------------------------
// Xg{bNX̃jbg`
__fastcall TForm_seisan::ListUnitPut(TCanvas *canvas,TRect *Rectp,int Index)
{
    int type,graph;

    type = ListBox1->Items->Strings[Index].ToIntDef(0);
    graph = BaseDatap->GetUnitGraphic(Side,type);
//    GBWImagep->ImageList_UnitN->Draw(Canvasp,Rectp->Left,Rectp->Top,graph);
    FieldScreenp->DrawUnitChipToTCanvas(canvas, Rectp->Left, Rectp->Top, graph, GRAPHDEGREE_N);
    canvas->TextOut(Rectp->Left+40, Rectp->Top+8, BaseDatap->GetUnitChipByType(type).Name);
    return 0;
}
//---------------------------------------------------------------------------
// Ijbg̏\B
__fastcall TForm_seisan::UnitChipPut(int Index)
{
    UnitStatus unit;
    int type;
    char str[32];

    type = ListBox1->Items->Strings[Index].ToIntDef(0);
    const UnitChip& unitInfo = BaseDatap->GetUnitChipByType(type);
    BaseDatap->InitializeUnitStatus(&unit,Side,type);
    FieldScreenp->DrawUnitStatusToTCanvas(Image_Unit->Canvas,Panel1->Brush->Color,0,0,&unit,&unitInfo,false);
    sprintf(str,"i %6d",unitInfo.Value);
    Label_UnitValue->Caption = str;
    Label_Guidance->Caption = unitInfo.GuidanceString.c_str();
    ButtonOK->Enabled = Money>=unitInfo.Value;
    SelectedType = type;
    return 0;
}
//---------------------------------------------------------------------------

void __fastcall TForm_seisan::OnListBox1DblClick(TObject *Sender)
{
    if(ButtonOK->Enabled)
        ButtonOK->Click();
}
//---------------------------------------------------------------------------

void __fastcall TForm_seisan::OnListBox1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    switch(Key){
    case VK_RETURN:  //enter
    case VK_SPACE:   //space
        if(ButtonOK->Enabled)
            ButtonOK->Click();
        break;
    case VK_ESCAPE:  //esc
        if(ButtonAbort->Enabled) //ӖǁB
            ButtonAbort->Click();
        break;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm_seisan::OnFormResize(TObject *Sender)
{
    Width=360;
    if(Height<288)
        Height=288;
    Panel1->Height=Height-59;
    Label_UnitValue->Top = Panel1->Height-25;
    Label_Money->Top=Height-52;
    ButtonOK->Top=Height-52;
    ButtonAbort->Top=Height-52;
}
//---------------------------------------------------------------------------

