//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "status.h"
#include "ksfunc.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm_Status *Form_Status;
//---------------------------------------------------------------------------
__fastcall TForm_Status::TForm_Status(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm_Status::TabControl_SideChange(TObject *Sender)
{
    PutStatus(TabControl_Side->TabIndex);
}
//---------------------------------------------------------------------------
/*__fastcall TForm_Status::SetPointer(MapData *map,FieldScreen *field,
    SideStatus **side,BaseData *base)
{
    Mapp = map;
    FieldScreenp = field;
    BaseDatap = base;
	for(int i=0;i<BaseDatap->Sides;i++)
		SideStatusp[i] = side[i];
	return 0;
}*/
//---------------------------------------------------------------------------
__fastcall TForm_Status::PutStatus(int side)
{
	TCanvas *canvas = Image_SideStatus->Canvas;
	//char *name[2]={"vC[","bot"};
	const BaseData& baseData = GameMaster->GMGetBaseData();
	const MapData& mapData = GameMaster->GMGetMapData();
	const TSideStatusArray& sideStatus = GameMaster->GMGetSideStatus();
	FieldScreen& fieldScreen = GameMaster->GMGetFieldScreen();
	AnsiString str;

	FillCanvas(canvas,clBtnFace);
	fieldScreen.DrawBuildingCount(canvas,side,&baseData,&mapData);

	str.sprintf("@%6d", sideStatus[side].Income);
	canvas->TextOut(8, 112, str);

	str.sprintf("jbg@%6d", sideStatus[side].UnitCount);
	canvas->TextOut(160, 112, str);

	int fy = 136;
	for(int i=0; i<baseData.Sides; ++i){
		if(i != side && sideStatus[side].Friendly[i]){
			str.sprintf("%s Ɠł܂B", baseData.SideName[i].c_str());
			canvas->TextOut(8, fy, str);
			fy += 16;
		}
	}

    return 0;
}
//---------------------------------------------------------------------------

