#ifndef mycsvH
#define mycsvH

#include <stdio.h>
#include <stdlib.h>

#define CSVTABLE_ROWMAX 1024 // ső吔
//#define CSVTABLE_COLMAX 65536 // Z̍ső吔

//---------------------------------------------------------------------------
// CSV̓ǂݍ݂sNXB
// ͍XVEoŝB
class TCSVTable
{
private:
    char *Buffer;
    char *Lines[CSVTABLE_ROWMAX];
    int LineCount;
    int LineLength[CSVTABLE_ROWMAX]; // s̒i'\0'j
//    int CellX[CSVTABLE_COLMAX];
    __fastcall GetNeedByte(FILE *);
    //__fastcall AllocateLine(int);
    __fastcall FreeLines(void);
public:
    TCSVTable(void){
        Initialize();
    }
    ~TCSVTable(void){
        FreeLines();
    }
    __fastcall Initialize(void);
    __fastcall LoadFromFile(const char *);
    __fastcall GetRowByName(const char *name);
    __fastcall GetCellColumnByName(int row,const char *name);
    __fastcall GetCellByKeyRow(int keyrow,const char *key,int row,char *cell,int cellsize);
    __fastcall GetCellByKeyRow(int keyrow,const char *key,int row,int *value);
    __fastcall GetCellByXY(int x,int y,char *cell,int size);
    __fastcall GetCellByXY(int x,int y,int *);
};
//---------------------------------------------------------------------------
#endif
