//---------------------------------------------------------------------------
#ifndef gbwfieldH
#define gbwfieldH
//---------------------------------------------------------------------------
#include <stdlib.h>
//#include <stlport/hash_map>
#include <map>
#include <vector>
#include <list>
#include <string>
#include <algorithm>
using namespace std;
#pragma hdrstop

#define _MBCS
extern "C"{
#include "lua.h"
#include "lualib.h"
#include "lauxlib.h"
}
#include "gbwmail.h"
#include "history.h"
#include "ksoption.h"
#include "../common/table.h"
#include "../common/mycsv.h"
#include "../common/buingl/ABitmap.hpp"
//---------------------------------------------------------------------------
#define UNION1NAME "u[ANAR"
#define UNION2NAME "bht@CAR"
#define UNITMAX     100  //jbgő吔
#define FIGURECOUNT   12 // OtBbN̂PF̐
#define FIGURECOLORMAX 3 // OtBbN̐F
#define GRAPHDEGREE_N 32
#define GRAPHDEGREE_S 16
#define NEIGHBOR_MAX  64 // ߖT̍ő唼a
#define UNITSERIAL_GETA 100000 // jbgVA̔Ԃ̊Jnԍ

#define LOAD_MAX      6 // ő哋ډ\

#define EXPERIENCE_MAX 100 // őol

#define CURSOR_MAX    15 //J[\OtBbN̐
#define CURSOR_MOVE    0 //J[\OtBbNԍ
#define CURSOR_ATTACK  1
#define CURSOR_UP      2 //
#define CURSOR_DOWN    3 //~
#define CURSOR_LOOKUP  4 //jbgʒuQƕ\
#define CURSOR_PLUS    5 //J[\
#define CURSOR_LOAD    6 //ڃ}[N
#define CURSOR_END     7
#define CURSOR_PLUSED  8 //\
#define CURSOR_KILLED  9 //\
#define CURSOR_NULL   10 //̊DFOtBbN
#define CURSOR_HALF   11 //Ԋ|
#define CURSOR_SELECT CURSOR_HALF //Ï̕\
#define CURSOR_CLLSN  12 //Փ˕\
#define CURSOR_DARK   13 //EOɊ|
#define CURSOR_RANGE  14 //U͈͂̕\
#define CURSOR_SUPPLY  15 //gp
#define CURSOR_SUPPLY2 16 //gp

//}bvt@C̃JeSƃL[
#define KEY_MAPNAME      "MapName"
#define KEY_MAPWIDTH     "MapWidth"
#define KEY_MAPHEIGHT    "MapHeight"
#define KEY_UNITFILE     "UnitFile"
#define KEY_SCRIPTFILE   "ScriptFile"
#define KEY_BGIMAGEFILE  "BGImageFile"
#define KEY_BGIMAGEONGAME "BGImageOnGame"
#define KEY_ZOCMODE      "ZOC"
#define KEY_SAKUTEKI     "Sakuteki"
#define KEY_IGNORELIFE   "IgnoreLife"
#define KEY_LEVELUPENABLED "LevelUpEnabled"
#define KEY_PROTECTED    "Protected"

#define SAVEVERNUMBER 200     //o[W͐lŎƂɂ
//Z[ut@C̃JeSƃL[
#define CTG_SAVEPROPERTY "Save Property"
#define KEY_SAVEVERSION  "SaveVersion"
#define CTG_MAPDATA      "Map"

//GameSituationZ[ut@CɋL^JeSƃL[
#define CTG_SITUATION    "Game Situation"
#define KEY_PHASE        "Phase"
#define KEY_TURN         "Turn"
#define KEY_UNITMAX      "UnitMax"
#define KEY_CPUMODE      "CPUMode"
#define CTG_EVENTSCRIPTVAR "Event Script Variable"

//MapStatusZ[ut@CɋL^JeSƃL[
#define CTG_MAPSTATUS    "Gnd"
#define KEY_MS_OWNER     "Owner"
#define KEY_MS_ID        "ID"
#define KEY_MS_LIFE      "Life"

//SideStatusL^JeSƃL[
#define CTG_SIDESTATUS   "SideStatus"
#define KEY_SS_MONEY     "Money"
#define KEY_SS_INCOME    "Income"
#define KEY_SS_ORIGINXY  "OriginXY"
#define KEY_SS_VALID     "Valid"
#define KEY_SS_LOST      "Lost"
#define KEY_SS_FRIENDLY  "Friendly"
#define KEY_SS_LIMITVIEW "LimitView"
#define KEY_SS_ISCOMPUTER "IsComputer"
#define KEY_SS_COMSCRIPTFILE "ComScriptFile"
#define KEY_SS_SERIALMAX "UnitSerialMax"
#define KEY_SS_MAIL      "MailAddress"
#define KEY_SS_PLAYER    "PlayerName"
#define CTG_CPUSCRIPTVAR "CPU Script Variable"

//UnitStatusL^JeSƃL[
#define CTG_UNITSTATUS   "Unit"
#define KEY_US_XY        "XY"
#define KEY_US_ID        "ID"
#define KEY_US_SERIAL    "Serial"
#define KEY_US_LIFE      "Life"
#define KEY_US_FUEL      "Fuel"
#define KEY_US_LEVEL     "Level"
#define KEY_US_EXP       "Experience"
#define KEY_US_LOAD      "Load"
#define KEY_US_GUNREST   "GunRest"
#define KEY_US_ACTIONED  "Actioned"

#define FILE_DEFAULTCSV "default.csv"
#define FILE_DEFAULTBMP "default.png"
#define FILE_SYSTEMBMP  "system.bmp"
#define FILE_DEFAULTLVUP "levelup_default.lua"
#define FILE_HELPINDEX  "Help\\index.html"

#define max(x,y) (x>y ? x:y)
#define min(x,y) (x<y ? x:y)

#define MASKCOLOR (0x00808000)

class SideStatus;
typedef vector<SideStatus> TSideStatusArray;
typedef map<string, string> TStringVariableMap;
//---------------------------------------------------------------------------
// n`̏ԁBt@Cɂ͋L^ꂸAǂݍݎɓIɎ擾B
typedef struct
{
    int ID;         // ʎqB
    bool Create;    // Y\Bij
    int Owner;      // Lwc(-1:)
    int Type;       // n`ԍBij
    int Graphic;    // ŎgpOtBbNԍBij
    int Side;       // ݃jbg̐wci-1:jij
    int UnitIndex;  // ݃jbg̔ԍij
    int Life;       // ϋvx
}MapStatus;
//---------------------------------------------------------------------------
// EêQzɎgpB
template <class ValueType> class TValueLayer
{
private:
    int Width;
    int Height;
    vector<ValueType> Value;
public:
    TValueLayer(int w, int h) : Width(w),Height(h){
        Value.resize(w*h);
    };
    TValueLayer(const TValueLayer& layer) : Width(layer.Width),Height(layer.Height){
        Value.resize(Width*Height);
        Value.assign(layer.Value.begin(), layer.Value.end());
    };
    virtual ~TValueLayer(void){
    };
    void Assign(const TValueLayer& layer) {
        Value.resize(layer.Value.size());
        Value.assign(layer.Value.begin(), layer.Value.end());
        Width = layer.Width;
		Height = layer.Height;
    }
    void Resize(int w, int h) {
        Value.resize(w*h);
        Width = w;
        Height = h;
    }
    int GetWidth(void) const { return Width; }
    int GetHeight(void) const { return Height; }
    ValueType& GetValue(void){
        return Value[0];
    }
    ValueType& GetValue(int x,int y){
        return Value[y*Width + x];
    }
    const ValueType& GetValue(void) const{
        return Value[0];
    }
    const ValueType& GetValue(int x, int y) const{
        return Value[y*Width + x];
    }
    void Init(void){
        Value.assign(Width*Height, 0);
    }
};
//---------------------------------------------------------------------------
// ړEU͈͒pBړpXL̂߂BackoɎĂB
class TRangeLayer
{
private:
    int Width;
    int Height;
    int *RangeValue;
    bool RangeValueIsMine;
    TPoint *Back;
public:
    TRangeLayer(int w,int h) : Width(w),Height(h),RangeValueIsMine(true){
        RangeValue = new int[w*h];
        Back = new TPoint[w*h];
    };
    // Oikslua.cppjnꂽintzRangeValueɎȂ΂ȂƂ邽߁B
    TRangeLayer(int w,int h,int *rp) : Width(w),Height(h),RangeValueIsMine(false){
        RangeValue = rp;
        Back = new TPoint[w*h];
    };
    virtual ~TRangeLayer(void){
        if(RangeValueIsMine){
            delete[] RangeValue;
        }
        delete[] Back;
    };
    int GetWidth(void) const { return Width; }
    int GetHeight(void) const { return Height; }
    int& GetRangeValue(int x,int y){
        return RangeValue[y*Width + x];
    }
    const int& GetRangeValue(int x,int y) const{
		return RangeValue[y*Width + x];
    }
    TPoint& GetBack(int x, int y){
        return Back[y*Width + x];
    }
    const TPoint& GetBack(int x,int y) const{
        return Back[y*Width + x];
    }
    void InitRange(void){
        memset(RangeValue, 0, sizeof(int)*Width*Height);
    }
};
//---------------------------------------------------------------------------
class MapData
{
private:
    TValueLayer<MapStatus> Data;
    // Visible ́A[̎EB
    // Shade ́AʏŉeĂ镔BCOM쎞ShadeVisiblevȂB
    // Visible ̓[AShade ͕`揈ɎgB
    TValueLayer<int> Visible;    //ELp
    TValueLayer<int> Shade;     //eĂ邩
public:
    MapData(int w, int h) : Data(w,h), Visible(w,h), Shade(w,h){
        Initialize();
    }
    bool ZOCMode;    // ZOC
    bool Tekisaku;   // eLTN
    bool IgnoreLife; // _[W
    bool LevelUpEnabled;    // xAbvB
    bool Protected;  // vC[̕ύXsB
    string Name;    // ^Cg
    char UnitDataFile[256]; // {f[^t@C(*.csv)
    char ScriptFile[256];   // XNvgt@C(*.c;*.lua)
    char BGImageFile[256];  // 摜t@C(*.bmp;*.png;*.jpg)
    bool BGImageOnGame;

    __fastcall Initialize(void);
private:
    __fastcall InitData(void);
public:
    // }bvGfB^̃obNAbv蔲̂߉}uB
    void __fastcall Assign(const MapData& m){
        Data.Assign(m.Data);
    };
    void __fastcall Resize(int w, int h);
    __fastcall InitVisible(int);
    __fastcall UpdateShade(void);
    __fastcall HasMapChip(int owner, int id) const;
    __fastcall SearchChipByID(int owner, int id, POINT *plist, int len) const;
    __fastcall CountGround(int *,int) const;
    __fastcall WriteText(TDataTable *) const;
    __fastcall ReadText(TDataTable *);
    // ȉ͎QƂ̂߂̃CC֐B
    __fastcall GetWidth(void) const { return Data.GetWidth(); };
    __fastcall GetHeight(void) const { return Data.GetHeight(); };
    int& __fastcall GetVisible(int x,int y) { return Visible.GetValue(x, y); };
	__fastcall GetVisible(int x,int y) const { return Visible.GetValue(x, y); };
    int& __fastcall GetShade(int x,int y) { return Shade.GetValue(x, y); };
    __fastcall GetShade(int x,int y) const { return Shade.GetValue(x, y); };
    const MapStatus& __fastcall GetMapStatus(int x,int y) const { return Data.GetValue(x, y); };
    MapStatus& __fastcall GetMapStatus(int x,int y){ return Data.GetValue(x, y); };
};
//---------------------------------------------------------------------------
#define GUN_MAX 4
// jbg̏ԁBt@Cɂ͋L^ꂸAǂݍݎɂhcB
class UnitStatus
{
private:
public:
    UnitStatus(void){
    }
    int ID;             // ʎqBL^ɗpB
    int Serial;         // jbǧ̂ʂʂԍB
    int X;              // ݂_W
    int Y;
    int Graphic;        // OtBbNԍij
    int Type;           // ށij
    int Life;
    int Fuel;           // cR
    int Level;          // xB
    int Experience;     // olB
    int Load;           // jbgڐ
    int GunRest[GUN_MAX]; // ce
    int LoadingUnit[LOAD_MAX]; // ڂĂ郆jbg
    bool Actioned;      // sς݂
    __fastcall WriteText(TDataTable *) const;
    __fastcall ReadText(TDataTable *);
};
//---------------------------------------------------------------------------
// ⋋tO萔
#define SUPPLY_FUEL 0x00000001
#define SUPPLY_GUN  0x00000002
#define SUPPLY_LIFE 0x00000004
#define SUPPLY_ALL  0x00000007
// n`̏ŉ\ȍsB
#define GROUND_CAN_LOAD   0x00000001
#define GROUND_CAN_UNLOAD 0x00000002
#define GROUND_CAN_RIDE   0x00000004
#define GROUND_CAN_ALIGHT 0x00000008
#define GROUND_CAN_ALL    0x0000000f
// {݂󂯂x̃tOB
// {݂ƒn`Sꂽ̂ŃtOꏏɂB
#define GROUND_CREATE     0x00000100
#define GROUND_SUPPLY     0x00000200

//jbǧŗLf[^
class UnitChip
{
private:
public:
    UnitChip(void){
    }
    int ID;
	enum UnitType{Army,Navy,Force}ANFType;    // C
    vector<int> GraphicX;   // ewc̃OtBbNWB
    vector<int> GraphicY;
    int MoveMax;            //ړ
    int Value;              //li
    int MinRange[GUN_MAX];  //Œ˒
    int MaxRange[GUN_MAX];  //ő˒
    int Radius[GUN_MAX];    //KwNXa
    int GunMax[GUN_MAX];    //őe
    int GunValue[GUN_MAX];  //ei
    int Loadable;           //ډ\
    int FuelMax;            //őR
    int FuelValue;          //Ri
    int FuelConsume;        //^[ƂɌR
    int Occupy;             // ̔\
    int Repair;             // 񕜔\
    int LevelMax;           // ő僌xB
    string LevelUpAttackFunc;
    string LevelUpDamageFunc;
    string GuidanceString;
    int Visibility;         //E
    int VisionType;         //Ẽg[X^Cvijbg^Cvԍj
    char Name[33];          //jbg̖
    char GunName[GUN_MAX][33];    //eΊ햼
    bool OnlyTekisaku;          //eLTN̂ݓo
    bool SuperMissile;          //X[p[~TC *

    // jbgƂ̊֌WB
    vector<int> Attack[GUN_MAX];        // Ί킲Ƃ̊ejbgɑ΂U
    vector<int> LoadUnit;               // ډ\ȃjbg
    vector<int> SupplyFlag_Neighbor;    // אڕ⋋tO
    vector<int> SupplyFlag_Loading;     // ڕ⋋tO
    // n`Ƃ̊֌WB
    vector<int> MoveLost;           // n`Ƃ̏ړl
    vector<int> GroundFlag;         // ځE퓋ځE~ԁE~ԁE{݃tO
    vector<int> Available;          // ̐wcŗp\B
    __fastcall SetDefault(void);
    __fastcall SetArraySize(int sideCount, int unitTypeCount, int groundTypeCount);
    __fastcall HasMegaHex(void) const;
    __fastcall GetMaxRange(void) const;
};
//---------------------------------------------------------------------------
// n`
typedef struct
{
    int ID;
    vector<int> GraphicX; // OtBbNWB
    vector<int> GraphicY; // 0:ʏ/{ 1~:ewc{
    bool IsBuilding; // {݂B
    bool IsCapital;  // s@\B
    bool SelfCreatable;  // s̎͂łȂƂY\B
    int Shield;     // n`
    int Income;     // 
    int LifeMax;    // őϋvx
    int Visibility; // E
    char Name[33];  // n`
    void __fastcall SetDefault(void){
		IsBuilding = IsCapital = SelfCreatable = false;
        ID = Shield = Income = LifeMax = Visibility = 0;
        Name[0] = '\0';
    };
}MapChip;
//---------------------------------------------------------------------------
class BaseData
{
private:
    lua_State *LuaState_LevelUp; // xAbvLuaԁB
    // jbgCn`ɂ͔z̍Ō"o^ID"ƂÕ_~[ĂB
    vector<UnitChip> UnitInfo;  // jbgŗLB
    vector<int> UnitID;         // jbgIDB\[gς݁B
    vector<MapChip> GroundInfo; // n`B
    vector<int> GroundID;       // n`IDB\[gς݁B
    int DefinedGunMax;          // `ꂽőΊ퐔B
public:
    BaseData(void) : LuaState_LevelUp(NULL){
    }
    __fastcall ~BaseData(void);
    char BitmapFile[256];        // jbg/n`̉摜t@C
    char LevelUpScriptFile[256]; // xAbvXNvgt@CB
    vector<string> SideName;    // wc
    int Sides;                  // wc̐
    int UnitGraphicX,UnitGraphicY;      // jbg摜̊JnʒuB
    int GroundGraphicX,GroundGraphicY;  // n`摜̊JnʒuB
    __fastcall SetDefault(void);
    __fastcall CanCreateUnit(int,int,int,bool) const;
    __fastcall CreatableExists(int,int,bool);
    __fastcall SetLuaStateLevelUp(lua_State *);
    lua_State* __fastcall GetLuaStateLevelUp(void) const { return LuaState_LevelUp; };
    __fastcall LoadFromCSV(const char *);
private:
    __fastcall CSV_GetUnit(TCSVTable *,const int row,const int keyrow);
    __fastcall CSV_StringToSupplyFlag(const char *str) const;
    __fastcall CSV_StringToGroundFlag(const char *str) const;
    __fastcall CSV_GetGun(TCSVTable *,UnitChip *,int index,int row,int keyrow);
    __fastcall CSV_GetGround(TCSVTable *,const int row,const int keyrow);
    __fastcall CSV_GetGraphicXY(TCSVTable *,int,int,int *,int *,char *);
    __fastcall CSV_GetEndOfNumberRow(TCSVTable *table,int row);
    __fastcall CSV_GetBool(TCSVTable *table,int col,int row);
public:
    __fastcall GetUnitTypeCount(void) const {return UnitInfo.size(); };
    __fastcall GetUnitTypeIndex(int id) const;
    const UnitChip& __fastcall BaseData::GetUnitChipByType(int index) const { return UnitInfo[index]; };
    const UnitChip& __fastcall BaseData::GetUnitChipByID(int id) const;
    __fastcall GetGroundTypeCount(void) const {return GroundInfo.size(); };
    __fastcall GetGroundTypeIndex(int id) const;
    const MapChip& __fastcall BaseData::GetMapChipByType(int index) const { return GroundInfo[index]; };
    const MapChip& __fastcall BaseData::GetMapChipByID(int id) const;
//    void __fastcall GetGroundIDList(vector<int>& v) const { v.assign(GroundID.begin(), GroundID.end()); };
    __fastcall ApplyIDToAll(MapData *mapData, TSideStatusArray& sideStatus) const;
    __fastcall GetGroundGraphic(int,int) const;
    __fastcall GetUnitGraphic(int,int) const;
    __fastcall GetUnitGunRange(int,int *,int *);
    __fastcall InitializeMapStatus(MapStatus *,int,int) const;
    __fastcall InitializeUnitStatus(UnitStatus *,int,int) const;
    __fastcall GetDefinedGunMax() const { return DefinedGunMax; }
};
//---------------------------------------------------------------------------
//wc
class SideStatus
{
private:
public:
    SideStatus(void){
        Initialize();
    }
    int UnitCount;           //݂̃jbg
    int Money;               //
    int Income;              //
    int PhaseStartX;         //tFCYJn̗zSW
    int PhaseStartY;
    vector<int> Friendly;    // ewcւ̗FDxB
    int UnitSerialMax;       // ݎgĂ郆jbgVA̓Aő̒lB
    bool Valid;              // 퓬ɎQĂwcB
    bool Lost;               // ɗtOB
    bool LimitView;          // eLTNԂB
    bool IsComputer;         // COMɂ鑀삩B
    char ComScriptFile[64];  // vl[`XNvg̃t@CB
    lua_State *LuaState_Com; // vl[`XNvg̃CX^XB
    HINSTANCE hLib;          // A[h̃nhB
    char MailAddress[128];   // [ΐ펞̓[AhXB
    char PlayerName[64];     // [ΐ펞̓vC[B
    UnitStatus Unit[UNITMAX];  //ejbg
	//hash_map<string,string> CPUScriptVariable_String;    // CPUXNvg̕ϐ}bvB
	TStringVariableMap CPUScriptVariable_String;    // CPUXNvg̕ϐ}bvB
	__fastcall Initialize(void);
	__fastcall EndClear(void);
    __fastcall CalcIncome(const MapData *, const BaseData *, int side);
    __fastcall AddUnit(BaseData *,int,int,int,int);
    __fastcall DeleteUnitBySerial(MapData *mapData, int side, int serial);
    __fastcall DeleteUnit(MapData *,int,int);
    __fastcall MakeDeleteList(int,int [],int);
    __fastcall PressUnit(MapData *,int [],int,int);
    __fastcall LoadUnit(int,int);
    __fastcall DisLife(int,int);
    __fastcall SearchNoActioned(int) const;
    __fastcall GenerateUnitSerial(void);
    __fastcall GetUnitBySerial(int serial) const;
//    UnitStatus& __fastcall GetUnitStatus(int num) { return Unit[num]; };
    const UnitStatus& __fastcall GetUnitStatus(int num) const { return Unit[num]; };
    __fastcall WriteText(TDataTable *, int side);
    __fastcall ReadText(TDataTable *, int side);
};
//---------------------------------------------------------------------------
// Q[isɂċL^ׂԁB
class GameSituation
{
private:
public:
    int Phase;          //݂̃tFCY(=Side)
    int Turn;
    int UnitMax;        //jbg
	// XNvgϐXg
	//hash_map<string,string> EventScriptVariable;
	TStringVariableMap EventScriptVariable;
	GameSituation(void){
		Initialize();
    }
    __fastcall Initialize(void);
    __fastcall WriteText(TDataTable *);
    __fastcall ReadText(TDataTable *);
};
//---------------------------------------------------------------------------
// قȂTCỶ摜`bvzi[摜ǗB
class TABitmapChipSet
{
private:
    TABitmap *ABitmapN, *ABitmapS;
    TRect ClipRect; // `掞̃NbsO`B
public:
    TABitmapChipSet(void) : ABitmapN(new TABitmap()), ABitmapS(new TABitmap()), ClipRect(0,0,INT_MAX,INT_MAX) {};
    ~TABitmapChipSet(void){
        delete ABitmapN;
        delete ABitmapS;
    };
    __fastcall CopyGraphicSet(Graphics::TBitmap *srcbitmap, int srcx, int srcy, int ycount);
    void __fastcall SetClipRect(const TRect& r){ ClipRect = r; };
    __fastcall DrawChipToTBitmap(Graphics::TBitmap *bitmap, int x, int y, int index,int size,TColor maskColor);
    __fastcall DrawChipToTCanvas(TCanvas *canvas,int x,int y,int index,int size);
};
//---------------------------------------------------------------------------
class TKSImageData
{
private:
public:
    TImageList *ImageList_FigureN, *ImageList_FigureS;
    TABitmapChipSet *ChipSetMap, *ChipSetUnit,
                    *ChipSetCursor, *ChipSetCrash;
    // wi摜B
    TABitmap *Bitmap_BGImageN, *Bitmap_BGImageS;
    // }bv`bṽhbgŁB
    TABitmap *Bitmap_MapD;
    TKSImageData(void){
        InitInstance();
    }
    ~TKSImageData(void){
        DeleteInstance();
    }
    __fastcall InitInstance(void);
    __fastcall DeleteInstance(void);
    __fastcall LoadSystemGraphic(const char *);
    __fastcall LoadFromFile(const char *file, int ground_srcx, int ground_srcy, int ground_ycount, int unit_srcx,int unit_srcy,int unit_ycount);
};
//---------------------------------------------------------------------------
class TSimpleScrollBar
{
public:
    bool Visible;
    // ȉ́ASetSize()ňxɌ肳lBPʂ͑SsNZB
    // F{^̗̈͂ꂼTRectUf[^͏璷ɂȂ̂̃R[h͊ȒPɂȂ邩ȂB
    int Left;
    int Top;
    int ScrollTargetLength; // XN[Ώۂ̒B
    int ViewportLength;     // XN[Ώۂ̂AxɌ̈̒B
    int OuterLength;        // XN[o[Ŝ̒B
    int OuterWidth;         // XN[o[Ŝ̕B
    int MinusButtonLength;  // {^̒B
    int PlusButtonLength;   // {^̒B
    int InnerLength;        // XC_ړ̈̒B
    int SliderLength;       // XC_̒B
    // ȉ́AɂĕωԁB
    int SliderMouseDownedPosition;  // XC_Ń}EXꂽWB
    int LargeChangeMouseDownedPosition; // {^ƃXC_̊Ԃ̗̈Ń}EXꂽWB
    bool MinusButtonDowned;
    bool PlusButtonDowned;
    __fastcall SetSize(int left, int top, int fulllen, int vplen, int outlen, int outw, int minuslen, int pluslen);
    __fastcall InitStatus(void);
private:
    __fastcall GetSliderLength(int fulllen, int vplen) const;
public:
    __fastcall GetSliderPosition(int targetPosition) const;
};
//---------------------------------------------------------------------------
class TViewport
{
public:
    TViewport(void) : Valid(false) {
    }
    TSize FullSize;     // Ŝ̑傫B
    TSize OuterSize;    // \̈̑傫iXN[o[܂ށjB
    TSize InnerSize;    // \̈̑傫iXN[o[jB
    TPoint LeftTop;     // ݂̕\̈̍WB
    TSimpleScrollBar RightScrollBar;    // ẼXN[o[B
    TSimpleScrollBar BottomScrollBar;   // ̃XN[o[B
    int ButtonScrollUnit;         // {^ɂXN[PʁB
private:
    bool Valid;
    int TimerCount;     // s[g鑀̊JnA^C}[ʒmꂽ񐔁B
public:
    __fastcall SetSize(int fullw, int fullh, int vpw, int vph);
    __fastcall SetLeftTop(int x, int y);
    __fastcall NoticeMouseDown(int x, int y);
    __fastcall NoticeMouseUp(void);
    __fastcall NoticeMouseMove(int x, int y);
    __fastcall NoticeTimer(void);
};
//---------------------------------------------------------------------------
// }bvɕ\XvCgꖇB
class TSpriteOnMap
{
public:
    int X;
    int Y;
    enum TSpriteType{stMapChip=1, stMapChipDark, stUnitChip, stCursor, stCrash, stDarkRect, stValue}SpriteType;
    int Value;
    int Index;
    int LayerIndex; // \̗DxBl傫ɕ\B
    // \[ĝ߂ɕKvB
    operator < (const TSpriteOnMap& o1) const { return LayerIndex < o1.LayerIndex; };
};
//---------------------------------------------------------------------------
class TPopupMenuOnMap
{
public:
    bool Visible;
    int X;
    int Y;
    int MenuWidth;
    int MenuHeight;
    int MouseMovedIndex;
    int SelectedIndex;
    vector<string> MenuItems;
    vector<int> MenuEnabled;
    vector<int> MenuID;
};
//---------------------------------------------------------------------------
class TMessageRectOnMap
{
public:
    // \̊ƂȂ_WB
    int ZX;
    int ZY;
    int Width;
    int Height;
    int StringHeight;
    vector<string> MessageString;
};
//---------------------------------------------------------------------------
// NߖT\̂ɕKvȗvfB\sum^n_{k=1}(6k) = 3n^2 + 3n B+1 ͒SW̕B
// N=32̎A3169ɂȂB
#define NEIGHBOR_NEED_SIZE(N) (3*(N*N+N)+1)
#define NEIGHBOR_LIST_MAX NEIGHBOR_NEED_SIZE(NEIGHBOR_MAX)
// rbg}bv̊ǗA}bvɖڂWȂǁB
class FieldScreen
{
private:
    TViewport Viewport;
    TRect SelectRect; //`悵Ïi_Wj
    // قȂTCỸOtBbN𓯂R[hňׂ̃|C^B
    TImageList *ImageList_Figure;
    TKSImageData *KSImageData;
    Graphics::TBitmap *Bitmap_Viewport;
    // wNXɂߖT̑΍W\B
    // a n ȓɂwNX̍ẂANeighborX,NeighborY 
    // 납 NeighborIndex[n-1] ̗vfɊi[B
    int NeighborX[2][NEIGHBOR_LIST_MAX],NeighborY[2][NEIGHBOR_LIST_MAX];
    int NeighborIndex[NEIGHBOR_MAX+1];
    TRect NeighborRect[NEIGHBOR_MAX];
    TABitmap *Bitmap;
    TABitmap *Bitmap_TempChip;      // DrawToCanvasn̊֐ňꎞ`ɎgB
    list<TSpriteOnMap> SpriteList;  // n`EjbgE˒\̂ɏɕ\摜B
    vector<TMessageRectOnMap> MessageRectList; // ̂ɏɕ\郁bZ[W`B
    TPopupMenuOnMap PopupMenu;
    static const int FONT_SIZE = 9;
public:
    //MapData::Visible falsȅRange`悵ȂIvV
    bool RangeLimit;
    int GraphDegree;
    enum TRangeType{rtNone=1, rtMoveRange, rtAttackOrLoadRange, rtAttackRange}CurrentRangeType;
    //wNXɂאڍW\萔iUӏjB
    static const int NextDX[2][6],NextDY[6];
    FieldScreen(void);
    ~FieldScreen(void);
    __fastcall MakeNeighborList(void);
    __fastcall GenerateNeighborList(int,int,int,int,int);
    __fastcall GetNeighborIndex(int,int,int,int,int);
    __fastcall GetNeighborRect(void);
    __fastcall GetNeighborList(int,int,int,int,int,int,POINT *,int) const;
    __fastcall GetNeighborList(int cx, int cy, int r1, int r2, int w, int h, vector<POINT>& list) const;
    __fastcall GetNeighborRange(int cx,int cy,int r1,int r2,TRangeLayer *layer) const;
    __fastcall IsNeighbor(int,int,int,int,int) const;
    __fastcall DefineImageList(TKSImageData *,int);
    __fastcall LoadImage(TKSImageData *);
    __fastcall SetViewportSize(const MapData *mapData, int w, int h);
    const TSize& __fastcall GetViewportOuterSize(void) const;
    const TSize& __fastcall GetViewportInnerSize(void) const;
    __fastcall SetViewportLeftTop(int x, int y);
    __fastcall GetViewportLeftTop(int *x, int *y) const;
    __fastcall SlideViewport(int x, int y);
    __fastcall NoticeMouseDownToViewport(int x, int y);
    __fastcall NoticeMouseUpToViewport(void);
    __fastcall NoticeMouseMoveToViewport(int x, int y);
    __fastcall NoticeTimerToViewport(void);
    __fastcall DrawScrollBars(void);
private:
    __fastcall DrawScrollBar(const TSimpleScrollBar& bar, int vppos, bool isVertical);
public:
    __fastcall ClearSpriteList(int layer=-1);
    __fastcall AddSprite(int x, int y, TSpriteOnMap::TSpriteType stype, int index, int value=0, int layer=0);
    __fastcall AddSpriteZ(int zx, int zy, TSpriteOnMap::TSpriteType stype, int index, int value=0, int layer=0);
    __fastcall ClearMessageRectList(void);
    __fastcall AddMessageRect(const TMessageRectOnMap& msgr);
    __fastcall GetMessageRectNeedUpdateRect(TRect *r) const;
    __fastcall ClearPopupMenu(void);
    __fastcall AddPopupMenu(const string& title, int menuID, bool enabled);
    __fastcall ShowPopupMenu(int zx, int zy, TRect *updateRect);
    __fastcall HidePopupMenu(TRect *updateRect);
    __fastcall GetPopupMenuSelectedID(void) const;
    __fastcall DrawMap(MapData *mapData, const TRangeLayer *layer, const UnitStatus *holdUnit, const TSideStatusArray& sideStatus);
    __fastcall DrawMap(MapData *mapData, const TRangeLayer *layer, const UnitStatus *holdUnit, const TSideStatusArray& sideStatus, int x1, int y1, int x2, int y2);
private:
    __fastcall DrawMapChipToTBitmap(Graphics::TBitmap *bitmap,int x,int y,int index,int size);
public:
    __fastcall DrawMapChipToTCanvas(TCanvas *canvas,int x,int y,int index, int size);
private:
    __fastcall DrawMapChip(int,int,int);
    __fastcall DrawMapChipZ(MapData *,int,int);
    __fastcall DrawMapChipShade(int,int,int);
    __fastcall DrawMapChipShadeZ(MapData *,int,int);
    __fastcall DrawMapChipDark(int x,int y,int index);
    __fastcall DrawMapChipDarkZ(int zx,int zy,int index);
    __fastcall DrawDarkRect(int px1, int py1, int px2, int py2);
    __fastcall DrawUnitChipToTBitmap(Graphics::TBitmap *bitmap,int x,int y,int index,int size);
public:
    __fastcall DrawUnitChipToTCanvas(TCanvas *canvas,int x,int y,int index, int size);
private:
    __fastcall DrawUnitChip(int,int,int);
    __fastcall DrawUnitChipZ(int,int,int);
    __fastcall DrawUnitChipAuto(const MapData *,const TSideStatusArray&,int,int,bool);
public:
    __fastcall DrawUnitNormalToCanvas(TCanvas *canvas,int x,int y,int index,bool load,bool actioned);
    __fastcall DrawUnitWithStatus(int,int,int,bool,bool);
private:
    __fastcall DrawCrash(int x, int y, int index);
    __fastcall DrawCursor(int,int,int);
    __fastcall DrawCursorZ(int,int,int);
    __fastcall DrawFigure(int,int,int,int);
    __fastcall DrawValue(int,int,int,int);
    __fastcall DrawValueZ(int,int,int,int);
public:
    __fastcall CopyToTCanvas(TCanvas *canvas);
    __fastcall CopyToTCanvas(TCanvas *canvas, const TRect& srcr);
    __fastcall DrawViewportToTCanvas(TCanvas *canvas , int canvasw, int canvash);
    __fastcall DrawGroundStatusToTCanvas(TCanvas *,TColor,int,int,const MapStatus&,const MapChip *);
    __fastcall DrawUnitStatusToTCanvas(TCanvas *,TColor,int,int,const UnitStatus *,const UnitChip *,bool drawLevel);
    __fastcall DrawLoadingStatus(TCanvas *canvas, TColor backcolor, const UnitStatus& unit, const BaseData& base, const TSideStatusArray& sideStatus, int side, int selected);
    __fastcall DrawBuildingCount(TCanvas *,int,const BaseData *,const MapData *);
    __fastcall RangeToText(char *str,int minr,int maxr,int radius);
    __fastcall DrawGage(TCanvas *,int,int,int,int,int,int,TColor,TColor);
    __fastcall XY_MapToPhy(int,int,int *,int *) const;
    __fastcall XY_PhyToMap(const MapData *,int,int,int *,int *) const;
    __fastcall GetMoveRange(TRangeLayer *layer,const MapData *,const BaseData *,const TSideStatusArray& sideStatus, const UnitStatus *,int,int,int) const;
    __fastcall GetLoadRange(TRangeLayer *layer,const MapData *,const BaseData *,const TSideStatusArray& sideStatus,const UnitStatus *,int,int,int) const;
private:
    __fastcall RangeSearch(TRangeLayer *layer,const MapData *,const BaseData *,const TSideStatusArray& sideStatus,const UnitStatus *,int,int,int,bool) const;
    __fastcall RangeTrace(TRangeLayer *layer, const MapData *map, const BaseData *baseDatap, const TSideStatusArray& sideStatus,int side,int zx,int zy,int unitType,bool isUnload) const;
public:
    __fastcall GetAttackRange(TRangeLayer *,const MapData *,const BaseData *,const UnitStatus *,const TSideStatusArray&,int,int,int,bool) const;
private:
    __fastcall SelectAttackRange(TRangeLayer *layer, const MapData *map, const BaseData *baseDatap, const UnitStatus *unitp, int zx, int zy, int gun, const TSideStatusArray& sideStatus, int side, bool noMove) const;
public:
    __fastcall FindAttackRange(TRangeLayer *layer,const BaseData *baseDatap,const UnitStatus *unitp);
    __fastcall FindSupplyRange(TRangeLayer *layer, const MapData *map, const BaseData *BaseDatap, const SideStatus *Sidep, int side) const;
    __fastcall TraceRangeSimply(TRangeLayer *rangeLayer, const MapData *map, const UnitChip *unitInfop, int zx, int zy);
//    __fastcall FindVisibleAll(MapData *, const BaseData *, const SideStatus *, int side) const;
    __fastcall FindVisibleAll(MapData *, const BaseData *, const TSideStatusArray& , int side) const;
    __fastcall FindVisible(MapData *,int,int,int,int) const;
    __fastcall CirculationEnemy(const MapData *map,const BaseData *baseDatap,const TSideStatusArray& sideStatus,int zx,int zy,int side,int unitType,bool vision) const;
private:
    __fastcall CallLuaFunction(lua_State *L, const char *func, double arg, double *ret) const;
public:
    __fastcall CalcDamage(const MapData *map, const BaseData *baseData, const UnitStatus *attackUnit, const UnitStatus *targetUnit, int *gunType,int gunFlag,bool discrease,bool ignoreLife,bool damageFix) const;
    __fastcall CanCounter(const UnitStatus *attackUnit, const UnitStatus *targetUnit, const UnitChip& targetInfo) const;
private:
    __fastcall SelectGun(const UnitStatus& unit, const UnitChip& unitInfo, int targetType, int flag, bool isZOC=false) const;
public:
    __fastcall GetCircleRect(TRect *rect,int cx,int cy,int radius,int w,int h);
    __fastcall GetDrawRect(const TRangeLayer *layer,TRect *r);
    __fastcall GetOrRect(TRect *,int,int,int,int);
};
//---------------------------------------------------------------------------
// kslua.cpp ₻̑_CAOĂяo֐̃C^[tF[XB
class TKSGameMaster
{
public:
    virtual void GMSetCPUOperationMode(void) = 0;      // CPU샂[hɂB
    virtual void GMSetEventOperationMode(void) = 0;    // Cxg[hɂB
    // vl[`ECxgpBꕔ͎vl[`pB
    virtual const BaseData& GMGetBaseData(void) const = 0;
    virtual const MapData& GMGetMapData(void) const = 0;
    virtual const GameSituation& GMGetGameSituation(void) const = 0;
    virtual const TSideStatusArray& GMGetSideStatus(void) const = 0;
    virtual FieldScreen& GMGetFieldScreen(void) = 0;
    virtual int GMGetFilePath(char *path, const char *fileName) = 0;
    virtual void GMGetSystemLuaPath(char *path) = 0;
    virtual int GMGetNextXYLayer(int *array_x, int *array_y) = 0;
//    virtual int GMGetNeighborXYLayer(int x, int y, int r1, int r2, POINT *plist, int array_size) = 0;
    virtual int GMGetNeighborXYLayer(int x, int y, int r1, int r2, vector<POINT>& plist) = 0;
    virtual int GMIsNeighbor(int x1, int y1, int x2, int y2, int r) = 0;
    virtual int GMGetCurrentSide(void) = 0;
    virtual int GMGetCreatableUnitList(int x,int y,int side,int *idlist) = 0;
    virtual int GMGetMoveDistanceLayer(int x,int y,int utype,int dist,int *layer) = 0;
    virtual int GMGetMovableRangeLayer(int side,int serial,int *layer) = 0;
    virtual int GMMoveAndAttack(int side,int serial,int x,int y,int gun_index,int tx,int ty,bool exec, POINT *plist, int *damagelist, int listmax) = 0;
    virtual int GMMoveAndUnload(int side,int serial,int x,int y,const int *loadlist,const POINT *plist,int loadcount,bool exec,bool *successlist) = 0;
    virtual int GMCanCreateUnit(int x,int y,int utype) = 0;
    virtual int GMCreateUnit(int x,int y,int utype) = 0;
    virtual void GMPutCPUScriptVariable(int side, const string& key, const string& value) = 0;
    virtual string GMGetCPUScriptVariable(int side, const string& key) = 0;
    virtual void GMRemoveCPUScriptVariable(int side, const string& key) = 0;
    virtual void GMPutEventScriptVariable(const string& key, const string& value) = 0;
    virtual string GMGetEventScriptVariable(const string& key) = 0;
    virtual void GMRemoveEventScriptVariable(const string& key) = 0;
    // ȉ̓CxgpB
    virtual int GMSetSideRelation(int side1, int side2, int friendly) = 0;
    virtual int GMAppendUnit(int x, int y, int side, int id) = 0;
    virtual int GMRemoveUnit(int x, int y) = 0;
    virtual int GMSetGroundStatus(int x, int y, int id, int life) = 0;
    virtual int GMSetSideStatus(int side, int money, int income) = 0;
    virtual int GMSetUnitStatus(int side, int serial, const UnitStatus& unit) = 0;
};
//---------------------------------------------------------------------------
__fastcall KS_LoadFromImgctl(Graphics::TBitmap *bmp, const char *file);
__fastcall KS_ResizeSideStatusArray(TSideStatusArray& sideStatus, int size);
__fastcall GBW_LoadBaseData(const char *file,BaseData *baseData,TKSOption *option, bool isGame);
__fastcall GBW_LoadSystemGraphic(TKSImageData *,TKSOption *);
__fastcall GBW_LoadBaseAll(const MapData *mapData, TKSImageData *GBWImage, BaseData *baseData, TKSOption *option, bool isGame);
__fastcall GBW_SaveGame(const char *file, const MapData *, GameSituation *, TSideStatusArray&, const BaseData *);
__fastcall GBW_LoadGame(const char *file, MapData **, GameSituation *, TSideStatusArray&,BaseData *,TKSOption *,TKSImageData *,bool isGame);
__fastcall GBW_PlaceUnitsToMap(MapData *,TSideStatusArray& sideStatus,int sideMax);
//---------------------------------------------------------------------------
#endif
