//---------------------------------------------------------------------------
#ifndef ksdrawhdcH
#define ksdrawhdcH
//---------------------------------------------------------------------------
#include <windows.h>
#define IMGCTL_RUNTIME
#include "../common/imgctl/imgctl.h"

void KSDrawHDC_Init(void);
void KSDrawHDC_End(void);
BOOL GetDIB(HDIBC hDIB, LPBITMAPINFO pbmi, DWORD *pdwbmiSize, LPVOID pvData, DWORD *pdwDataSize);
HDIB ToDIB(const char *path);
BOOL DeleteDIB(HDIB hDIB);
BOOL PasteDIB(
    HDIB hDIBDest, long lXDest, long lYDest, long lWidth, long lHeight,
    HDIBC hDIBSrc, long lXSrc, long lYSrc, PASTEPROC pfnPasteProc,
    LPARAM lParam);
BOOL DIBtoDC(
      HDC hdc, int nXDest, int nYDest, int nWidth, int nHeight,
      HDIBC hDIB, int nXSrc, int nYSrc, DWORD dwRop);
BOOL DIBto24Bit(HDIB hDIB);
HDIB PNGtoDIB(const char *file);
HDIB JPGtoDIB(const char *file);
void FillRectRGBA(LPDWORD lpdwPixel, int width, int height, int x1, int y1, int x2, int y2, COLORREF color, int alpha);
void FrameRectRGBA(LPDWORD lpdwPixel, int width, int height, int x1, int y1, int x2, int y2, COLORREF color, int alpha);
void DrawRectangle(HDC hdc, int x1, int y1, int x2, int y2, COLORREF lineColor, COLORREF inColor);
void DrawString(HDC hdc, int x, int y, LPCSTR str, COLORREF charColor);
void DrawString(HDC hdc, int x, int y, LPCSTR str, COLORREF charColor, int fontheight);

#endif
//---------------------------------------------------------------------------
