//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "unitlist.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm_UnitList *Form_UnitList;
//---------------------------------------------------------------------------
__fastcall TForm_UnitList::TForm_UnitList(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
/*__fastcall TForm_UnitList::Initialize(TForm1 *f,BaseData *base,FieldScreen *fs,GBWImageData *gbwi){
    Form1p = f;
    BaseDatap = base;
    FieldScreen1 = fs;
    GBWImageDatap = gbwi;
    return 0;
}*/
//---------------------------------------------------------------------------
//IWiseisan.cppB
void __fastcall TForm_UnitList::OnListBox1DrawItem(TWinControl *Control,
      int Index, TRect &Rect, TOwnerDrawState State)
{
    TRect Rect1;

    ListBox1->Canvas->Brush->Color=clWindow;
    ListBox1->Canvas->Font->Color=clBlack;
    if(ListBox1->Selected[Index]){
        if(OldIndex!=-1){   //OIĂACeĕ`
            if(OldIndex==Index && OldIndex<ListBox1->Items->Count-1)
                OldIndex++;   //̏ɂďXN[̕`sBs
            Rect1=Rect;
            Rect1.Top+=(OldIndex-Index)*ListBox1->ItemHeight;
            Rect1.Bottom=Rect1.Top+ListBox1->ItemHeight;
            ListBox1->Canvas->FillRect(Rect1);
            ListUnitPut(ListBox1->Canvas,&Rect1,OldIndex);
        }
        OldIndex=Index;
        ListBox1->Canvas->Brush->Color=clActiveCaption;
        ListBox1->Canvas->Font->Color=clWhite;
        UpdateUnitStatus(Index);
    }
    ListBox1->Canvas->FillRect(Rect);
    ListUnitPut(ListBox1->Canvas,&Rect,Index);
}
//---------------------------------------------------------------------------
//Xg{bNX̃jbgĕ`
__fastcall TForm_UnitList::ListUnitRevise(int Index)
{
    TRect Rect1;

    ListBox1->Canvas->Brush->Color=clWindow;
    ListBox1->Canvas->Font->Color=clBlack;
    if(Index==UnitIndex){
        ListBox1->Canvas->Brush->Color=clActiveCaption;
        ListBox1->Canvas->Font->Color=clWhite;
        UpdateUnitStatus(Index); //IĂ΍ĕ`
    }
    if(Index<ListBox1->TopIndex || Index>ListBox1->TopIndex+ListBox1->Height/ListBox1->ItemHeight)
        return 0;  //\̈̊OȂ牽Ȃ
    Rect1.Top=(Index-ListBox1->TopIndex)*ListBox1->ItemHeight;
    Rect1.Bottom=Rect1.Top+ListBox1->ItemHeight;
    Rect1.Left=0;
    Rect1.Right=ListBox1->Width;
    ListBox1->Canvas->FillRect(Rect1);
    ListUnitPut(ListBox1->Canvas,&Rect1,Index);

    return 0;
}
//---------------------------------------------------------------------------
//Xg{bNX̃jbg`
__fastcall TForm_UnitList::ListUnitPut(TCanvas *canvas,TRect *r,int index)
{
    char str[20];
    const BaseData& baseData = GameMaster->GMGetBaseData();
    const TSideStatusArray& sideStatus = GameMaster->GMGetSideStatus();
    FieldScreen& fieldScreen = GameMaster->GMGetFieldScreen();
    int side = GameMaster->GMGetCurrentSide();

    const UnitStatus *unitp = &sideStatus[side].Unit[index];
    const UnitChip& unitInfo = baseData.GetUnitChipByType(unitp->Type);

    fieldScreen.DrawUnitNormalToCanvas(canvas,r->Left,r->Top,unitp->Graphic,unitp->Load,unitp->Actioned);
    canvas->TextOut(r->Left+40,r->Top+6,unitInfo.Name);
    sprintf(str,"Life %3d",unitp->Life);
    canvas->TextOut(r->Left+40,r->Top+18,str);
    return 0;
}
//---------------------------------------------------------------------------
//Iꂽjbg\
__fastcall TForm_UnitList::UpdateUnitStatus(int index)
{
    const BaseData& baseData = GameMaster->GMGetBaseData();
    const TSideStatusArray& sideStatus = GameMaster->GMGetSideStatus();
    FieldScreen& fieldScreen = GameMaster->GMGetFieldScreen();
    int side = GameMaster->GMGetCurrentSide();

    const UnitStatus *unitp = &sideStatus[side].Unit[index];
    const UnitChip *unitInfop = &baseData.GetUnitChipByType(unitp->Type);

    UnitIndex = index;
    fieldScreen.DrawUnitStatusToTCanvas(Image_UnitStatus->Canvas,Panel1->Brush->Color,0,0,unitp,unitInfop,true);
    ButtonOK->Enabled=true;
    return 0;
}
//---------------------------------------------------------------------------
//Xg{bNXւ̃ACe̓o^
__fastcall TForm_UnitList::MakeList(void)
{
    char str[10];
    const TSideStatusArray& sideStatus = GameMaster->GMGetSideStatus();
    int side = GameMaster->GMGetCurrentSide();

    Image_UnitStatus->Canvas->Brush->Color=clWindow;
    Image_UnitStatus->Canvas->FillRect(Image_UnitStatus->ClientRect);
    ButtonOK->Enabled=false;
    ListBox1->Clear();
    for(int i=0;i<sideStatus[side].UnitCount;i++){
        itoa(i,str,10);
        ListBox1->Items->Add(AnsiString(str));
    }
    UnitIndex=-1;
    OldIndex=-1;
    Result=false;
    return 0;
}
//---------------------------------------------------------------------------
//샆jbgiォ牺ցj
void __fastcall TForm_UnitList::ButtonNextClick(TObject *Sender)
{
    const TSideStatusArray& sideStatus = GameMaster->GMGetSideStatus();
    int side = GameMaster->GMGetCurrentSide();
    int i;

    i=sideStatus[side].SearchNoActioned(UnitIndex+1);
    if(i!=-1)
        ListBox1->ItemIndex=i;
}
//---------------------------------------------------------------------------

void __fastcall TForm_UnitList::ButtonOKClick(TObject *Sender)
{
    if(NoModal)
        Form1p->ShowLookup(UnitIndex);
    else{
        Result=true;
        Close();
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm_UnitList::ButtonCancelClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm_UnitList::OnFormResize(TObject *Sender)
{
    Width=360;
    Panel1->Height=Height-59;
    ButtonNext->Top=Height-52;
    ButtonOK->Top=Height-52;
    ButtonCancel->Top=Height-52;
}
//---------------------------------------------------------------------------

