//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <string.h>

#include "unitview.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm_ViewUnit *Form_ViewUnit;
//---------------------------------------------------------------------------
__fastcall TForm_ViewUnit::TForm_ViewUnit(TComponent* Owner)
    : TForm(Owner)
{
    BaseDataTmp = new BaseData();
    GBWImageTmp = new GBWImageData();
    OtherFile = false;
}
//---------------------------------------------------------------------------
__fastcall TForm_ViewUnit::~TForm_ViewUnit(void)
{
    delete BaseDataTmp;
    delete GBWImageTmp;
}
//---------------------------------------------------------------------------
void __fastcall TForm_ViewUnit::Edit_UnitChange(TObject *Sender)
{
    Selected = UpDown_Unit->Position;
    if(OtherFile){
        GBWImagep->ImageList_CursorN->Draw(Image_Unit->Canvas,0,0,CURSOR_NULL);
        GBWImageTmp->ImageList_UnitN->Draw(Image_Unit->Canvas,0,0,Selected);
    }
    else{
        GBWImagep->DrawUnitCanvas(Image_Unit->Canvas,Selected);
    }
    Image_Unit->Refresh();
    Label_UnitName->Caption = BaseDataTmp->UnitInfo[Selected].Name;
}
//---------------------------------------------------------------------------
//pXQƏ
void __fastcall TForm_ViewUnit::Button_BrowseClick(TObject *Sender)
{
    PathBrowser browser;
    char str[256];

    strcpy(str,Edit_Path->Text.c_str());
    if(browser.Execute(this,"GBWƯ̧ (*.csv)|*.csv","csv",str)){
        Edit_Path->Text = str;
        ReadFromOtherFile();
    }
}
//---------------------------------------------------------------------------
//̃t@CꎞIɓǂ
__fastcall TForm_ViewUnit::ReadFromOtherFile(void)
{
    char grpfile[256];
    int i;

    if(Edit_Path->Text == "")
        return 0;
    //ǂݍ݂ɎsҏW̃f[^Rs[
    if(BaseDataTmp->LoadFromCSV(Edit_Path->Text.c_str()) == -1){
        *BaseDataTmp = *BaseDatap;
        return 0;
    }
    //jbgt@C̓ǂݍ݂ɐ
    //OtBbNt@Cw肳ĂΓǂݍ
    if(BaseDataTmp->BitmapFile[0] != '\0'){
        strcpy(grpfile,Edit_Path->Text.c_str());
        i = strlen(grpfile);
        while(i>=0 && grpfile[i]!= '\\')
            i--;
        grpfile[i+1] = '\0';
        strcat(grpfile,BaseDataTmp->BitmapFile);
        //摜t@Cǂݍ߂΂g
        if(!GBW_LoadGraphic(GBWImageTmp,BaseDataTmp));
            OtherFile = true;
    }
    else
        OtherFile = true;
    return 0;
}
//---------------------------------------------------------------------------

